unit cminit;

interface

uses defs, general, menus, dirscan, crt, dos, slmenu, filedef, strings, sldata, cfgdef,
	slenter, data, strznnp, users, sublist, putils;

procedure setup_cfg;


implementation

type
	TreeRootType = record
		a, listroot, c, treeroot, d,
		entries							: longint;
		e								: byte;
	end;

	TreeLeafType = record
		status			: byte;
		left, right	    : longint;
		last, next		: longint;
	end;



procedure uabort;
begin
	heading('User Abort');
	writeln(#13#10#10'CatMail setup aborted at user''s request.');
	halt(43);
end;


procedure add_pw_file(fn : string; tipe : o_pw);
var
  gptr 	: file;
  n	: byte;
  pwf	: _password;
begin
	assign(gptr, fromnts(@cfg.cmpath)+'PASSWORD.CM');
	{$I-} reset(gptr, 1); {$I+}
	if ioresult <> 0 then
		rewrite(gptr, 1)
	else
		seek(gptr, filesize(gptr));

	n := 1;
	fillchar(pwf, sizeof(pwf), 0);
	tonts(fn, pwf.pw);
	pwf.tipe := tipe;
	blockwrite(gptr, pwf, sizeof(pwf));
	close(gptr);
end;

procedure add_domain(z : word; s : string);
var
	fptr : file;
	bink : _bink;
begin
	assign(fptr, fromnts(@cfg.cmpath)+'DOMAIN.CM');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
		rewrite(fptr, 1)
	else
		seek(fptr, filesize(fptr));

	fillchar(bink, sizeof(bink), 0);
	bink.zone := z;
	tonts(s, bink.domain);
	blockwrite(fptr, bink, sizeof(bink));
	close(fptr);
end;

procedure read_text_cfg(fn : string);
type
	_binkr = record
		ld : string[30];
		sd : string[10];
	end;

var
  fptr 	: text;
  kw	: string[80];
  s     : string;
  z 	: znnp;
  alpw  : boolean;
  binkr : array [1..15] of ^_binkr;
  nbinkr: byte;
  r, lp, n : word;

begin
	alpw := false;
	nbinkr := 0;

	assign(fptr, fn);
	{$i-} reset(fptr); {$I+}
	if ioresult <> 0 then exit;

	while not eof(fptr) do
	begin
		readln(fptr, s);
		kw := aword(s, 1);
		kw := ups(kw);

		if (kw = 'ADDRESS') or (kw = 'AKA') then
		begin
			strtoznnp(aword(s, 2), z);
			n := 15;
			for lp := 0 to 14 do
			begin
				if (cfg.address[lp].zone = 0) and (n = 15) then
					n := lp;

				if (cfg.address[lp].zone = z.zone) and
				   (cfg.address[lp].net = z.net) and
				   (cfg.address[lp].node = z.node) and
				   (cfg.address[lp].point = z.point) then
					n := 16;
			end;

			if (n < 15) then
			begin
				with cfg.address[n] do
				begin
					zone := z.zone;
					net := z.net;
					node := z.node;
					point := z.point;
				end;
			end;
		end;

		if (kw = 'DOMAIN') and (nbinkr < 15) then
		begin
			inc(nbinkr);
			getmem(binkr[nbinkr], sizeof(_binkr));
			binkr[nbinkr]^.ld := ups(aword(s, 2));
			binkr[nbinkr]^.sd := ups(aword(s, 3));
		end;

		if (kw = 'DOMAINKLUDGE') then
		begin
			kw := ups(aword(s, 3));
			for lp := 1 to nbinkr do
			begin
				if kw = binkr[lp]^.ld then
				begin
					val(aword(s, 2), n, r);
					add_domain(n, binkr[lp]^.sd);
					lp := nbinkr;
				end;
			end;
		end;

		if kw = 'NETMAIL' then
			tonts(ups(addslash(aword(s, 2))), cfg.netpath);

		if kw = 'NETFILE' then
			tonts(ups(addslash(aword(s, 2))), cfg.filespath);

		if kw = 'SYSOP' then
			tonts(aword(s, 2)+' '+aword(s, 3), cfg.sysop);

		if kw = 'HOLD' then
			tonts(ups(addslash(aword(s, 2))), cfg.binkpath);

		if kw = 'PACK' then
			{ something here!!!!!!!!!!!!!!!!!!!!!!!! }

		if (kw = 'PASSWORD') and (alpw = false) then
		begin
			alpw := true;
			add_pw_file(fn, pw_squish);
		end;

		if (kw = 'USERNAME') and (cfg.sysop[0] = #0) then
			tonts(copy(s, length(kw)+1, 25), cfg.sysop);

		if (copy(kw, 1, 5) = 'SPOOL') then
			tonts(ups(addslash(aword(s, 2))), icfg.spool);
	end;

	close(fptr);

	for lp := 1 to nbinkr do
		freemem(binkr[lp], sizeof(_binkr));
end;




function get_aliasf(s : string; exp : boolean) : boolean;
type
	aliasfilet = record
		tlt			: TreeLeafType;
		inet		: string[80];
		slname		: string[80];
		typ			: byte;
		junk2		: array [180..255] of byte;
	end;

var
	fptr	: file;
	aliasf	: file;
	trt		: treeroottype;
	aft		: aliasfilet;
	na		: TNameAlias;

  procedure Process;
  begin
	if not exp then
	begin
		seek(aliasf, 0);
		while not eof(aliasf) do
		begin
			blockread(aliasf, na, sizeof(na));
			if fromnts(@na.inetname) = aft.inet then
				exit;
		end;
	end
	else
		seek(aliasf, filesize(aliasf));

	fillchar(na, sizeof(na), 0);

	if not exp then
	begin
		tonts(aft.inet, na.inetname);
		tonts(aft.slname, na.user);
	end
	else
	begin
		tonts(aft.slname, na.inetname);
		tonts(aft.inet, na.user);
	end;

	if aft.typ = 1 then
		na.atype := A_MailList
	else if exp then
		na.atype := A_InOut
	else
		na.atype := A_Inbound;

	blockwrite(aliasf, na, sizeof(na));
  end;

  procedure DoIt(n : longint);
  begin
	seek(fptr, $10C+(n-1)*256);
	blockread(fptr, aft, sizeof(aft));

	if aft.tlt.left > 0 then
	begin
		DoIt(aft.tlt.left);
		seek(fptr, $10C+(n-1)*256);
		blockread(fptr, aft, sizeof(aft));
	end;

	Process;

	if aft.tlt.right > 0 then
		DoIt(aft.tlt.right);
  end;

begin
	get_aliasf := false;

	assign(fptr, s);
	{$i-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
	begin
		writeln('Unable to open file.');
		exit;
	end;

	assign(aliasf, 'ALIAS.CM');
	{$i-} reset(aliasf, 1); {$I+}
	if ioresult <> 0 then
		rewrite(aliasf, 1);

	blockread(fptr, trt, sizeof(trt));

	if trt.treeroot > 0 then DoIt(trt.treeroot);

	close(aliasf);
	close(fptr);

	get_aliasf := true;
end;



procedure eval_progs;
var
   fptr : file;
   lastwhite : boolean;
   regs	: registers;
   done_mailer	: boolean;


procedure ch_cl;
begin
	if lastwhite = true then
	begin
		textcolor(lightgray);
		lastwhite := false;
	end
	else
	begin
		textcolor(white);
		lastwhite := true;
	end;
end;

var b : byte;

begin
	filemode := 66;
	done_mailer := false;
	lastwhite := false;
	heading('Evaluation and AutoSetup');
	textcolor(cf.colorchart[NORMAL]);

	writeln(#10'The following programs were found on your hard drive(s):');

	if found.squish = true then
	begin
		ch_cl;
		write('      Squish mail processor in ',found.squishp,'.  ');
		read_text_cfg(found.squishp+'\SQUISH.CFG');

		writeln('SQUISH.CFG imported.');
	end;

	if found.golded = true then
	begin
		ch_cl;
		write('      GoldED mail editor in ',found.goldedp,'.  ');
		read_text_cfg(found.goldedp+'\GOLDED.CFG');

		writeln('GOLDED.CFG imported.');
	end;

	if found.fd = true then
	begin
		ch_cl;
		write('      FrontDoor front end mailer in ',found.fdp,'.  ');

		if done_mailer = false then
		begin
			assign(fptr, found.fdp+'\SETUP.FD');
			{$I-}reset(fptr, 1);{$I+}
			if ioresult = 0 then
			begin
				seek(fptr, $2505);
				blockread(fptr, cfg.netpath, 44);
				strcpy(cfg.arcnetpath, cfg.netpath);
				cfg.mailertype := FrontDoor;
				add_pw_file(found.fdp+'\PASSWORD.FD', pw_frontdoor);
				tonts(found.fdp+'\FDRESCAN.NOW', cfg.rescanfile);

				seek(fptr, $2621);
				blockread(fptr, cfg.filespath, 44);
				seek(fptr, $2755);
				blockread(fptr, cfg.sysop, 24);
				seek(fptr, $26f8);
				blockread(fptr, cfg.address[0], sizeof(znnp)*11);
				close(fptr);
				done_mailer := true;
			end
			else found.fd := false;

			writeln('SETUP.FD imported.');
		end
		else
			writeln('Ignored.');
	end;

	if found.bink = true then
	begin
		ch_cl;
		write('      BinkleyTerm front end mailer in ',found.binkp,'.  ');
		if done_mailer = false then
		begin
			read_text_cfg(found.binkp+'\BINKLEY.CFG');
			done_mailer := true;
			writeln('BINKLEY.CFG imported.');
			cfg.mailertype := Binkley;
		end
		else
			writeln('Ignored.');
	end;

	if found.db = true then
	begin
		ch_cl;
		write('      D''Bridge front end mailer in ',found.dbp,'.  ');
		if done_mailer = false then
		begin
			read_text_cfg(found.dbp+'\DBRIDGE.CFG');
			done_mailer := true;
			writeln('DBRIDGE.CFG imported.');
			cfg.mailertype := DBridge;
		end
		else
			writeln('Ignored.');
	end;

	if found.uumail = true then
	begin
		ch_cl;
		write('      UUMail found in ',found.uumailp,'.  ');
		assign(fptr, found.uumailp+'\UCONFIG.SL2');
		{$i-} reset(fptr, 1); {$I+}
		if ioresult = 0 then
		begin
			blockread(fptr, b, 1);
			blockread(fptr, icfg.address, b);
			strcpy(icfg.returnaddr, icfg.address);

			seek(fptr, $229);
			blockread(fptr, b, 1);
			blockread(fptr, icfg.uucpname, b);
			icfg.enabled := true;
			writeln('UCONFIG.SL2 imported.');
		end
		else
			writeln('Can''t import.');
	end;

	if found.uucico = true then
	begin
		ch_cl;
		write('      UUCICO found in ',found.uucicop,'.  ');
		read_text_cfg(found.uucicop+'\UUCICO.CFG');
		writeln('UUCICO.CFG imported.');
	end;

	if found.outalias = true then
	begin
		ch_cl;
		write('      OUTALIAS.SL2 found in ',found.outaliasp,'.  ');
		if get_aliasf(found.outaliasp+'\OUTALIAS.SL2', true) then
			writeln('Imported.');
	end;

	if found.inalias = true then
	begin
		ch_cl;
		write('      INALIAS.SL2 found in ',found.inaliasp,'.  ');
		if get_aliasf(found.inaliasp+'\INALIAS.SL2', false) then
			writeln('Imported.');
	end;


	regs.ax := $d44d;
	regs.bh := 0;
	intr($2f, regs);
	if (regs.ax = $44dd) then
	begin
		ch_cl;
		writeln('      4DOS v',regs.bl,'.',regs.bh,' found resident in memory.  4DOS support added.');
		cfg.usecomfile := 1;
	end;
end;



procedure default(ch : char);
var s : string;
    lp : integer;
    p : setupptr;
    fptr : file;
	o : _origin;
	a : _archive;
	pp : _pack;

	ac : _areacfg;
	al : _arealink;

begin
	getdir(0, s);
	s := s + '\';

	tonts(s, cfg.cmpath);
	tonts(s+'PACK\', cfg.packpath);
	tonts(s+'WORK\', cfg.workpath);
	tonts(s+'DUPE\', cfg.dupepath);
    tonts('DESCRIPT.ION', cfg.comfile);
	tonts(s+'CM.LOG', cfg.logfile);
	tonts(s+'INET.LOG', cfg.inetlogfile);
	tonts(s+'TRANSX.LOG', cfg.transxlogfile);

	move(cfg_cm_id, cfg.id, 6);

	with cfg do
	begin
		killblank := 1;
		quotecolour := yellow;
        tearcolour := lightred;
        origincolour := green;
		tagcolour := brown;
		ihdrcolour := darkgray;
        stripcolour := 1;
		quiet := 1;
        cmfixsecure := 1;
        secureimport := 1;
        retries := 2;
		msgbufsize := 32000;
		msgcachesize := 20000;
		wrapline := 76;
		loglevel := Average;
		swapto := 255;
		quiet := 1;
		uudecode := decodedelete;
		localnetimp := 1;
		pidtype := 1;
		fa_net := FileAttach;
		fa_echo := UUEncode;
		fa_use := UUEncode;
		fl_net := 257;
		fl_netf := 273;
		dupeaction := d_rename;
		sentaction := sa_Kill;
		enable_cmfix := 1;
		fidoenabled := true;

		for lp := 0 to 9 do
			rep[lp] := 1;

	  case ch of
		'S':
		begin
			thread := 0;
			colour := 1;
			dupecheck := 20;
		end;
		'N':
		begin
			dupeaction := d_ignore;
			thread := 0;
			colour := 0;
			dupecheck := 0;
		end;
		else
		begin
			thread := 1;
			colour := 1;
			dupecheck := 200;
		end;
	  end;
	end;


	if (access(s+'ORIGIN.CM') = false) then
	begin
		assign(fptr, s+'ORIGIN.CM');
		rewrite(fptr, 1);
		fillchar(o, sizeof(o), 0);
		tonts('Default CatMail Origin Line', o.line);
		blockwrite(fptr, o, sizeof(o));
		close(fptr);
	end;

	if (access(s+'ARCHIVE.CM') = false) then
	begin
		assign(fptr, s+'ARCHIVE.CM');
		rewrite(fptr, 1);
		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('PKArc', name); tonts('1A', IdString); tonts('pkpak -oct %a %f', CmdAdd); tonts('pkunpak %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('PKPak', name); IdLocation := -2; tonts('FE', IdString);
				tonts('pak a %a %f', CmdAdd); tonts('pak e /wn %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('PKZip v2.04g', name); tonts('504B030414', IdString);
				tonts('pkzip -a %a %f', CmdAdd); tonts('pkunzip -n %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		with a do
		begin
			tonts('PKZip v1.10', name); tonts('504B03040A', IdString);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('LHA v1.13', name); IdLocation := 2; tonts('2D6C68', IdString);
			tonts('lha a /o /m %a %f', CmdAdd); tonts('lha e /m %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		with a do
		begin
			tonts('LHA v2.13', name); tonts('lha a /m %a %f', CmdAdd);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('ZOO', name); tonts('5A4F4F', IdString);
			tonts('zoo a: %a %f', CmdAdd); tonts('zoo e:O %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('ARJ', name); tonts('60EA', IdString);
			tonts('arj a -e- %a %f', CmdAdd); tonts('arj e -n %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('RAR', name); tonts('526172211A07', IdString);
			tonts('rar a %a %f', CmdAdd);  tonts('rar e %a %f', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		fillchar(a, sizeof(a), 0);
		with a do
		begin
			tonts('comp430d', name); tonts('1F9D8C', IdString);
			tonts('comp430d.exe -d -f %a', CmdExtract);
		end;
		blockwrite(fptr, a, sizeof(a));

		close(fptr);
	end;

	if (access(s+'PACK.CM') = false) then
	begin
		assign(fptr, s+'PACK.CM');
		rewrite(fptr, 1);
		fillchar(pp, sizeof(pp), 0);
		with pp.z do
		begin
			zone := 65535; net := 65535; node := 65535; point := 65535;
		end;
		tonts('PKZIP V2.04G', pp.name);
		blockwrite(fptr, pp, sizeof(pp));
		close(fptr);
	end;

	if (access(s+'AREA.CM') = false) then
	begin
		assign(fptr, s+'AREA.CM');
		rewrite(fptr, 1);
		fillchar(ac, sizeof(ac), 0);
		blockwrite(fptr, ac, sizeof(ac));
		close(fptr);
	end;

	if (access(s+'AREALINK.CM') = false) then
	begin
		assign(fptr, s+'AREALINK.CM');
		rewrite(fptr, 1);
		fillchar(al, sizeof(al), 0);
		blockwrite(fptr, al, sizeof(al));
		close(fptr);
	end;
end;

procedure eval_sysop;
var u : usertype;
    upos : longint;
begin
	if openuserfile then
	begin
		usearch('SYSOP', u, upos);
		if upos = 0 then
		begin
			closeuserfile;
			exit;
		end;

		textcolor(cf.colorchart[NORMAL]);
		write(#13#10'CatMail has detected a user named SYSOP.  Do you log in as SYSOP? ');
		if (bar_yesno = 'Y') then
			cfg.rennet := 1;

		writeln;

		closeuserfile;
	end;
end;

procedure setup_cfg;
var s, noscan : string;
    p : byte;
	ret : word;
	mch, ch : char;
begin
	heading('Welcome to CatMail');

	fillchar(cfg, sizeof(cfg), 0);
	tonts('CM2', cfg.id);

	textcolor(cf.colorchart[NORMAL]);
	writeln(#13#10#10'Welcome to CatMail, the mail processor dedicated to Searchlight BBS!');
	writeln;
	writeln('CMSetup has detected that you do not have CatMail already set up on your');
	writeln('system.  If this is correct, then answer Yes to continue with the setup');
	writeln('procedure.  If not, or you wish to quit, select No.');
	writeln;
	writeln('It is recommended you set up Searchlight and your mailer software before');
	writeln('setting up CatMail.');
	writeln;
	write('Would you like to continue? ');
	init_barmenu;
	add_barmenu('Yes', 'Please continue!');
	add_barmenu('No', 'No, I''ll read the manual first!');
	p := 1;
	if (disp_barmenu(p) = 'N') then
		quit;

	if (not access('CM.EXE')) then
	begin
		heading('Install Abort');
		writeln(#13#10#10'CatMail cannot self-configure - you must run CatMail from its own directory');
		writeln('the first time you configure it.  After then, as long as the CM environment');
		writeln('variable is set, and CatMail is in your path, you may run it from anywhere.');
		writeln('Please change to your CatMail directory and rerun CMSETUP.');
		halt(42);
	end;

	getdir(0, s);
	if (copy(s, 3, 100) <> '\CM') then
	begin
		textcolor(cf.colorchart[NORMAL]);
		writeln(#13#10#10#10'It is advisable that you set up CatMail in a directory called ',s[1],':\CM.');
		writeln('This makes all CatMail systems standardised, and is purely for aesthetic');
		writeln('reasons.  If you want it to be in the directory ',s,',');
		writeln('then select No to continue.');
		writeln;
		write('Would you like to quit? ');
		init_barmenu;
		add_barmenu('Yes', 'Abort setup so I can go and move CatMail.');
		add_barmenu('No', 'Continue anyway, there''s a good reason why it''s there!');
		p := 1;
		if (disp_barmenu(p) = 'Y') then
			quit;
	end;

	heading('CatMail Personal Setup');
	writeln(#13#10#10'CatMail can function in different modes, depending on your requirements.');
	writeln('This initial setup program allows you to easily select a template which best');
	writeln('suits your needs.');
	writeln;
	writeln('If the computer you will run CatMail on is a 486 or above, select the');
	writeln('all features enabled option.  If your computer is slower, you might like');
	writeln('to turn off some of the more advanced features of CatMail to speed it up,');
	writeln('such as duplicate message checking and threading.  If this is so, select');
	writeln('the advanced features off option or the all features disabled option.');
	writeln;
	writeln('Please note: The author recommends you try CatMail with all features');
	writeln('enabled, even if you have a slow computer.  CatMail is still many times');
	writeln('faster than conventional message processing methods even with all the');
	writeln('advanced features on.');
	writeln;
	writeln('At any time you can enable and disable features by using CMSetup.');
	writeln;

	write('Which option? ');
	init_barmenu;
	add_barmenu('All Features', 'Enable all features: *recommended* (threading, 200 msg dupe buffer, colouring)');
	add_barmenu('Some Features', 'Advanced features off (no threading, 50 message dupe buffer, colouring)');
	add_barmenu('No Features', 'All features off (no threading, no dupe checking, no colouring)');
	add_barmenu('Quit', 'Quit CatMail Setup');
	p := 1;
	mch := disp_barmenu(p);

	if (mch = 'Q') then
		quit;

	heading('CatMail Automatic HD Scan');
	writeln(#13#10#10'CatMail will now scan your hard drive(s) searching for applications it can');
	writeln('recognise in order to make a express setup for you.  Depending on how big your');
	writeln('hard drives are and the speed of your computer, this will take from two seconds');
	writeln('to five minutes.');


	writeln(#10'Hit enter to scan all drives.  If you don''t want CatMail to scan all your');
	writeln('drives, enter the drives letters that you want to scan below.  For example,');
	writeln('type "CDT" to scan drives C, D, and T.  Don''t specify your CD-ROM drives.');

	write(#10'Enter drives to scan:  ');
	textcolor(cf.colorchart[PROMPTCOLOR]);
	noscan := getlinep('', 26, true, true, false, 0, 0, ret, ' ', false);
	gotoxy(1, wherey);
	clreol;

	textcolor(cf.colorchart[NORMAL]);
	if noscan = '' then
		write('CatMail will scan all drives')
	else
	begin
		write('CatMail will scan drives ');
		textcolor(cf.colorchart[PROMPTCOLOR]);
		write(noscan);
		textcolor(cf.colorchart[NORMAL]);
	end;

	writeln('.  Press [ESC] to abort scan.');

	write(#10'Searching... ');
	textcolor(cf.colorchart[PROMPTCOLOR]);
	perform_dirscan(noscan);
	textcolor(cf.colorchart[NORMAL]);
	writeln('done!');

	default(mch);
	eval_progs;
	eval_sysop;

	textcolor(cf.colorchart[NORMAL]);
	writeln(#10'CatMail has completed a default setup and has used information from the');
	writeln('programs given above to try to customise CatMail to your system.  Please');
	writeln('take the time to go through the CatMail Setup program and manual, filling');
	writeln('in items that CatMail could not obtain information about and setting');
	writeln('CatMail to your own liking.');
	writeln;
	writeln('Also remember that CatMail is shareware!  If you like what you see, support');
	writeln('the author so that he can make more Searchlight utilities and continue the');
	writeln('development of CatMail!  Details are in REGFORM.DOC in your DOCS\ directory.');
	writeln;
	write('Press any key to enter CMSetup... ');

	ch := readkey;
end;

end.
