unit dirscan;

interface

uses dos, crt;

procedure perform_dirscan(scan : string);

type _found = record
	fd		: boolean;
	fdp		: string[45];
	bink	: boolean;
	binkp	: string[45];
	db		: boolean;
	dbp		: string[45];
	cm		: boolean;
	cmp		: string[45];
	squish  : boolean;
	squishp : string[45];
	golded	: boolean;
	goldedp : string[45];
	uumail  : boolean;
	uumailp : string[45];
	uucico	: boolean;
	uucicop : string[45];
	inalias	: boolean;
	inaliasp: string[45];
	outalias: boolean;
	outaliasp:string[45];
end;

var found : _found;

implementation

var wx, wy : word;


type _fc = record
		n, n2	: string[13];
		v, s	: pointer;
end;


const fc : array [1..11] of _fc = (
	( n:'CM.EXE'; n2:'CFG.CM'; 	v:@found.cm;	s:@found.cmp ),
	( n:'FD.EXE'; n2:'SETUP.FD'; 	v:@found.fd;	s:@found.fdp ),
	( n:'BT.EXE'; n2:'BINKLEY.CFG';	v:@found.bink;	s:@found.binkp ),
	( n:'DB.EXE'; n2:'DBRIDGE.CFG'; v:@found.db;	s:@found.dbp ),
	( n:'SQUISH.EXE'; n2:'SQUISH.CFG';v:@found.squish;s:@found.squishp ),
	( n:'GOLDED.EXE'; n2:'GOLDED.CFG';v:@found.golded;s:@found.goldedp ),
	( n:'GED386.EXE'; n2:'GOLDED.CFG';v:@found.golded;s:@found.goldedp ),
	( n:'UUMAIL.EXE'; n2:'UCONFIG.SL2'; v:@found.uumail; s:@found.uumailp ),
	( n:'UUCICO.CFG'; n2:''; v:@found.uucico; s:@found.uucicop ),
	( n:'INALIAS.SL2'; n2:''; v:@found.inalias; s:@found.inaliasp ),
	( n:'OUTALIAS.SL2'; n2:''; v:@found.outalias; s:@found.outaliasp ) );


const fcn = 11;


procedure check_file(dir, files, dirfiles : string);
var lp : integer;
    sp : ^string;
	sr : searchrec;
begin
	for lp := 1 to fcn do
	begin
		if fc[lp].n = files then
		begin
			if (fc[lp].n2 <> '') then
				findfirst(dir+'\'+fc[lp].n2, anyfile, sr)
			else
				sr.name := '';

			if (sr.name = fc[lp].n2) then
			begin
				boolean(fc[lp].v^) := true;
				string(fc[lp].s^) := dir;
			end;
		end;
	end;
end;


function perform_subscan(s:string) : boolean;
var
  sr : searchrec;
  ss, ext : string[80];
  ch : char;
  lp : integer;
begin
	perform_subscan := false;

	if keypressed then
	begin
		ch := readkey;
		if ch = #27 then
		begin
			perform_subscan := true;
			exit;
		end;
	end;

	findfirst(s+'\*.*', Directory, sr);
	while doserror = 0 do
	begin
		if ((sr.attr and Directory) = Directory) and
			(sr.name <> '.') and
			(sr.name <> '..') then
		begin
			if perform_subscan(s+'\'+sr.name) = true then
			begin
				perform_subscan := true;
				exit;
			end;
		end;
		findnext(sr);
	end;

	for lp := 1 to 3 do
	begin
		case lp of
		  1:  ext := '\*.EXE';
		  2:  ext := '\*.CFG';
		  3:  ext := '\*.SL2';
		end;

		findfirst(s+ext, anyfile, sr);
		while doserror = 0 do
		begin
			clreol;
			write(s+'\'+sr.name);
			gotoxy(wx,wy);
			check_file(s, sr.name, s+'\'+sr.name);
			findnext(sr);
		end;
	end;
end;



procedure perform_dirscan(scan : string);
type pbyte = ^byte;
var
  sr : searchrec;
  dup, lp : byte;
  regs : registers;
  p : pbyte;

begin
	wx := wherex;
	wy := wherey;

	if (scan <> '') then
	begin
		for lp := 1 to length(scan) do
		begin
			if perform_subscan(scan[lp]+':') = true then
				lp := length(scan);
		end;
	end
	else
	begin
		dup := 3;
		while dup < 27 do
		begin
			findfirst(char(dup+64)+':\*.*', anyfile, sr);
			if (doserror = 0) and (pos(char(dup+64), scan) = 0) then
				if (perform_subscan(char(dup+64)+':') = true) then
					dup := 27;
			inc(dup);
		end;
	end;

	clreol;
end;

end.