unit ext;

interface

uses
	stats,
	slenter, data, strings, areas, defs, strznnp, putils,
	general, filedef;

procedure exec_external(s : string);

implementation

procedure ImportAreasBBS;
const
 areastr : string[50] = '; The following area(s) are from ';
var
	s 		: string;
	group	: string;
	r 		: word;
	fptr 	: text;
	a 		: _areacfg;
	al		: _arealink;
	sz		: sysznnp;
	pz, z	: znnp;
	l		: longint;

	Area 	 : TArea;
	linkfile : file;
begin
	heading('Import AREAS.BBS Into Configuration');

	if GetFileDate(fromnts(@cfg.cmpath)+'AREA.CM') >
	   GetFileDate(fromnts(@cfg.cmpath)+'AREAIDX.CM') then
	begin
		writeln(#10'You must run CM.EXE now before importing an AREAS.BBS file.  Run CM.EXE');
		writeln('with no command line parameters, and then rerun CMSETUP.EXE.'#10);
		pok;
		exit;
	end;

	writeln(#10'This program will import the standard AREAS.BBS into your CatMail area');
	writeln('configuration.  If an area is found in the AREAS.BBS file which already');
	writeln('exists, the new area will be ignored.');
	writeln;
	write('Enter the full path and filename of the AREAS.BBS file:'#13#10'  ');

	s := getlinep('', 60, true, true, false, 0, 0, r, #0, false);
	writeln(#10);

	if s = '' then exit;

	if Area.ReadIDX = false then
	begin
		write('Unable to open AREA.CM.  ');
		pok;
		exit;
	end;

	assign(linkfile, fromnts(@cfg.cmpath)+'AREALINK.CM');
	{$i-} reset(linkfile, 1); {$I+}
	if ioresult <> 0 then
	begin
		write('Unable to open AREALINK.CM.  ');
		pok;
		exit;
	end;

	assign(fptr, s);
	{$i-} reset(fptr); {$I+}
	if ioresult <> 0 then
	begin
		write('Unable to open file.  ');
		pok;
		exit;
	end;

	readln(fptr, s);

	fillchar(pz, sizeof(znnp), 0);
	group := '';

	while not eof(fptr) do
	begin
		readln(fptr, s);
		if not (s[1] in ['#', ';']) then
		begin
			if (Area.GetTag(aword(s, 2)) = false) then
			begin
				fillchar(a, sizeof(a), 0);
				if aword(s, 1) <> 'P' then
					tonts(aword(s, 1), a.slarea);
				tonts(aword(s, 2), a.tag);
				tonts(group, a.group);

				a.export := Yes;
				a.import := Yes;

				r := 3;
				while aword(s, r) <> '' do
				begin
					if strtoznnpo(aword(s, r), z, pz) then
					begin
						sz.t := DFidonet;
						sz.z := z;

						move(z, pz, sizeof(znnp));
					end
					else
					begin
						sz.t := DInternet;
						tonts(ups(aword(s, r)), sz.s);
						a.isusenet := 1;
					end;

					fillchar(al, sizeof(al), 0);
					al.status := MSActive;
					al.sz := sz;

					l := filesize(linkfile);
					if r = 3 then
						a.links := l;

					if aword(s, r+1) <> '' then
						al.next := l + sizeof(_arealink);

					seek(linkfile, l);
					blockwrite(linkfile, al, sizeof(al));

					inc(r);
				end;

				seek(area.areafile, filesize(area.areafile));
				blockwrite(area.areafile, a, sizeof(_areacfg));
			end;
		end
		else
		begin
			if copy(s, 1, length(areastr)) = areastr then
			begin
				group := copy(s, length(areastr)+1, 8);
				stripspaces(group);
			end;
		end;
	end;

	close(fptr);
	close(linkfile);
	Area.CloseIDX;
end;

procedure ExportAreasBBS;
var
	s 			: string;
	a 			: _areacfg;
	al			: _arealink;
	fptr 		: text;
	areafile	: file;
	linkfile	: file;
	r			: word;
	lastgroup	: string;
	pz, z		: znnp;
	l			: longint;

begin
	heading('Export AREAS.BBS From Configuration');

	writeln(#10'This program will export your CatMail area database into the standard');
	writeln('AREAS.BBS format.');
	writeln;
	write('Enter the full path and filename of the AREAS.BBS file:'#13#10'  ');

	s := getlinep('', 60, true, true, false, 0, 0, r, #0, false);
	writeln(#10);

	if s = '' then exit;

	assign(areafile, fromnts(@cfg.cmpath)+'AREA.CM');
	{$i-} reset(areafile, 1); {$I+}
	if ioresult <> 0 then
	begin
		write('Unable to open AREA.CM.  ');
		pok;
		exit;
	end;

	assign(linkfile, fromnts(@cfg.cmpath)+'AREALINK.CM');
	{$i-} reset(linkfile, 1); {$I+}
	if ioresult <> 0 then
	begin
		write('Unable to open AREALINK.CM.  ');
		pok;
		exit;
	end;

	assign(fptr, s);
	{$i-} reset(fptr); {$I+}
	if ioresult = 0 then
	begin
		close(fptr);
		writeln('This file already exists!  Please choose another filename.'#10);
		pok;
		exit;
	end;

	{$i-} rewrite(fptr); {$I+}
	if ioresult <> 0 then
	begin
		write('Unable to open file for writing.  ');
		pok;
		exit;
	end;

	lastgroup := '';
	blockread(areafile, a, sizeof(a));

	writeln(fptr, fromnts(@cfg.sysop)+' from '+cf.systemname+' BBS #');

	while not eof(areafile) do
	begin
		blockread(areafile, a, sizeof(a));

		if fromnts(@a.group) <> lastgroup then
		begin
			writeln(fptr, ';');
			writeln(fptr, '; The following area(s) are from '+fromnts(@a.group));
			writeln(fptr, ';');
			lastgroup := fromnts(@a.group);
		end;

		s := fromnts(@a.slarea);
		if s = '' then s := 'P';

		write(fptr, s+sp(10-length(s))+fromnts(@a.tag)+sp(36-length(fromnts(@a.tag))));

		fillchar(pz, sizeof(pz), 0);

		l := a.links;
		while l > 0 do
		begin
			seek(linkfile, l);
			blockread(linkfile, al, sizeof(al));

			if al.status = MSActive then
			begin
				if al.sz.t = DFidonet then
				begin
					write(fptr, pn(al.sz.z, pz)+' ');
					move(al.sz.z, pz, sizeof(znnp));
				end
				else
					write(fptr, fromnts(@al.sz.s)+' ');
			end;

			l := al.next;
		end;

		writeln(fptr);
	end;

	close(fptr);
	close(areafile);
	close(linkfile);
end;


procedure exec_external(s : string);
begin
	if s = 'IMPAREA' then
		ImportAreasBBS
	else if s = 'EXPAREA' then
		ExportAreasBBS
	else if s = 'S_BBS' then
		StatsBBS
	else if s = 'S_NODE' then
		StatsNode
	else if s = 'S_GROUP' then
		StatsGroup;
end;


end.
