unit menus;

interface

uses sldata, cfgdef, icfgdef, data, filedef, defs;

var
	td_origin	: _origin;
	td_pw		: _password;
	td_bink		: _bink;
	td_ac		: _areacfg;
	td_archive	: _archive;

	td_fix_alias	: _fix_alias;
	td_pack			: _pack;
	td_znnp			: znnp;
	td_tmplink		: _tmplink;
	td_st			: subtype;
	td_est			: mysubtype;

	td_netpath		: _netpath;
	td_hosts		: THosts;
	td_nalias		: TNameAlias;
	td_newmsg		: TNewMsg;
	td_volch		: TVolCh;

type _ab = record
	pvt,rcv,snt,fat,orp,loc,frq,cra,int,kws,hld,kfs,rrq,irr,arq,fur : boolean;
end;

var ab1, ab2 : _ab;



{ listscr'ed listscrs! }

const m_i_areaz : array [1..2] of cfgscrtype = (
	(s: 'Node'; st: L_SYSZNNP; l:@td_tmplink.sz),
	(s: 'Area status'; st: L_TOGGLE1; l:@td_tmplink.status; min:longint(@s_msgstat); max:2) );

const d_i_areaz : desctype = (n: 2; d: 'Area Uplink / Downlinks Setup'; l: @m_i_areaz; lt: T_CFGSCR);



const m_areaz : array [1..2] of listscrtype = (
	(off: 1; t: L_SYSZNNP; len:20; d: 'Address'),
	(off: 0; t: L_TOGGLE1; len:10; d: 'Status'; tog: @s_msgstat ) );

const l_areaz : lsdesctype = (l: @m_areaz; fn: '$LINK.CM'; recsize: sizeof(_tmplink); tl: @td_tmplink; dl: @d_i_areaz);
const d_areaz : desctype = (n: 2; d: 'FidoNet Area Uplink / Downlinks Setup'; l: @l_areaz; lt: T_LISTSCR);


const m_areasl : array [1..14] of cfgscrtype = (
	(s: 'Conference description'; st: L_STR; l:@td_est.name; min:0; max:40),
	(s: 'Required access level'; st: L_BYTE; l:@td_st.access; min:0; max:255),
	(s: 'Join attributes'; st: L_ATTRIB; l:@td_st.attrib),
	(s: 'Post attributes'; st: L_ATTRIB; l:@td_st.postattrib),
	(s: 'Conference SysOp'; st: L_STR; l:@td_est.subsysop; min:0; max:25),
	(s: 'Max. messages on conference'; st: L_WORD; l:@td_st.maxsize; min:0; max:32767),
	(s: 'Max. message size (lines)'; st: L_WORD; l:@td_st.maxmsglen; min:0; max:32767),
	(s: 'Alias name support'; st: L_TOGGLE0; l:@td_st.allowname; min:longint(@s_nametype); max:4),
	(s: 'Allow anonymous messages'; st: L_BOOL; l:@td_st.anonymous),
	(s: 'Auto purge old messages'; st: L_BOOL; l:@td_st.autokill),
	(s: 'Compress message texts'; st: L_BOOL; l:@td_st.compress),
	(s: 'Allow users to join'; st: L_BOOL; l:@td_st.userjoin),
	(s: 'Display on conference lists'; st: L_BOOL; l:@td_st.visible),
	(s: 'Echomail address'; st: L_ZNNP; l:@td_est.orig) );

const d_areasl : desctype = (n: 14; d: 'Corresponding Searchlight Area Setup'; l: @m_areasl; lt: T_CFGSCR);


{ menus for listscrs }

const m_i_ac : array [1..10] of cfgscrtype = (
	(s : 'Searchlight name'; st: L_UPSTR; l: @td_ac.slarea; min:0; max:8),
	(s : 'Group name'; st: L_STR; l: @td_ac.group; min:0; max:8),
	(s : 'Allow exporting from SL?'; st: L_TOGGLE1; l: @td_ac.export; min:longint(@s_dyn); max:2),
	(s : 'Allow importing into SL?'; st: L_TOGGLE1; l: @td_ac.import; min:longint(@s_dyn); max:2),
	(s : 'Freeze inbound PKTs?'; st: L_BOOL; l: @td_ac.freeze),
	(s : 'Colour strip outbound msgs?'; st: L_TOGGLE0; l: @td_ac.cstrip; min:longint(@s_dyn); max:2),
	(s : 'Import secure messages only?'; st: L_TOGGLE0; l: @td_ac.secure; min:longint(@s_dyn); max:2),
	(s : 'Perform dupe checking?'; st: L_TOGGLE0; l: @td_ac.dupe; min:longint(@s_dyn); max:2),
	(s : 'UUEncoded message action'; st: L_TOGGLE0; l: @td_ac.uu; min:longint(@s_uudd); max:3),
	(s : 'Edit uplink / downlinks for this area'; st: L_LINK; l: @d_areaz) );
const d_i_ac : desctype = (n: 10; d: 'FidoNet/InterNet Message Area Setup'; l: @m_i_ac; lt: T_CFGSCR);



const m_i_origin : array [1..4] of cfgscrtype = (
	(s : 'Origin line'; st: L_STR; l: @td_origin.line; min:0; max:70),
	(s : 'For zone or area?'; st: L_TOGGLE0; l: @td_origin.t; min:longint(@s_origintype); max:1),
	(s : 'Zone number'; st: L_WORD; l: @td_origin.zone; min:0; max:65535),
	(s : 'Searchlight area name'; st: L_UPSTR; l: @td_origin.area; min:0; max:8));

const d_i_origin : desctype = (n: 4; d: 'Origin Line Setup'; l: @m_i_origin; lt: T_CFGSCR);


const m_i_pw : array [1..3] of cfgscrtype = (
	(s : 'The field below is a'; st: L_TOGGLE0; l:@td_pw.tipe; min:longint(@s_pw); max:3),
	(s : 'Password or path'; st: L_UPSTR; l:@td_pw.pw; min:0; max:30),
	(s : 'If password, node'; st: L_ZNNP; l: @td_pw.z));

const d_i_pw : desctype = (n: 3; d: 'Password Setup'; l: @m_i_pw; lt: T_CFGSCR);


const m_i_bink : array [1..3] of cfgscrtype = (
	(s : 'Zone'; st: L_WORD; l: @td_bink.zone; min:1; max:65535),
	(s : 'Domain name'; st: L_UPSTR; l: @td_bink.domain; min:0; max:8),
	(s : 'Optional path to outbound'; st: L_UPSTR; l: @td_bink.path; min:0; max:30));
const d_i_bink : desctype = (n: 3; d: 'Binkley Specific Setup'; l: @m_i_bink; lt: T_CFGSCR);


const m_i_arch : array [1..5] of cfgscrtype = (
	(s : 'Archiver name'; st: L_STR; l: @td_archive.name; min:0; max:14),
	(s : 'Ident location'; st: L_LONG; l: @td_archive.IdLocation; min:-2147483647; max:2147483647),
	(s : 'Ident string'; st: L_UPSTR; l: @td_archive.IdString; min:0; max:29),
	(s : 'Archiver add command'; st: L_STR; l: @td_archive.CmdAdd; min:0; max:75),
	(s : 'Archiver extract command'; st: L_STR; l: @td_archive.CmdExtract; min:0; max:75));
const d_i_arch : desctype = (n: 5; d: 'Archiver Setup'; l: @m_i_arch; lt: T_CFGSCR);


const m_i_fix_alias : array [1..1] of cfgscrtype = (
	(s: 'CMFix alias'; st: L_STR; l: @td_fix_alias.alias; min:0; max:35) );
const d_i_fix_alias : desctype = (n: 1; d: 'CMFix Name Alias Setup'; l: @m_i_fix_alias; lt: T_CFGSCR);


const m_i_pack : array [1..2] of cfgscrtype = (
	(s: 'Node'; st: L_ZNNP; l:@td_pack.z),
	(s: 'Archiver name'; st: L_UPSTR; l: @td_pack.name; min:0; max:14));
const d_i_pack : desctype = (n: 2; d: 'Specific Node Archiver Setup'; l: @m_i_pack; lt: T_CFGSCR);


const m_i_path_net : array [1..2] of cfgscrtype = (
	(s: 'Secondary netmail path'; st: L_PATH; l:@td_netpath.path; min:0; max:41),
	(s: 'Include in CMFix scan?'; st: L_BOOL; l:@td_netpath.fixscan) );

const d_i_path_net : desctype = (n: 2; d: 'Secondary NetMail Path Setup'; l: @m_i_path_net; lt: T_CFGSCR);


const m_i_hosts : array [1..3] of cfgscrtype = (
	(s: 'UUCP name of host'; st: L_STR; l: @td_hosts.name; min:0; max:10),
	(s: 'Full address of postmaster'; st: L_STR; l:@td_hosts.postmaster; min:0; max:59),
	(s: 'Allow foreign email to pass'; st: L_BOOL; l:@td_hosts.AllowEmailPassing ) );

const d_i_hosts : desctype = (n: 3; d: 'Internet Host Setup'; l: @m_i_hosts; lt: T_CFGSCR);


const m_i_nalias : array [1..4] of cfgscrtype = (
	(s: 'User name / conference'; st: L_UPSTR; l: @td_nalias.user; min:0; max:24),
	(s: 'Internet name'; st: L_STR; l: @td_nalias.inetname; min:0; max:69),
	(s: 'Alias type'; st: L_TOGGLE0; l: @td_nalias.atype; min:longint(@s_aliastype); max:6),
	(s: 'Forwarding address:'; st: L_STR; l: @td_nalias.forwardto; min:0; max:69) );

const d_i_nalias : desctype = (n: 4; d: 'Internet Name Alias Setup'; l: @m_i_nalias; lt: T_CFGSCR);


const m_i_newmsg : array [1..21] of cfgscrtype = (
	(s: 'Messages come from'; st: L_SYSZNNP; l: @td_newmsg.from),
	(s: 'Autocreate new area?'; st: L_BOOL; l: @td_newmsg.autocreate),
	(s: 'Autogenerate SL area name?'; st: L_BOOL; l: @td_newmsg.autoname),
	(s: 'Autocreate new SL area?'; st: L_BOOL; l: @td_newmsg.makeslsub),
	(s: 'Default group name'; st: L_STR; l: @td_newmsg.group; min:0; max:9),
	(s: 'Default subboard directory'; st: L_PATH; l:@td_newmsg.subdir; min:0; max:44),
	(s: 'Default subboard list file'; st: L_FILE; l:@td_newmsg.subfile; min:0; max:44),
	(s: 'Default SL area name prefix'; st: L_UPSTR; l:@td_newmsg.nameprefix; min:0; max:3),
	(s: 'Conference description'; st: L_STR; l:@td_newmsg.mn.name; min:0; max:40),
	(s: 'Required access level'; st: L_BYTE; l:@td_newmsg.n.access; min:0; max:255),
	(s: 'Join attributes'; st: L_ATTRIB; l:@td_newmsg.n.attrib),
	(s: 'Post attributes'; st: L_ATTRIB; l:@td_newmsg.n.postattrib),
	(s: 'Conference SysOp'; st: L_UPSTR; l:@td_newmsg.mn.subsysop; min:0; max:25),
	(s: 'Max. messages on conference'; st: L_WORD; l:@td_newmsg.n.maxsize; min:0; max:32767),
	(s: 'Max. message size (lines)'; st: L_WORD; l:@td_newmsg.n.maxmsglen; min:0; max:32767),
	(s: 'Alias name support'; st: L_TOGGLE0; l:@td_newmsg.n.allowname; min:longint(@s_nametype); max:4),
	(s: 'Allow anonymous messages'; st: L_BOOL; l:@td_newmsg.n.anonymous),
	(s: 'Auto purge old messages'; st: L_BOOL; l:@td_newmsg.n.autokill),
	(s: 'Compress message texts'; st: L_BOOL; l:@td_newmsg.n.compress),
	(s: 'Allow users to join'; st: L_BOOL; l:@td_newmsg.n.userjoin),
	(s: 'Display on conference lists'; st: L_BOOL; l:@td_newmsg.n.visible) );

const d_i_newmsg : desctype = (n: 21; d: 'New Message Area Setup'; l: @m_i_newmsg; lt: T_CFGSCR);


const m_i_volch : array [1..3] of cfgscrtype = (
	(s: 'System (with wildcards)'; st: L_STR; l: @td_volch.addr; min:0; max:50),
	(s: 'Fidonet or internet?'; st: L_TOGGLE0; l: @td_volch.fi; min:longint(@s_fi); max:1),
	(s: 'Credits per kilobyte'; st: L_LONG; l: @td_volch.credits; min:0; max:2147483647) );
const d_i_volch : desctype = (n: 3; d: 'Volume Charges for Private Mail'; l: @m_i_volch; lt: T_CFGSCR);


{ listscrs }


const m_ac : array [1..4] of listscrtype = (
	(off: 0; t: L_STR; len: 28; d:'Area Tag'),
	(off: 40; t: L_UPSTR; len: 10; d:'SLArea'),
	(off: 50; t: L_STR; len: 10; d:'Group'),
	(off: 60; t: L_STR; len: 30; d:'Description'));

const l_ac : lsdesctype = ( l: @m_ac; fn: 'AREA.CM';
	recsize: sizeof(_areacfg); tl: @td_ac; dl: @d_i_ac; sort: Nil );

const d_ac : desctype = (n: 4; d:'Message Area Configuration'; l: @l_ac; lt: T_MSGAREA);


const m_origin : array [1..5] of listscrtype = (
	(off: 82; t: L_TOGGLE0; len:5; d: 'Type'; tog: @s_origintype),
	(off: 0; t: L_WORD; len: 5; d:'Zone'),
	(off: 2; t: L_NONE; len: 2),
	(off: 2; t: L_UPSTR; len: 9; d:'Area'),
	(off: 11; t: L_STR; len: 58; d:'Origin Line'));

const l_origin : lsdesctype = ( l: @m_origin; fn: 'ORIGIN.CM';
	recsize: sizeof(_origin); tl: @td_origin; dl: @d_i_origin; sort: Nil);


const d_origin : desctype = (n: 5; d:'Origin Lines'; l:@l_origin; lt: T_LISTSCR);


const m_pw : array [1..3] of listscrtype = (
	(off : 8; t: L_TOGGLE0; len : 20; d:'Type'; tog:@s_pw),
	(off : 0; t: L_ZNNP; len: 25; d:'Node'),
	(off : 9; t: L_STR; len: 30; d:'Password/File'));

const l_pw : lsdesctype = ( l: @m_pw; fn: 'PASSWORD.CM';
	recsize: sizeof(_password); tl: @td_pw; dl: @d_i_pw);

const d_pw : desctype = (n: 3; d: 'Password Setup'; l: @l_pw; lt: T_LISTSCR);



const m_bink : array [1..4] of listscrtype = (
	(off : 2; t: L_UPSTR; len: 10; d:'Domain'),
	(off : 0; t: L_WORD; len: 5; d:'Zone'),
	(off : 2; t: L_NONE; len: 3; d:''),
	(off : 11; t: L_UPSTR; len: 30; d:'Optional Path'));

const l_bink : lsdesctype = ( l: @m_bink; fn: 'DOMAIN.CM';
	recsize: sizeof(_bink); tl: @td_bink; dl: @d_i_bink);

const d_bink : desctype = (n: 4; d: 'Binkley Specific'; l: @l_bink; lt: T_LISTSCR);


const m_archive : array [1..1] of listscrtype = (
	(off: 0; t: L_STR; len: 15; d:'Archiver Name') );
const l_archive : lsdesctype = ( l: @m_archive; fn: 'ARCHIVE.CM';
								recsize: sizeof(_archive); tl: @td_archive;
								dl: @d_i_arch);
const d_archive : desctype = (n: 1; d: 'Archiver Setup'; l: @l_archive; lt: T_LISTSCR);

const m_pack : array [1..2] of listscrtype = (
	(off: 0; t: L_ZNNP; len: 15; d: 'Node'),
	(off: 8; t: L_STR; len: 17; d: 'Archiver') );
const l_pack : lsdesctype = (l: @m_pack; fn: 'PACK.CM'; recsize: sizeof(_pack);
							tl: @td_pack; dl: @d_i_pack);
const d_pack : desctype = (n: 2; d: 'Specific Node Archiver Setup'; l: @l_pack; lt: T_LISTSCR);


const m_fix_alias : array [1..1] of listscrtype = (
	(off: 0; t: L_STR; len: 35; d:'CMFix Alias') );
const l_fix_alias : lsdesctype = ( l: @m_fix_alias; fn: 'FIXALIAS.CM';
									recsize: sizeof(_fix_alias); tl: @td_fix_alias;
									dl: @d_i_fix_alias);
const d_fix_alias : desctype = (n: 1; d: 'CMFix Name Aliases'; l: @l_fix_alias; lt: T_LISTSCR);


const m_path_net : array [1..2] of listscrtype = (
	(off: 0; t: L_PATH; len: 50; d: 'NetMail Path'),
	(off: 45; t: L_BOOL; len: 12; d: 'CMFix Scan?') );

const l_path_net : lsdesctype = (l: @m_path_net; fn: 'NETPATH.CM';
								 recsize: sizeof(_netpath); tl: @td_netpath;
								 dl: @d_i_path_net);
const d_path_net : desctype = (n: 2; d: 'Secondary NeMail Paths Setup'; l: @l_path_net; lt: T_LISTSCR);

const d_group : desctype = (n:0; d:'Area Group Names Setup'; l: Nil; lt: T_GROUPAREA);
	{ contains area name, list of nodes, whether the node can hubjoin,
		the name of the hubjoin ascii file }


const m_hosts : array [1..3] of listscrtype = (
	(off: 0; t: L_STR; len: 13; d: 'UUCP name'),
	(off: 15; t: L_STR; len: 40; d: 'Postmaster'),
	(off: 75; t: L_BOOL; len: 20; d: 'Allow Passing') );

const l_hosts : lsdesctype = (l: @m_hosts; fn: 'HOSTS.CM';
							  recsize: sizeof(THosts); tl: @td_hosts;
							  dl: @d_i_hosts);
const d_hosts : desctype = (n: 3; d:'Internet Hosts'; l: @l_hosts; lt: T_LISTSCR);


const m_nalias : array [1..3] of listscrtype = (
	(off: 0; t: L_UPSTR; len:24; d: 'User Name'),
	(off: 25; t: L_STR; len:46; d: 'Internet Alias'),
	(off: 95; t: L_TOGGLE0; len:8; d: 'Type'; tog: @s_aliastype2) );

const l_nalias : lsdesctype = (l: @m_nalias; fn: 'ALIAS.CM';
								recsize: sizeof(TNameAlias); tl: @td_nalias;
								dl: @d_i_nalias);
const d_nalias : desctype = (n: 3; d: 'Internet Name Aliases'; l: @l_nalias; lt: T_LISTSCR);


const m_newmsg : array [1..2] of listscrtype = (
	(off: 0; t: L_SYSZNNP; len:15; d: 'From'),
	(off: 11; t: L_STR; len:10; d: 'Group') );

const l_newmsg : lsdesctype = (l: @m_newmsg; fn: 'NEWAREA.CM';
								recsize: sizeof(TNewMsg); tl: @td_newmsg; dl: @d_i_newmsg);
const d_newmsg : desctype = (n: 2; d: 'New Message Area Setup'; l: @l_newmsg; lt: T_LISTSCR);


const m_volch : array [1..3] of listscrtype = (
	(off: 0;  t: L_STR;  len:50; d:'System Wildcard'),
	(off: 50; t: L_TOGGLE0; len: 10; d:'Type'; tog: @s_fi),
	(off: 51; t: L_LONG; len:14; d:'Credits per KB') );

const l_volch : lsdesctype = (l: @m_volch; fn: 'VOLCH.CM';
								recsize: sizeof(TVolCh); tl: @td_volch; dl: @d_i_volch);
const d_volch : desctype = (n: 3; d: 'Volume Charges for Private Mail'; l: @l_volch; lt: T_LISTSCR);


{ Level 3 menus }

const m_advanced : array [1..3] of cfgscrtype = (
	(s : 'Message buffer size'; st: L_WORD; l:@cfg.msgbufsize;min:4096;max:65534),
	(s : 'Internal file cache'; st: L_WORD; l:@cfg.msgcachesize;min:0;max:65535),
	(s : 'Spawn memory swap value'; st: L_BYTE; l:@cfg.swapto;min:0;max:255));
const d_advanced : desctype = (n:3;d:'Advanced Memory Parameters Setup';l:@m_advanced;lt:T_CFGSCR);



{ Level 2 menus }

const m_address : array [1..17] of cfgscrtype = (
	(s : 'FidoNet processing enabled?'; st: L_BOOL; l: @cfg.fidoenabled),
	(s : 'Front end mailer type'; st : L_TOGGLE1; l : @cfg.mailertype; min:longint(@s_mailer); max:4),
	(s : 'Primary address'; st : L_ZNNP; l : @cfg.address[0]),
	(s : 'AKA address 2'; st : L_ZNNP; l : @cfg.address[1]),
	(s : 'AKA address 3'; st : L_ZNNP; l : @cfg.address[2]),
	(s : 'AKA address 4'; st : L_ZNNP; l : @cfg.address[3]),
	(s : 'AKA address 5'; st : L_ZNNP; l : @cfg.address[4]),
	(s : 'AKA address 6'; st : L_ZNNP; l : @cfg.address[5]),
	(s : 'AKA address 7'; st : L_ZNNP; l : @cfg.address[6]),
	(s : 'AKA address 8'; st : L_ZNNP; l : @cfg.address[7]),
	(s : 'AKA address 9'; st : L_ZNNP; l : @cfg.address[8]),
	(s : 'AKA address 10'; st : L_ZNNP; l : @cfg.address[9]),
	(s : 'AKA address 11'; st : L_ZNNP; l : @cfg.address[10]),
	(s : 'AKA address 12'; st : L_ZNNP; l : @cfg.address[11]),
	(s : 'AKA address 13'; st : L_ZNNP; l : @cfg.address[12]),
	(s : 'AKA address 14'; st : L_ZNNP; l : @cfg.address[13]),
	(s : 'AKA address 15'; st : L_ZNNP; l : @cfg.address[14]));

const d_address : desctype = (n : 17; d:'Address Setup';
				l:@m_address; lt:T_CFGSCR);

const m_error : array [1..5] of cfgscrtype = (
	(s : 'Report duplicate messages?'; st:L_BOOL; l:@cfg.rep[0]),
	(s : 'Report lack of disk space?'; st:L_BOOL; l:@cfg.rep[1]),
	(s : 'Report critical errors?'; st:L_BOOL; l:@cfg.rep[2]),
	(s : 'Report new conferences made?'; st:L_BOOL; l:@cfg.rep[3]),
	(s : 'Retries running external CMEs'; st:L_BYTE; l:@cfg.retries; min:0;max:255));
const d_error : desctype = (n : 5; d:'Exceptions and Errors Configuration';
				l:@m_error; lt:T_CFGSCR);

const m_paths : array [1..12] of cfgscrtype = (
	(s : 'CatMail primary path'; st : L_PATH; l : @cfg.cmpath;min:0;max:41),
	(s : 'Dedicated work path'; st : L_PATH; l : @cfg.workpath;min:0;max:41),
	(s : 'Inbound fido files path'; st : L_PATH; l : @cfg.filespath;min:0;max:41),
	(s : 'Outbound fido archives path'; st: L_PATH; l : @cfg.packpath;min:0;max:41),
	(s : 'Duplicate data path'; st:L_PATH; l:@cfg.dupepath;min:0;max:41),
	(s : 'Primary netmail path'; st: L_PATH; l: @cfg.netpath;min:0;max:41),
	(s : 'Primary arcmail path'; st: L_PATH; l: @cfg.arcnetpath; min:0; max:41),
	(s : 'Primary internet spool path'; st: L_PATH; l: @icfg.spool; min:0; max:41),
	(s : 'CatMail log file'; st:L_FILE; l:@cfg.logfile;min:0;max:41),
	(s : 'Internet log file'; st: L_FILE; l: @cfg.inetlogfile; min:0; max: 41),
	(s : 'Transaction log file'; st: L_FILE; l: @cfg.transxlogfile; min:0; max: 41),
	(s : 'Forced rescan semaphore file'; st:L_FILE; l:@cfg.rescanfile;min:0;max:41));
const d_paths : desctype = (n : 12; d:'Paths and FileNames Setup';
				l:@m_paths; lt:T_CFGSCR);


const m_pkt : array [1..6] of cfgscrtype = (
	(s: 'EchoMail file attach method'; st:L_TOGGLE0; l:@cfg.fa_echo; min:longint(@s_fam); max:1),
	(s: 'Inbound PKT password checking?'; st: L_BOOL; l: @cfg.secure),
	(s: 'Import from listed nodes only?'; st: L_BOOL; l: @cfg.secureimport),
	(s: 'Duplicate message action'; st: L_TOGGLE0; l: @cfg.dupeaction; min:longint(@s_dupe); max:2),
	(s: 'Remember x last messages'; st: L_WORD; l:@cfg.dupecheck;min:0;max:10000),
	(s: 'Action once archive is sent'; st: L_TOGGLE0; l: @cfg.sentaction; min:longint(@s_sa); max:2));
const d_pkt : desctype = (n : 6; d:'FidoNet .PKT Importing and Exporting Setup';
				l:@m_pkt; lt:T_CFGSCR);


const m_net1 : array [1..10] of cfgscrtype = (
	(s: 'Private?'; st: L_BOOL; l: @ab1.pvt),
	(s: 'Local?'; st: L_BOOL; l: @ab1.loc),
	(s: 'Crash?'; st: L_BOOL; l: @ab1.cra),
	(s: 'Hold?'; st: L_BOOL; l: @ab1.hld),
	(s: 'File Attached?'; st: L_BOOL; l: @ab1.fat),
	(s: 'File Request?'; st: L_BOOL; l: @ab1.frq),
	(s: 'Orphan?'; st: L_BOOL; l: @ab1.orp),
	(s: 'In Transit?'; st: L_BOOL; l: @ab1.int),
	(s: 'Kill Msg Once Sent?'; st: L_BOOL; l: @ab1.kws),
	(s: 'Kill File Once Sent?'; st: L_BOOL; l: @ab1.kfs));
const d_net1 : desctype = (n : 10; d:'Attributes for netmail exported from Searchlight';
				l:@m_net1; lt:T_CFGSCR);


const m_net2 : array [1..10] of cfgscrtype = (
	(s: 'Private?'; st: L_BOOL; l: @ab2.pvt),
	(s: 'Local?'; st: L_BOOL; l: @ab2.loc),
	(s: 'Crash?'; st: L_BOOL; l: @ab2.cra),
	(s: 'Hold?'; st: L_BOOL; l: @ab2.hld),
	(s: 'File Attached?'; st: L_BOOL; l: @ab2.fat),
	(s: 'File Request?'; st: L_BOOL; l: @ab2.frq),
	(s: 'Orphan?'; st: L_BOOL; l: @ab2.orp),
	(s: 'In Transit?'; st: L_BOOL; l: @ab2.int),
	(s: 'Kill Msg Once Sent?'; st: L_BOOL; l: @ab2.kws),
	(s: 'Kill File Once Sent?'; st: L_BOOL; l: @ab2.kfs));

const d_net2 : desctype = (n : 10; d:'Attributes for FileAttached netmail exported from Searchlight';
				l:@m_net2; lt:T_CFGSCR);


const m_net : array [1..10] of cfgscrtype = (
	(s: 'Kill blank messages?'; st: L_BOOL; l:@cfg.killblank),
	(s: 'SysOp logs in as SYSOP?'; st: L_BOOL; l:@cfg.rennet),
	(s: 'Use ^APID for netmail?'; st: L_BOOL; l:@cfg.pidtype),
	(s: 'Import "Local" netmail?'; st: L_BOOL; l:@cfg.localnetimp),
	(s: 'Default credits per KB'; st: L_WORD; l: @cfg.defcredits; min:0; max:65535),
	(s: 'Netmail file attach method'; st: L_TOGGLE0; l:@cfg.fa_net; min:longint(@s_fam);max:2),
	(s: 'Primary netmail path'; st: L_PATH; l: @cfg.netpath;min:0;max:41),
	(s: 'Secondary netmail paths'; st:L_LINK; l:@d_path_net; min:0;max:0),
	(s: 'Attribs for outbound netmail'; st: L_LINK; l:@d_net1),
	(s: 'Attribs for fileattached netmail'; st: L_LINK; l:@d_net2));
const d_net : desctype = (n : 10; d:'NetMail Importing and Exporting Setup';
				l:@m_net; lt:T_CFGSCR);


const m_misc : array [1..7] of cfgscrtype = (
	(s : 'SysOp name'; st : L_UPSTR; l:@cfg.sysop; min:0;max:25),
	(s : 'System comment'; st : L_STR; l:@cfg.system_comment;min:0;max:70),
	(s : 'Log detail level'; st: L_TOGGLE0; l:@cfg.loglevel;min:longint(@s_loglevel);max:5),
	(s : 'Use 4DOS comments?'; st: L_BOOL; l:@cfg.usecomfile),
	(s : '4DOS comments filename'; st:L_FILE; l:@cfg.comfile;min:0;max:12),
	(s : 'Suppress archiver output'; st:L_BOOL; l:@cfg.quiet),
	(s : 'Advanced memory setup'; st:L_LINK; l:@d_advanced));
const d_misc : desctype = (n:7;d:'Miscellaneous Setup';l:@m_misc;lt:T_CFGSCR);


const m_sl : array [1..11] of cfgscrtype = (
	(s : 'Thread inbound messages?'; st:L_BOOL; l:@cfg.thread),
	(s : 'Colour inbound messages?'; st:L_BOOL; l:@cfg.colour),
	(s : 'Quote colour [>]'; st:L_TOGGLE0; l:@cfg.quotecolour; min:longint(@s_colour); max:15),
	(s : 'Tag colour [___]'; st:L_TOGGLE0; l:@cfg.tagcolour; min:longint(@s_colour); max:15),
	(s : 'Tear colour [---]'; st:L_TOGGLE0; l:@cfg.tearcolour; min:longint(@s_colour); max:15),
	(s : 'Origin colour [ * Orig]'; st:L_TOGGLE0; l:@cfg.origincolour; min:longint(@s_colour); max:15),
	(s : 'Internet header colour'; st: L_TOGGLE0; l:@cfg.ihdrcolour; min:longint(@s_colour); max:15),
	(s : 'Strip colour on outbound msgs'; st:L_BOOL; l:@cfg.stripcolour),
	(s : 'Auto wrap at column'; st:L_BYTE; l:@cfg.wrapline; min:40; max:80),
	(s : 'UUEncoded message action'; st:L_TOGGLE0; l:@cfg.uudecode; min:longint(@s_uuda); max:2),
	(s : 'Use import error correction?'; st:L_BOOL; l:@cfg.usehlt) );

const d_sl : desctype = (n:11;d:'Searchlight Importing and Exporting Configuration';
		l:@m_sl; lt:T_CFGSCR);


const m_cmfix : array [1..4] of cfgscrtype = (
	(s: 'Enable CMFix?'; st: L_BOOL; l: @cfg.enable_cmfix),
	(s: 'Use CMFix secure mode?'; st:L_BOOL; l:@cfg.cmfixsecure),
	(s: 'Edit CMFix name aliases'; st: L_LINK; l: @d_fix_alias),
	(s: 'Edit group access levels'; st:L_LINK; l: @d_group));

const d_cmfix : desctype = (n: 4; d: 'CatMail FIX Configuration'; l: @m_cmfix; lt: T_CFGSCR);



{ Level 1 menus }

const m_fido : array [1..8] of menulisttype = (
	(s : 'FidoNet Configuration'; l : Nil),
	(s : 'Addresses and Mailer'; l : @d_address),
	(s : 'NetMail'; l : @d_net),
	(s : 'Passwords'; l : @d_pw),
	(s : '*.PKT Import and Exporting'; l : @d_pkt),
	(s : 'Origin Lines'; l : @d_origin),
	(s : 'CMFix Setup'; l : @d_cmfix),
	(s : 'BinkleyTerm Domains and Paths'; l : @d_bink));
const d_fido : desctype = ( n:8; d:'FidoNet Specific Configuration';
				l:@m_fido; lt:T_MENULIST);


const m_gen : array [1..10] of menulisttype = (
	(s : 'General Configuration'; l : Nil),
	(s : 'Paths and Filenames'; l : @d_paths),
	(s : 'Searchlight Import and Exporting'; l : @d_sl),
	(s : 'Exception and Error Handling'; l : @d_error),
	(s : 'Archiver Setup'; l : @d_archive),
	(s : 'Archivers'; l: @d_pack),
	(s : 'Group Name Setup'; l: @d_group),
	(s : 'New Message Area Setup'; l: @d_newmsg),
	(s : 'Mail Volume Charges'; l: @d_volch),
	(s : 'Miscellaneous'; l : @d_misc));
const d_gen : desctype = ( n: 10; d:'General Configuration';
				l:@m_gen; lt:T_MENULIST);


const m_inet : array [1..16] of cfgscrtype = (
	(s : 'Internet commands enabled?'; st: L_BOOL; l: @icfg.enabled),
	(s : 'Full internet domain'; st: L_STR; l: @icfg.address; min: 0; max: 40),
	(s : 'Full internet return domain'; st: L_STR; l: @icfg.returnaddr; min: 0; max: 40),
	(s : 'UUCP name'; st: L_STR; l: @icfg.uucpname; min: 0; max: 12),
	(s : 'Outbound email host'; st: L_STR; l: @icfg.emailhost; min: 0; max: 10),
	(s : 'Outbound usenet host'; st: L_STR; l: @icfg.usenethost; min: 0; max: 10),
	(s : 'Access req. to send EMail'; st: L_ATTRIB; l: @icfg.accsend),
	(s : 'Access req. to receive EMail'; st: L_ATTRIB; l: @icfg.accrecv),
	(s : 'EMail message headers'; st: L_TOGGLE0; l: @icfg.email_head; min:longint(@s_HeaderPos); max:2),
	(s : 'Usenet message headers'; st: L_TOGGLE0; l: @icfg.usenet_head; min:longint(@s_HeaderPos); max:2),
	(s : 'Send bounced messages to'; st: L_UPSTR; l: @icfg.postmaster; min: 0; max: 25),
	(s : 'Primary internet spool path'; st: L_PATH; l: @icfg.spool; min:0; max:41),
	(s : 'Default credits per KB'; st: L_WORD; l: @icfg.defcredits; min:0; max:65535),
	(s : 'Kill control messages'; st: L_BOOL; l: @icfg.killcontrols),
	(s : 'Hosts setup'; st: L_LINK; l: @d_hosts),
	(s : 'Name aliases'; st: L_LINK; l: @d_nalias) );

const d_inet: desctype = ( n: 16; d:'InterNet Importing and Exporting Setup';
				l:@m_inet; lt:T_CFGSCR);


const d_imparea : desctype = ( n:0; d:'IMPAREA'; l:nil; lt: T_EXTERNAL);
const d_exparea : desctype = ( n:0; d:'EXPAREA'; l:nil; lt: T_EXTERNAL);

const m_impexp : array [1..3] of menulisttype = (
	(s: 'Configuration Import / Exporting'; l: Nil),
	(s: 'Import AREAS.BBS into CatMail'; l: @d_imparea),
	(s: 'Export AREAS.BBS from CatMail'; l: @d_exparea) );

const d_impexp : desctype = ( n:3; d:'Import / Export Configuration'; l:@m_impexp; lt: T_MENULIST );



const d_stats_bbs   : desctype = ( n:0; d:'S_BBS'; l:nil; lt: T_EXTERNAL);
const d_stats_node  : desctype = ( n:0; d:'S_NODE'; l:nil; lt: T_EXTERNAL);
const d_stats_group : desctype = ( n:0; d:'S_GROUP'; l:nil; lt: T_EXTERNAL);

const m_stats : array [1..4] of menulisttype = (
	(s: 'Statistics'; l: Nil),
	(s: 'Display BBS statistics'; l: @d_stats_bbs),
	(s: 'Display statistics for a node'; l: @d_stats_node),
	(s: 'Display statistics for a group'; l: @d_stats_group) );

const d_stats : desctype = ( n:4; d:'Statistics Generation'; l: @m_stats; lt: T_MENULIST );

{ Level 0 menus }

const m_main : array [1..6] of menulisttype = (
	(s: 'General Configuration'; l: @d_gen),
	(s: 'FidoNet Configuration'; l: @d_fido),
	(s: 'InterNet Configuration'; l : @d_inet),
	(s: 'Message Area Setup'; l : @d_ac),
	(s: 'Statistics Generation'; l : @d_stats),
	(s: 'Import / Export Configuration'; l : @d_ImpExp) );

const d_main: desctype = ( n: 6; d:'CatMail Setup and Utilities Main Menu';
				l:@m_main; lt:T_MENULIST);


implementation

end.