unit slmenu;

interface


uses
	crt, dos,
	version, cfgdef, defs,
	putils, slenter, strznnp, strings, sldata, data, menus,
	general, filedef, sublist, message, ext;

var	cstrings : boolean;


procedure exec_menu(d : desctype);

implementation

type string20 = array [0..0] of string[20];
type ma = array [1..1] of cfgscrtype;


procedure pl_cfgscr(line : integer; aline : integer; m : cfgscrtype);
var
 lp : integer;
begin
	gotoxy(1, line+2);
	if m.st = L_NONE then
	begin
		textcolor(cf.colorchart[NORMAL]);
		writeln('     ',m.s)
	end
	else
	begin
		textcolor(cf.colorchart[ALTCOLOR]);
		write(aline:2,'. ');
		textcolor(cf.colorchart[NORMAL]);
		write(m.s);
		if (m.st = L_LINK) then
			write(' [...]')
		else
			for lp := length(m.s) to 31 do
				write('.');
	end;
end;


procedure fill_cfgscr(line : integer; m : cfgscrtype);
var
  np : ^byte;
  sp : aocp;
  bp : ^boolean;
  zp : ^znnp;
  szp : ^sysznnp;
  byp : ^byte;
  wop : ^word;
  lop : ^longint;
  lp : integer;
  s20p : ^string20;
  asp : ^attribset;
  s : string;
begin
	gotoxy(37, line+2);

	case m.st of
	  L_NONE:
		exit;

	  L_PATH, L_UPSTR, L_STR, L_FILE:
	  begin
		sp := m.l;
		s := fromnts(sp);
		if (m.max > 43) then
		begin
			textbackground(black);
			gotoxy(1, line+2);
			textcolor(cf.colorchart[ALTCOLOR]);
			write(line:2,'. ');
			textcolor(cf.colorchart[NORMAL]);
			write(m.s);
			for lp := length(m.s) to {34}31 do
				write('.');

			if highon then high else low;

			if highon then
			begin
				gotoxy(wherex-(m.max-45)-3, wherey);
				write(' ',s);
				fillsp(m.max-length(s));
				gotoxy(wherex-m.max, wherey);
			end
			else
			begin
				delete(s, 42, 1000);
				write(' ',s);
				if length(s) < length(fromnts(sp)) then write('');
				clreol;
				gotoxy(38, line+2);
			end;
		end
		else
		begin
			write(' ', s);
			if highon then
				fillsp(m.max-length(s)+1)
			else
				clreol;
			gotoxy(38, line+2);
		end;
	  end;

	  L_BYTE:
	  begin
		byp := m.l;
		write(' ',byp^:3,' ');
		if (highon) then
		begin
			textbackground(black);
			textcolor(lightgray);
			write(' (',m.min,'-',m.max,')');
			high;
		end else clreol;
		gotoxy(38, line+2);
	  end;

	  L_WORD:
	  begin
		wop := m.l;
		write(' ',wop^:5,' ');
		if (highon) then
		begin
			textbackground(black);
			textcolor(lightgray);
			write(' (',m.min,'-',m.max,')');
			high;
		end else clreol;
		gotoxy(38, line+2);
	  end;

	  L_LONG:
	  begin
		lop := m.l;
		write(' ',lop^:10,' ');
		if (highon) then
		begin
			textbackground(black);
			textcolor(lightgray);
			write(' (',m.min,'-',m.max,')');
			high;
		end else clreol;
		gotoxy(38, line+2);
	  end;

	  L_BOOL:
	  begin
		bp := m.l;
		yn( bp^ );
	  end;

	  L_ZNNP:
	  begin
		zp := m.l;
		write(' ',znnptostr(zp^),' ');
		if (not highon) then
			clreol;
		gotoxy(38, line+2);
	  end;

	  L_SYSZNNP:
	  begin
		szp := m.l;
		if szp^.t = DFidoNet then
			write(' ',znnptostr(szp^.z),' ')
		else
			write(' ',fromnts(@szp^.s),' ');

		if (not highon) then clreol;
		gotoxy(38, line+2);
	  end;

	  L_TOGGLE0, L_TOGGLE1:
	  begin
		np := m.l;
		s20p := pointer(m.min);
		write(' ',s20p^[np^],' ');
		if (not highon) then clreol else
		begin
			low; clreol; high;
		end;
	  end;

	  L_LINK:
	  begin
		gotoxy(1, line+2);
		textbackground(black);
		textcolor(cf.colorchart[ALTCOLOR]);
		write(line:2,'.');
		if highon then high else textcolor(cf.colorchart[NORMAL]);
		write(' ',m.s,' [...] ')
	  end;

	  L_ATTRIB:
	  begin
		asp := m.l;
		s := '';
		for lp := 1 to 24 do
			if lp in asp^ then
				s := s + chr(lp+64);

		write(' ', s);
		if highon then
			for lp := length(s) to 25 do
				write(' ')
		else
			clreol;
		gotoxy(38, line+2);
	  end;
	end;
end;

function do_cfgscr(d : desctype) : byte;
var
  ch : char;
  at : byte;
  mp : ^ma;
  boolp : ^boolean;
  lt : listtype;
  extd : boolean;
  tp : pointer;
  stp : aocp;
  btp : ^byte;
  wtp : ^word;
  ltp : ^longint;
  ztp : ^znnp;
  asp : ^attribset;
  sztp : ^sysznnp;
  ret : word;
  s   : string;
  n   : word;
  z   : znnp;
  lp  : integer;

label down, up, getstrpart;
begin
	mp := d.l;
	at := 1;
	high;
	fill_cfgscr(at, mp^[at]);

	while true do
	begin
		lt := mp^[at].st;
		extd := false;
		ch := readkey;
		case ch of
		  #0:
		  begin
			extd := true;
			ch := readkey;
			case ch of
			  #75,#77,#79{end},#71{home},#115{ctrlleft},#116{ctrlright},#83{delete}:
			  begin
				if (lt in [L_FILE,L_PATH,L_STR,L_UPSTR,L_ZNNP,L_ATTRIB,L_WORD,L_BYTE,L_LONG]) then
					goto getstrpart
				else
					goto down;
			  end;

			  #80:
			  begin
down:         	low;
				fill_cfgscr(at, mp^[at]);
				inc(at);
				if (at > d.n) then
					at := 1;
				high;
				fill_cfgscr(at, mp^[at]);
			  end;

			  #81:
			  begin
				low;
				fill_cfgscr(at, mp^[at]);
				inc(at, 4);
				if (at > d.n) then
					at := d.n;
				high;
				fill_cfgscr(at, mp^[at]);
			  end;

			  #72:
			  begin
up:             low;
				fill_cfgscr(at, mp^[at]);
				dec(at);
				if (at = 0) then
					at := d.n;
				high;
				fill_cfgscr(at, mp^[at]);
			  end;

			  #73:
			  begin
				low;
				fill_cfgscr(at, mp^[at]);
				if (at < 5) then at := 5;
					dec(at, 4);
				high;
				fill_cfgscr(at, mp^[at]);
			  end;
			end;
		  end;

		  #13:
		  begin
			if (lt = L_LINK) then
			begin
				exec_menu(desctype(mp^[at].l^));
				clrscr;
				textcolor(cf.colorchart[HEADCOLOR]);
				writeln(d.d);

				for n := 1 to d.n do
				begin
					pl_cfgscr(n, n, mp^[n]);
					fill_cfgscr(n, mp^[n]);
				end;

				high;
				fill_cfgscr(at, mp^[at]);
			end
			else
			begin
				if at = d.n then
				begin
					low;
					do_cfgscr := 255;
					exit;
				end
				else
					goto down;
			end;
		  end;

		  #32..#126:
		  begin
getstrpart:
			tp := mp^[at].l;
			stp := tp;
			btp := tp;
			wtp := tp;
			ltp := tp;
			ztp := tp;
			sztp := tp;

			ret := 0;

			if lt in [L_STR,L_FILE,L_PATH,L_UPSTR] then
			begin
				if cstrings then
					s := fromnts(stp)
				else
					s := stp^;

{				if mp^[at].max > 45 then
					gotoxy(wherex-(mp^[at].max-45)-3, wherey);}
			end;

			case lt of
			  L_STR:  s := getlinep(s, mp^[at].max, false, false, true, 0, 0, ret, ch, extd);
			  L_PATH:
			  begin
				s := getlinep(s, mp^[at].max, true, true, true, 0, 0, ret, ch, extd);
				if (s[length(s)] <> '\') then s:=s+'\';
			  end;
			  L_FILE:  s := getlinep(s, mp^[at].max, true, true, true, 0, 0, ret, ch, extd);
			  L_UPSTR: s := getlinep(s, mp^[at].max, true, false, true, 0, 0, ret, ch, extd);
			  L_BYTE:
			  begin
				str(btp^, s);
				s := getlinep(s, 3, false, false, true, mp^[at].min, mp^[at].max, ret, ch, extd);
				val(s, btp^, n);
			  end;
			  L_WORD:
			  begin
				str(wtp^, s);
				s := getlinep(s, 6, false, false, true, mp^[at].min, mp^[at].max, ret, ch, extd);
				val(s, wtp^, n);
			  end;
			  L_LONG:
			  begin
				str(ltp^, s);
				s := getlinep(s, 10, false, false, true, mp^[at].min, mp^[at].max, ret, ch, extd);
				val(s, ltp^, n);
			  end;
			  L_BOOL:
			  begin
				sb(boolean(mp^[at].l^));
				fill_cfgscr(at, mp^[at]);
			  end;
			  L_ZNNP:
			  begin
				s := znnptostr(ztp^);
				s := getlinep(s, 23, true, false, true, 0, 0, ret, ch, extd);
				if (strtoznnp(s, z) = true) then
					ztp^ := z;
			  end;
			  L_SYSZNNP:
			  begin
				if sztp^.t = DFidoNet then
					s := znnptostr(sztp^.z)
				else
					s := fromnts(@sztp^.s);
				s := getlinep(s, 23, true, false, true, 0, 0, ret, ch, extd);

				while pos(' ', s) > 0 do
					delete(s, pos(' ', s), 1);

				if (strtoznnp(s, z) = true) then
				begin
					sztp^.t := DFidoNet;
					sztp^.z := z;
				end
				else
				begin
					if (length(s) < 9) then
					begin
						sztp^.t := DInternet;
						tonts(s, sztp^.s);
					end;
				end;
			  end;
			  L_TOGGLE1:
			  begin
				inc(btp^);
				if (mp^[at].max < btp^) then
					btp^ := 1;
				fill_cfgscr(at, mp^[at]);
			  end;
			  L_TOGGLE0:
			  begin
				inc(btp^);
				if (mp^[at].max < btp^) then
					btp^ := 0;
				fill_cfgscr(at, mp^[at]);
			  end;
			  L_ATTRIB:
			  begin
				asp := tp;
				s := '';
				for lp := 1 to 24 do
					if lp in asp^ then
						s := s + chr(lp+64);

				s := getlinep(s, 24, true, false, true, 0, 0, ret, ch, extd);

				if s = 'ALL' then
					s := 'ABCDEFGHIJKLMNOPQRSTUVWX';

				asp^ := [];
				for lp := 1 to length(s) do
					asp^ := asp^ + [ord(s[lp])-64];
			  end;
			end;

			if lt in [L_STR,L_PATH,L_FILE,L_UPSTR] then
			begin
				stripspaces(s);
				if cstrings then
					tonts(s, stp^)
				else
					stp := aocp(@s);
			end;

			if ret = 27 then
			begin
				low;
				do_cfgscr := 255;
				exit;
			end;

			if ret = 72 then goto up;
			if ret in [1,80] then goto down;

		  end;

		  #27:
		  begin
			low;
			do_cfgscr := 255;
			exit;
		  end;
		end;
	end;
end;

procedure exec_listscr(d : desctype);
type pbyte = array [0..0] of byte;
type plst = array [1..1] of listscrtype;
var
  regs	: registers;
  lsd 	: ^lsdesctype;
  lst 	: ^plst;
  fptr 	: file;
  nptr	: file;
  buf, buf2	: ^pbyte;
  toprec  : word;
  cline : byte;
  zp	: ^znnp;
  szp	: ^sysznnp;
  lp	: integer;
  r		: integer;
  quit	: boolean;
  ch	: char;
  maxrec : word;
  ds	: ^desctype;
  s20p  : ^string20;
  bytep  : ^byte;
  s 	: string;

  movemode 	: longint;


  procedure putrline;
  var lp, pp, n : word;
  begin
	for lp := 1 to d.n do
	begin
		clreol;
		n := lst^[lp].off;
		case lst^[lp].t of
		  L_NONE: fillsp(lst^[lp].len);
		  L_WORD: write((buf^[n] + buf^[n+1] * 256):lst^[lp].len);
		  L_BYTE: write((buf^[n]):lst^[lp].len);
		  L_LONG: write((buf^[n] + (longint(buf^[n+1]) shl 8)
							+ (longint(buf^[n+2]) shl 16)
								+ (longint(buf^[n+3]) shl 24)):lst^[lp].len);

		  L_ZNNP:
		  begin
			zp := pointer(longint(buf)+n);
			write(znnptostr(zp^));
			gotoxy(wherex + ( lst^[lp].len - length(znnptostr(zp^))), wherey );
		  end;

		  L_SYSZNNP:
		  begin
			szp := pointer(longint(buf)+n);
			if szp^.t = DFidoNet then
				s := znnptostr(szp^.z)
			else
				s := fromnts(@szp^.s);
			write(s);
			gotoxy(wherex + ( lst^[lp].len - length(s) ), wherey);
		  end;

		  L_STR, L_UPSTR, L_PATH, L_FILE:
		  begin
			for pp := 0 to lst^[lp].len-1 do
			begin
				if (buf^[n+pp] = 0) then
				begin
					gotoxy( wherex + (lst^[lp].len)-pp, wherey );
					pp := lst^[lp].len-1
				end
				else
					write(chr(buf^[n+pp]));
			end;
		  end;

		  L_TOGGLE0, L_TOGGLE1:
		  begin
			s20p := lst^[lp].tog;
			write(s20p^[buf^[n]]);
			gotoxy(wherex + lst^[lp].len - length(s20p^[buf^[n]]), wherey );
		  end;

		  L_BOOL:
		  begin
			if buf^[n] = 0 then
				write('No ')
			else
				write('Yes');
		  end;

		  else
			write('?!');
		end;
	end;
  end;

  procedure putscr;
  var
    lp : integer;
	r  : word;
  begin
	seek(fptr, toprec*lsd^.recsize);

	for lp := 5 to 23 do
	begin
		blockread(fptr, buf^, lsd^.recsize, r);
		if (lsd^.recsize = r) then
		begin
			gotoxy(2, lp);
			clreol;
			putrline;
		end
		else
		begin
			for r := lp to 23 do begin gotoxy(2, r);clreol; end;
			lp := 23
		end;
	end;
  end;

  procedure putline(line : byte);
   var r : word;
  begin
	seek(fptr, (toprec+line)*lsd^.recsize);
	blockread(fptr, buf^, lsd^.recsize, r);
	if (lsd^.recsize = r) then
	begin
		gotoxy(2, line+5);
		clreol;
		putrline;
	end;
  end;

  procedure drawscreen;
  var lp : integer;
  begin
  	clrscr;
    heading(d.d);

	gotoxy(1,3);
	textcolor(cf.colorchart[SPECIAL]);
	write(' <ENTER> Edit entry   <F1> Add entry   <F2> Delete entry  <F3> Move');
    gotoxy(1,4);
	high;
    clreol;
	write(' ');
    for lp := 1 to d.n do
    begin
    	write(lst^[lp].d);
        fillsp(lst^[lp].len-length(lst^[lp].d));
	end;

    gotoxy(1,24);
    clreol;
    write('  Press [ESC] to Exit');
	low;

    putscr;
  end;

label reread;

begin
	regs.al := 1;
    regs.bh := 3;
	regs.ch := 4;
    regs.cl := 0;
    regs.dh := 22;
    regs.dl := 79;

    lsd := d.l;
    lst := lsd^.l;

	toprec := 0;
    cline := 0;
	movemode := 0;


reread:

	assign(fptr, lsd^.fn);
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
		rewrite(fptr, 1);

    maxrec := filesize(fptr) div lsd^.recsize;
	if (maxrec > 0) then dec(maxrec);

	if (toprec+cline > maxrec) then
		if (toprec > 0) then dec(toprec) else dec(cline);

	getmem(buf, lsd^.recsize+1);
	getmem(buf2, lsd^.recsize+1);

	drawscreen;

	quit := false;
	while not quit do
	begin
		gotoxy(1, cline+5);

		ch := readkey;
		case ch of
		  #0:
		  begin
			ch := readkey;
			case ch of
			  #59:
			  begin
				if movemode = 0 then
				begin
					fillchar(lsd^.tl^, lsd^.recsize, 0);

					{ oh, a lovely little patch exists here for silly programmers! }
					if (lsd^.dl = @d_i_areaz) then
					begin
						bytep := lsd^.tl;
						bytep^ := byte(MSActive);  { set it to MSActive! }
					end;

					ds := lsd^.dl;
					exec_menu(ds^);

					quit := false;
					bytep := lsd^.tl;
					for lp := 1 to lsd^.recsize do
					begin
						if bytep^ <> 0 then
						begin
							quit := true;
							lp := lsd^.recsize;
						end;
						inc(bytep);
					end;

					if quit = true then
					begin
						seek(fptr, 0);
						assign(nptr, 'NEWF.$$$');
						rewrite(nptr, 1);
						for lp := 0 to maxrec do
						begin
							{$i-} blockread(fptr, buf^, lsd^.recsize); {$I+}
							r := ioresult;

							if (lp = toprec+cline) then
								blockwrite(nptr, lsd^.tl^, lsd^.recsize);
							if r = 0 then
								blockwrite(nptr, buf^, lsd^.recsize);
						end;
						if toprec+cline = maxrec+1 then
							blockwrite(nptr, lsd^.tl^, lsd^.recsize);

						close(nptr);
						close(fptr);
						{$I-} erase(fptr); {$I+}
						rename(nptr, lsd^.fn);
						goto reread;
					end;

					close(fptr);
					goto reread;
				end;
			  end;

			  #60:
			  begin
				if (movemode = 0) and (filesize(fptr) > 0) and (toprec+cline <= maxrec) then
				begin
					clrscr;
					heading(d.d);
					write(#10'Are you sure you want to delete this item? ');
					if (bar_noyes = 'N') then
					begin
						close(fptr);
						goto reread;
					end;

					seek(fptr, 0);
					assign(nptr, 'NEWF.$$$');
					rewrite(nptr, 1);
					for lp := 0 to maxrec do
					begin
						blockread(fptr, buf^, lsd^.recsize);
						if (lp <> toprec+cline) then
							blockwrite(nptr, buf^, lsd^.recsize);
					end;
					close(nptr);
					close(fptr);
					{$I-} erase(fptr); {$I+}
					rename(nptr, lsd^.fn);
					goto reread;
				end;
			  end;

			  #61:
			  begin
				if (movemode = 0) and (toprec+cline <= maxrec) then
				begin
					gotoxy(1,3);
					textcolor(cf.colorchart[SPECIAL]);
					clreol;
					write('Put the cursor where want the item moved to, and press [ENTER].');
					movemode := toprec+cline+1;
					seek(fptr, (toprec+cline)*lsd^.recsize);
					blockread(fptr, buf2^, lsd^.recsize, r);
					textcolor(cf.colorchart[NORMAL]);
				end;
			  end;

			  #72:
			  begin
				if cline > 0 then
					dec(cline)
				else
				begin
					if (toprec > 0) then
					begin
						regs.ah := 7; {down}
						intr($10, regs);
						dec(toprec);
						putline(0);
					end;
				end;
			  end;

			  #71:
			  begin
				toprec := 0; cline := 0;
				putscr;
			  end;

			  #73:
			  begin
				if (toprec > 0) then
				begin
					if toprec > 18 then dec(toprec, 18) else toprec := 0;
					putscr;
				end else cline := 0;
			  end;

			  #79:
			  begin
				if maxrec > 16 then
				begin
					toprec := maxrec - 17;
					cline := 17;
				end
				else
				begin
					toprec := 0;
					cline := maxrec;
				end;
				putscr;
			  end;

			  #80:
			  begin
				if (toprec+cline <= maxrec) then
				begin
					if (cline < 18) then
						inc(cline)
					else
					begin
						regs.ah := 6;
						intr($10, regs);
						inc(toprec);
						putline(18);
					end;
				end;
			  end;

			  #81:
			  begin
				if (toprec+18 < maxrec) then
				begin
					inc(toprec, 18);
					if maxrec < toprec+cline then
						toprec := maxrec-18;
					putscr;
				end
				else
					cline := maxrec-toprec;
			  end;

			end;
		  end;

		  #13:
		  begin
			if (movemode > 0) then
			begin
				seek(fptr, 0);
				assign(nptr, 'NEWF.$$$');
				rewrite(nptr, 1);
				for lp := 0 to maxrec do
				begin
					blockread(fptr, buf^, lsd^.recsize);
					if lp = toprec+cline then
						blockwrite(nptr, buf2^, lsd^.recsize);
					if lp <> movemode-1 then
						blockwrite(nptr, buf^, lsd^.recsize);
				end;

				if toprec+cline = maxrec+1 then
					blockwrite(nptr, buf2^, lsd^.recsize);

				close(nptr);
				close(fptr);
				{$I-} erase(fptr); {$I+}
				rename(nptr, lsd^.fn);
				movemode := 0;

				goto reread;
			end
			else if (filesize(fptr) > 0) and (toprec+cline <= maxrec) then
			begin
				seek(fptr, (toprec+cline)*lsd^.recsize);
				blockread(fptr, lsd^.tl^, lsd^.recsize, r);

				ds := lsd^.dl;
				exec_menu(ds^);

				seek(fptr, (toprec+cline)*lsd^.recsize);
				blockwrite(fptr, lsd^.tl^, lsd^.recsize);

				drawscreen;
			end;
		  end;

		  #27:
		  begin
			if movemode > 0 then
			begin
				drawscreen;
				movemode := 0;
			end
			else
			  quit := true;
		  end;

		end;
	end;

	close(fptr);
	freemem(buf, lsd^.recsize+1);
	freemem(buf2, lsd^.recsize+1);
end;



procedure exec_cfgscr(d : desctype);
var
  lp : integer;
  n : byte;
  mp : ^ma;
  s : string;
  ds : ^desctype;
  pos : byte;
  ch : char;
begin
	pos := 1;
	mp := d.l;

	while true do
	begin
		clrscr;
		high;
		gotoxy(1, 24);
		write(' Press [ESC] When Done                ');
		gotoxy(40, 24);
		write('  Press F2 or ^Q to Restore Old Value  ');
		low;
		gotoxy(1,1);

		textcolor(cf.colorchart[HEADCOLOR]);
		writeln(d.d);

		for lp := 1 to d.n do
		begin
			pl_cfgscr(lp, lp, mp^[lp]);
			fill_cfgscr(lp, mp^[lp]);
		end;

		n := do_cfgscr(d);

		if n = 255 then
			exit;

		ds := mp^[n].l;
		exec_menu(ds^);
	end;
end;


procedure exec_menulist(d : desctype);
type ma = array [1..1] of menulisttype;
var
  lp : integer;
  n : byte;
  mp : ^ma;
  s : string;
  ds : ^desctype;
  pos : byte;
begin
	pos := 1;
	mp := d.l;

	while true do
	begin
		clrscr;
		textcolor(cf.colorchart[SPECIAL]);
		gotoxy((80-length(d.d)) div 2, 3);
		writeln(d.d);

		textcolor(cf.colorchart[ALTCOLOR]);
		s := 'Press [ESC] to Exit';
		gotoxy((80-length(s)) div 2, 24);
		write(s);

		textcolor(cf.colorchart[ALTCOLOR]);
		s := 'CMSETUP v'+_ver+';  Copyright (C)1994-1998 LastByte Software';
		gotoxy((80-length(s)) div 2, 4);
		writeln(s,#10);

		init_listmenu;
		for lp := 1 to d.n do
		begin
			if mp^[lp].l = Nil then
				desc_listmenu(mp^[lp].s)
			else
				add_listmenu(mp^[lp].s);
		end;

		n := disp_listmenu(pos);

		if n = 27 then
			exit;

		ds := mp^[n].l;

		exec_menu(ds^);
	end;
end;

type
	nodefixp = ^_nodefix;

	_nodefix = record
	  z		: znnp;
	  line  : string[70];
	  next	: nodefixp;
end;

var
	nodefix 	: nodefixp;


procedure add_nodefix(z : znnp; line : string);
var
	nf : nodefixp;
begin
	if (nodefix = nil) then
	begin
		new(nodefix);
		nf := nodefix;
	end
	else
	begin
		nf := nodefix;
		while nf^.next = nil do
			nf := nf^.next;
		new(nf^.next);
		nf := nf^.next;
	end;

	nf^.next := Nil;
	nf^.z := z;
	nf^.line := line;
end;

procedure make_nodefix;
var
	n 			: integer;
	pnf, nf 	: nodefixp;
	fptr		: file;
	net			: _netmail;
	s			: string;
begin
	if nodefix = Nil then
		exit;

	nf := nodefix;
	while nf <> Nil do
	begin
		if nf^.z.zone > 0 then
		begin
			assign(fptr, fromnts(@cfg.netpath)+strs(nnm)+'.MSG');
			rewrite(fptr, 1);

			n := ouraddr(nf^.z);

			fillchar(net, sizeof(net), 0);
			with net do
			begin
				tonts('CatMail', fromuser);
				tonts('AreaFix', touser);
				destnode := nf^.z.node;
				destnet := nf^.z.net;
				orignet := cfg.address[n].net;
				orignode := cfg.address[n].node;
				attrib := 257; { private, local }
			end;

			blockwrite(fptr, net, sizeof(net));

			s := #1'INTL '+strs(nf^.z.zone)+':'+
						   strs(nf^.z.net)+'/'+
						   strs(nf^.z.node)+' '+
						   strs(cfg.address[n].zone)+':'+
						   strs(cfg.address[n].net)+'/'+
						   strs(cfg.address[n].node)+#13;

			if nf^.z.point > 0 then
				s := s + #1'TOPT '+strs(nf^.z.point)+#13;

			if cfg.address[n].point > 0 then
				s := s + #1'FMPT '+strs(cfg.address[n].point)+#13;

			blockwrite(fptr, s[1], length(s));

			blockwrite(fptr, nf^.line[1], length(nf^.line));

			s := #13'---'#13#0;
			blockwrite(fptr, s[1], length(s));
			close(fptr);

{			writeln(znnptostr(nf^.z), '  ', nf^.line);}
		end;

		nf := nf^.next;
	end;

	while nodefix^.next <> Nil do
	begin
		pnf := nodefix;
		nf := nodefix^.next;

		if (nf^.next = Nil) then
		begin
			dispose(nf);
			pnf^.next := Nil;
		end
		else
		begin
			pnf := nf;
			nf := nf^.next;
		end;
	end;

	dispose(nodefix);
end;

procedure exec_msgarealist(d : desctype);
type pbyte = array [0..0] of byte;
type plst = array [1..1] of listscrtype;
var
  regs	: registers;
  lsd 	: ^lsdesctype;
  lst 	: ^plst;
  a		: _areacfg;
  buf	: ^pbyte;
  toprec  : word;
  cline : byte;
  zp	: ^znnp;
  r, y	: integer;
  quit	: boolean;
  ch	: char;
  maxrec : word;
  ds	: ^desctype;
  s20p  : ^string20;
  fptr, nptr	: file;
  nac	: _areacfg;

  linkf, tempf	: file;
  link	: _arealink;
  l, nl	: longint;
  tmpl	: _tmplink;
  appending	: boolean;
  tagged	: ^pbyte;
  ntagged	: longint;

  helptype 	: integer;

  function spawnslarea(slarea : string) : boolean;
  var
	p : setupptr;
  begin
	spawnslarea := false;

	fillchar(td_st, sizeof(td_st), 0);
	fillchar(td_est, sizeof(td_est), 0);

	if slarea = '' then
		exit;

	SubListInit(subboards, '');
	p := TempListIndex(slarea, Subboards);
	if p^.name <> slarea then
		exit;

	if opensub(p^.name, mainsub, [HEADERF]) = false then
		exit;

	readsubinfo(mainsub);

	move(mainsub.subinfo, td_st, sizeof(subtype));
	tonts(td_st.name, td_est.name);
	tonts(td_st.subsysop, td_est.subsysop);
	td_est.orig.zone := td_st.origzone;
	td_est.orig.net := td_st.orignet;
	td_est.orig.node := td_st.orignode;
	td_est.orig.point := td_st.origpoint;

	exec_menu(d_areasl);

	td_st.name := fromnts(@td_est.name);
	td_st.subsysop := fromnts(@td_est.subsysop);
	td_st.origzone := td_est.orig.zone;
	td_st.orignet := td_est.orig.net;
	td_st.orignode := td_est.orig.node;
	td_st.origpoint := td_est.orig.point;
	move(td_st, mainsub.subinfo, sizeof(subtype));

	changesub(mainsub);
	closesub(mainsub);
	spawnslarea := true;
  end;

  function addarea : boolean;
  var
	s, t	: string;
	pt		: string;
	ret		: word;
	areacfg	: _areacfg;
	p		: setupptr;
	sz		: sysznnp;
	z		: znnp;
	tptr	: text;

  begin
	fillchar(nac, sizeof(nac), 0);

    addarea := false;

	clrscr;
    heading('Add Message Area');

    writeln(#10);
	textcolor(cf.colorchart[NORMAL]);
	write('Enter the new Fidonet EchoMail or Usenet area name:'#13#10'  ');

	s := getlinep('', 39, true, false, false, 0, 0, ret, #0, true);
	writeln(#13#10);

	if s = '' then exit;

	t := ups(s);

	seek(fptr, 0);
	while (not eof(fptr)) do
	begin
		blockread(fptr, areacfg, sizeof(areacfg));
		if (ups(fromnts(@areacfg.tag)) = t) then
        begin
        	textcolor(cf.colorchart[ERRCOLOR]);
			write('Area ',s,' already exists!  ');
            pok;
            exit;
		end;
	end;

	tonts(s, nac.tag);

	if (pos('.', s) > 0) then
	begin
		textcolor(cf.colorchart[NORMAL]);
	    write('Is this a usenet area? ');
		if (bar_yesno = 'Y') then
			nac.isusenet := 1;
        writeln(#10);
	end;

	textcolor(cf.colorchart[NORMAL]);
	write('Enter the Searchlight area, if any: ');

	s := getlinep('', 8, true, false, false, 0, 0, ret, #0, true);
	writeln(#13#10);

	if ret = 27 then
	begin
		nac.tag[0] := #0;
		exit;
	end;

	if (s <> '') then
	begin
		SubListInit(subboards, '');
		textcolor(cf.colorchart[NORMAL]);

		p := templistindex(s, subboards);
		if (p = Nil) or (p^.name <> s) then
		begin
			write('Searchlight area ',s,' does not exist.  Create area? ');
			if (bar_yesno = 'Y') then
			begin
				textcolor(cf.colorchart[NORMAL]);
				write(#13#10#10'Enter the path to put the new Searchlight area or press [ENTER] for default:'#13#10'  ');
				pt := getlinep('', 44, true, true, false, 0, 0, ret, #0, true);
				fillchar(sz, sizeof(sz), 0);
				if addsub(s, fromnts(@nac.tag), sz, true, pt) then
					spawnslarea(s)
				else
				begin
					textcolor(cf.colorchart[NORMAL]);
					writeln(#13#10#10'Unable to create Searchlight area.  Make sure the path exists, and');
					writeln('you have at least one entry in your new area configuration.'#10);
					pok;
					nac.tag[0] := #0;
					exit;
				end;

				clrscr;
				textcolor(cf.colorchart[NORMAL]);
				write(#13#10#10'Enter the subboard list file to add, or [ESC] for none:'#13#10'  ');
				if cf.altprogpath = '' then
					pt := cf.progpath
				else
					pt := cf.altprogpath;
				pt := getlinep(pt+'MAIN.SUB', 44, true, true, false, 0, 0, ret, #0, true);
				if (pt <> '') and (ret <> 27) then
				begin
					assign(tptr, pt);
					{$i-} append(tptr); {$I+}
					if ioresult <> 0 then
					begin
						textcolor(cf.colorchart[NORMAL]);
						writeln(#13#10#10'Unable to write to subboard list file; file must already exist.'#10);
						pok;
					end
					else
					begin
						writeln(tptr, s);
						close(tptr);
					end;
				end;
			end;
		end
		else
		begin
			write('Searchlight area ',s,' *already* exists.  Continue? ');
			if (bar_noyes = 'N') then
			begin
				nac.tag[0] := #0;
				exit;
			end;
		end;
	end;

	tonts(s, nac.slarea);

	writeln;
	l := 0;
	repeat
		textcolor(cf.colorchart[NORMAL]);

		if nac.isusenet = 0 then
			write(#13#10'Enter the node number of your Fidonet hub')
		else
			write(#13#10'Enter the system name of your Usenet host');
		write(' or [ENTER] to skip:'#13#10'  ');

		s := getlinep('', 25, true, false, false, 0, 0, ret, #0, false);
		writeln;
		if s = '' then
			l := 1
		else
		begin
			if (nac.isusenet = 0) and (strtoznnp(s, z) = false) then
			begin
				writeln(#13#10'This node must be a valid Fidonet node.  Please enter your Fidonet uplink');
				writeln('for this area, or press X to skip.');
			end
			else if (nac.isusenet > 0) and
					((length(s) < 1) or (length(s) > 8) or (pos(':',s)>0)) then
			begin
				writeln(#13#10'The system you enter must be a valid UUCP system name which is between');
				writeln('one and eight characters in length.');
			end
			else
				l := 1;
		end;
	until l = 1;

	if (nac.isusenet = 0) and (s <> '') then
	begin
		write(#13#10'Do you wish to send an join AreaFix to your hub? ');
		if (bar_yesno = 'Y') then
			add_nodefix(z, '+'+fromnts(@nac.tag));
	end;

	if (s <> '') then
	begin
		nac.links := filesize(linkf);
		seek(linkf, nac.links);
		fillchar(link, sizeof(link), 0);
		if nac.isusenet = 0 then
		begin
			link.sz.t := dfidonet;
			link.sz.z := z;
		end
		else
		begin
			link.sz.t := dinternet;
			tonts(s, link.sz.s);
		end;

		link.Status := MSActive;
		blockwrite(linkf, link, sizeof(link));
	end;
  end;

  function deletearea : boolean;
  var
	a, b	: _areacfg;
	links 	: longint;
	l       : longint;
	link	: _arealink;
	ret		: word;
	s		: string;
	z		: znnp;

  begin
	deletearea := false;
	clrscr;
	heading(d.d);

	seek(fptr, (toprec+cline)*sizeof(a));
	blockread(fptr, b, sizeof(b));

	write(#10'Delete tag area ',b.tag,'? ');
	if (bar_noyes = 'N') then
		exit;

	seek(fptr, 0);
	assign(nptr, 'NEWF.$$$');
	rewrite(nptr, 1);
	for l := 0 to maxrec do
	begin
		blockread(fptr, a, sizeof(a));
		if (l <> toprec+cline) then
			blockwrite(nptr, a, sizeof(a))
		else
			links := a.links;
	end;
	close(nptr);
	close(fptr);
	{$I-} erase(fptr); {$I+}
	rename(nptr, lsd^.fn);

	if (b.isusenet = 0) and (links > 0) then
	begin
		textcolor(cf.colorchart[NORMAL]);
		write(#13#10#10'Do you wish to send an unjoin AreaFix to your hub? ');
		if (bar_yesno = 'Y') then
		begin
			textcolor(cf.colorchart[NORMAL]);
			writeln(#13#10#10'The following nodes were joined to ',b.tag,':');

			s := '';

			while links > 0 do
			begin
				seek(linkf, links);
				blockread(linkf, link, sizeof(link));
				links := link.next;

				if s <> '' then
					s := s + ', ';

				if (link.sz.t = DFidonet) then
					s := s + znnptostr(link.sz.z)
				else
					s := s + link.sz.s;

				if length(s) > 60 then
				begin
					writeln(s);
					s := '';
				end;
			end;

			writeln(s,'.');

			l := 0;
			repeat
				write(#13#10'Enter node to send AreaFix to [X for none]: ');
				s := getlinep('', 25, true, false, false, 0, 0, ret, #0, false);
				if s = 'X' then l := 1;
				if (s <> 'X') and (strtoznnp(s, z) = false) then
				begin
					writeln(#13#10'The node you send an AreaFix message to must be a valid Fidonet node.');
					writeln('Please enter your fidonet uplink for this area, or press X to quit.');
				end
				else
					l := 1;
			until l = 1;

			if (s <> 'X') then add_nodefix(z, '-'+b.tag);
		end;
	end;

	close(linkf);
	freemem(buf, lsd^.recsize+1);
	freemem(tagged, maxrec div 8 + 2);

	deletearea := true;
  end;


  function getns(var z : znnp; var s : string) : boolean;
  var
	ret		: word;

  begin
	getns := false;

	write(#13#10'Enter node or system name: ');

	s := getlinep('', 26, true, false, false, 0, 0, ret, #0, true);
	if s = '' then
		exit;

	writeln(#13#10);

	if (strtoznnp(s, z) = false) then
	begin
		z.zone := 0;
		if ((not (s[1] in ['A'..'Z'])) or (length(s) > 8)) then
		begin
			textcolor(cf.colorchart[ERRCOLOR]);
			write('Invalid node number or system name.  Press any key. ');
			readkey;
			exit;
		end;
	end
	else
	begin
		if (z.zone = 65535) or (z.net = 65535) or (z.node = 65535) or (z.point = 65535) then
		begin
			textcolor(Cf.colorchart[ERRCOLOR]);
			write('Wildcards are not permitted in node number entry. ');
			readkey;
			exit;
		end;
	end;

	getns := true;
  end;

  procedure addlink;
  var
	s 		: string;
	z		: znnp;
	a		: _areacfg;
	lp		: longint;

	function addlinknow(rec : longint; errbad : boolean) : boolean;
	begin
		addlinknow := false;

		seek(fptr, rec*sizeof(_areacfg));
		blockread(fptr, a, sizeof(a));
		l := a.links;
		nl := 0;
		while (l > 0) do
		begin
			seek(linkf, l);
			blockread(linkf, link, sizeof(link));
			if ( (z.zone = 0) and (link.sz.t = DInternet) and (fromnts(@link.sz.s) = s)) or
				 (z.zone <> 0) and (link.sz.t = DFidonet) and (addrcmp(link.sz.z, z)) then
			begin
				if (errbad) then
				begin
					textcolor(cf.colorchart[ERRCOLOR]);
					write('error - node already linked.  ');
					readkey;
				end;
				tagged^[rec div 8] := tagged^[rec div 8] and (255 - (1 shl (rec mod 8)));
				dec(ntagged);
				exit;
			end;

			nl := l;
			l := link.next;
		end;

		if (nl > 0) then
		begin
			seek(linkf, nl);
			link.next := filesize(linkf);
			blockwrite(linkf, link, sizeof(link));
		end
		else
		begin
			a.links := filesize(linkf);
			seek(fptr, rec*sizeof(_areacfg));
			blockwrite(fptr, a, sizeof(a));
		end;

		seek(linkf, filesize(linkf));
		fillchar(link, sizeof(link), 0);
		link.status := msactive;
		if (z.zone = 0) then
		begin
			link.sz.t := dinternet;
			tonts(s, link.sz.s);
		end
		else
		begin
			link.sz.t := dfidonet;
			link.sz.z := z;
		end;
		blockwrite(linkf, link, sizeof(link));

		addlinknow := true;
	end;

  begin
	clrscr;
	heading('Add uplink / downlink');
	if (ntagged > 0) then
	begin
		write(#10'Add link to ',ntagged,' marked records? ');
		if (bar_noyes = 'N') then
			exit;
		writeln;
		textcolor(cf.colorchart[NORMAL]);
	end;

	if (getns(z, s) = false) then
		exit;

	textcolor(cf.colorchart[NORMAL]);
	write('Processing... ');

	if (ntagged = 0) then
	begin
		if (addlinknow(toprec + cline, true) = false) then
			exit;
	end
	else
	begin
		for lp := 1 to maxrec do
		begin
			if tagged^[lp div 8] and (1 shl (lp mod 8)) > 0 then
				addlinknow(lp, false);
		end;
	end;

	write('done!  Press any key. ');
	readkey;
	exit;
  end;

  procedure dellink;
  var
	s 		: string;
	z		: znnp;
	a		: _areacfg;
	lp		: longint;
	done	: boolean;

	function dellinknow(rec : longint; errbad : boolean) : boolean;
	begin
		dellinknow := false;

		seek(fptr, rec*sizeof(_areacfg));
		blockread(fptr, a, sizeof(a));

		l := a.links;
		nl := 0;
		done := false;

		while (l > 0) do
		begin
			seek(linkf, l);
			blockread(linkf, link, sizeof(link));
			if ( (z.zone = 0) and (link.sz.t = DInternet) and (fromnts(@link.sz.s) = s)) or
				 (z.zone <> 0) and (link.sz.t = DFidonet) and (addrcmp(link.sz.z, z)) then
			begin
				if nl = 0 then
				begin
					a.links := link.next;
					seek(fptr, rec*sizeof(_areacfg));
					blockwrite(fptr, a, sizeof(a));
				end
				else
				begin
					seek(linkf, nl);
					l := link.next;
					blockread(linkf, link, sizeof(link));
					link.next := l;
					seek(linkf, nl);
					blockwrite(linkf, link, sizeof(link));
				end;

				done := true;
				l := 0;
			end
			else
			begin
				nl := l;
				l := link.next;
			end;
		end;

		if (not done) then
		begin
			tagged^[rec div 8] := tagged^[rec div 8] and (255 - (1 shl (rec mod 8)));
			dec(ntagged);

			if errbad then
			begin
				write('error - node not linked.  ');
				readkey;
			end;
		end;

		dellinknow := done;
	end;

  begin
	clrscr;
	heading('Delete uplink / downlink');
	if (ntagged > 0) then
	begin
		write(#10'Delete link from ',ntagged,' marked records? ');
		if (bar_noyes = 'N') then
			exit;
		writeln;
		textcolor(cf.colorchart[NORMAL]);
	end;

	if (getns(z, s) = false) then
		exit;

	textcolor(cf.colorchart[NORMAL]);
	write('Processing... ');

	if (ntagged = 0) then
	begin
		if (dellinknow(toprec + cline, true) = false) then
			exit;
	end
	else
	begin
		for lp := 1 to maxrec do
		begin
			if tagged^[lp div 8] and (1 shl (lp mod 8)) > 0 then
				dellinknow(lp, false);
		end;
	end;

	write('done!  Press any key. ');
	readkey;
	exit;
  end;

  procedure putrline(at : longint);
  var
	y : byte;
	s : string;
	l : longint;
	last : znnp;

  begin
	clreol;

	y := wherey;

	s := fromnts(@a.tag);

	if (a.isusenet = 1) then
		s := downstr(s);

	if (length(s) > 26) then
	begin
		delete(s, 1, length(s)-26);
		s := '<' + s;
	end;

	if (tagged^[at div 8] and (1 shl (at mod 8)) > 0) then
		write('*')
	else
		write(' ');

	write(s);
	gotoxy(30, y);
	write(a.slarea);
	gotoxy(40, y);
	write(a.group);
	gotoxy(49, y);

	s := '';
	fillchar(last, sizeof(last), 0);
	l := a.links;
	while (l <> 0) do
	begin
		if (l <= filesize(linkf)-sizeof(link)) then
			seek(linkf, l);

		blockread(linkf, link, sizeof(link));
		if (link.sz.t = DFidoNet) then
		begin
			s := s + pn(link.sz.z, last);
			move(link.sz.z, last, sizeof(last));
		end
		else
			s := s + downstr(fromnts(@link.sz.s));

		case link.Status of
		  MSActive:	s := s + ' ';
		  MSPaused: s := s + '! ';
		  MSNone:   s := s + #219+' ';
		end;

		if (length(s) > 30) then
		begin
			delete(s, 30, 1000);
			s := s + '>';
			l := 0;
		end
		else
			l := link.next;
	end;
	write(s);
  end;


  procedure putscr;
  var
	lp : integer;
	r  : word;
  begin
	seek(fptr, toprec*lsd^.recsize);
	for lp := 5 to 23 do
	begin
		blockread(fptr, a, sizeof(_areacfg), r);
		if (sizeof(_areacfg) = r) then
		begin
			gotoxy(1, lp);
			clreol;
			putrline(toprec+lp-5);
		end
		else
		begin
			for r := lp to 23 do begin gotoxy(1, r);clreol; end;
			lp := 23
		end;
	end;
  end;

  procedure putline(line : byte);
   var r : word;
  begin
	seek(fptr, (toprec+line)*sizeof(_areacfg));
	blockread(fptr, a, sizeof(_areacfg), r);
	if (sizeof(_areacfg) = r) then
	begin
		gotoxy(1, line+5);
		clreol;
		putrline(toprec+line);
	end;
  end;

  procedure drawhelpbar;
  begin
	gotoxy(1,3);
	textcolor(cf.colorchart[SPECIAL]);
	clreol;

	case helptype of
	  1:	write(' <ENTER>Edit <SP>Tag <F1>Add <F2>Del <F3>Join <F4>Unjoin <F5>SLArea <F6>More');
	  2:	write(' <T>Tag all  <U>Untag all  <I>Invert Tagged  <F6>More');
	end;
	low;
  end;

  procedure drawscreen;
  var lp : integer;
  begin
	clrscr;
	heading(d.d);

	drawhelpbar;
	gotoxy(1,4);
	high;
	clreol;
	write(' Area Tag                    SLArea    Group    Downlinks');

	gotoxy(1,24);
	clreol;
	write('  Press [ESC] to Exit');
	low;

	putscr;
  end;


  procedure MakeLinkCM(a : _areacfg);
  begin
	assign(tempf, '$LINK.CM');
	rewrite(tempf, 1);

	l := a.links;
	while (l > 0) do
	begin
		seek(linkf, l);
		blockread(linkf, link, sizeof(link));

		fillchar(tmpl, sizeof(tmpl), 0);

		tmpl.sz.t := link.sz.t;
		tmpl.status := link.status;
		if (link.sz.t = DFidoNet) then
			tmpl.sz.z := link.sz.z
		else
			move(link.sz.s, tmpl.sz.s, 10);

		blockwrite(tempf, tmpl, sizeof(tmpl));
		l := link.next;
	end;

	close(tempf);
  end;

  procedure EraseLinkCM;
  begin
	assign(tempf, '$LINK.CM');
	{$I-} erase(tempf); {$I+}
  end;

  procedure ReadLinkCM;
  var
   a : _areacfg;
  begin
	assign(tempf, '$LINK.CM');
	{$I-} reset(tempf, 1); {$I+}

	l := ioresult;

	move(lsd^.tl^, a, sizeof(_areacfg));

	if (l = 0) and (filesize(tempf) = 0) then
	begin
		a.links := 0;
		move(a, lsd^.tl^, sizeof(_areacfg));
		close(tempf);
		{$I-} erase(tempf); {$I+}
		l := 1;
	end;

	if l = 0 then
	begin
		nl := a.links;
		if nl = 0 then
			a.links := filesize(linkf);

		appending := (nl = 0);

		while not eof(tempf) do
		begin
			if not appending then
			begin
				l := nl;
				seek(linkf, l);
				blockread(linkf, link, sizeof(link));
				nl := link.next;
				if (nl = 0) then
				begin
					appending := true;
					nl := filesize(linkf);
				end;
			end
			else
			begin
				l := filesize(linkf);
				nl := l + sizeof(link);
			end;

			blockread(tempf, tmpl, sizeof(tmpl));

			fillchar(link, sizeof(link), 0);
			link.sz.t := tmpl.sz.t;
			link.status := tmpl.status;

			if (tmpl.sz.t = DFidoNet) then
				link.sz.z := tmpl.sz.z
			else
				move(tmpl.sz.s, link.sz.s, 10);

			link.next := nl;

			seek(linkf, l);
			blockwrite(linkf, link, sizeof(link));
		end;

		link.next := 0;
		seek(linkf, l);
		blockwrite(linkf, link, sizeof(link));

		close(tempf);
		{$I-} erase(tempf); {$I+}
	end;

	move(a, lsd^.tl^, sizeof(_areacfg));
{	seek(fptr, (toprec+cline)*lsd^.recsize);}
	blockwrite(fptr, lsd^.tl^, lsd^.recsize);
  end;


label reread;

begin					{ message area version }
	regs.al := 1;
	regs.bh := 3;
	regs.ch := 4;
	regs.cl := 0;
	regs.dh := 22;
	regs.dl := 79;

	lsd := d.l;
	lst := lsd^.l;

	nodefix := Nil;

	toprec := 1;
	cline := 0;

	helptype := 1;

reread:

	assign(fptr, lsd^.fn);
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
	begin
		rewrite(fptr, 1);
		fillchar(a, sizeof(a), 0);
		blockwrite(fptr, a, sizeof(a));
	end;

	assign(linkf, 'AREALINK.CM');
	{$i-} reset(linkf, 1); {$i+}
	if ioresult <> 0 then
	begin
		rewrite(linkf, 1);
		fillchar(link, sizeof(link), 0);
		blockwrite(linkf, link, sizeof(link));
	end;

	maxrec := filesize(fptr) div lsd^.recsize;
	dec(maxrec);

	getmem(buf, lsd^.recsize+1);
	getmem(tagged, maxrec div 8 + 2);

	fillchar(tagged^, maxrec div 8 + 2, 0);
	ntagged := 0;

	drawscreen;

	quit := false;
	while not quit do
	begin
		gotoxy(1, cline+5);

		ch := upcase(readkey);

		if (maxrec = 0) and (ch <> #0) and (ch <> #27) then
			ch := #255;

		case ch of
		#0:
		begin
			ch := readkey;

			if (maxrec = 0) and (ch <> #59) then
				ch := #0;

			case ch of
			  #59:
			  begin
				fillchar(lsd^.tl^, lsd^.recsize, 0);
				ds := lsd^.dl;

				addarea;
				if (fromnts(@nac.tag) <> '') then
				begin
					MakeLinkCM(nac);

					nac.export := Yes;
					nac.import := Yes;

					move(nac, lsd^.tl^, sizeof(nac));
					exec_menu(ds^);
					move(lsd^.tl^, nac, sizeof(nac));

					l := filesize(fptr);
					seek(fptr, l);
					blockwrite(fptr, nac, sizeof(nac));

					seek(fptr, l);
					ReadLinkCM;

					close(fptr);
					close(linkf);

					freemem(buf, lsd^.recsize+1);
					freemem(tagged, maxrec div 8 + 2);

					goto reread;
				end;

				drawscreen;
			  end;

			  #60:
			  begin
				if (deletearea = true) then
					goto reread;
				drawscreen;
			  end;

			  #61:
			  begin
				addlink;
				drawscreen;
			  end;

			  #62:
			  begin
				dellink;
				drawscreen;
			  end;

			  #63:
			  begin
				seek(fptr, (toprec+cline)*lsd^.recsize);
				blockread(fptr, a, sizeof(a));
				if spawnslarea(fromnts(@a.slarea)) = true then
					drawscreen;
			  end;

			  #64:
			  begin
				inc(helptype);
				if helptype = 3 then
					helptype := 1;
				drawhelpbar;
			  end;

			  #72:
			  begin
				if cline > 0 then
					dec(cline)
				else
				begin
					if (toprec > 1) then
					begin
						regs.ah := 7; {down}
						intr($10, regs);
						dec(toprec);
						putline(0);
					end;
				end;
			  end;

			  #71:
			  begin
				toprec := 1; cline := 0;
				putscr;
			  end;

			  #73:
			  begin
				if (toprec > 1) then
				begin
					if toprec > 18 then dec(toprec, 18) else toprec := 1;
					putscr;
				end else cline := 0;
			  end;

			  #79:
			  begin
				if maxrec > 16 then
				begin
					toprec := maxrec - 17;
					cline := 17;
				end
				else
				begin
					toprec := 1;
					cline := maxrec - 1;
				end;
				putscr;
			  end;

			  #80:
			  begin
				if (toprec+cline < maxrec) then
				begin
					if (cline < 18) then
						inc(cline)
					else
					begin
						regs.ah := 6;
						intr($10, regs);
						inc(toprec);
						putline(18);
					end;
				end;
			  end;

			  #81:
			  begin
				if (toprec+18 < maxrec) then
				begin
					inc(toprec, 18);
					if maxrec < toprec+cline then
						toprec := maxrec-18;
					putscr;
				end
				else
					cline := maxrec-toprec;
			  end;
			end;
		end;

		#13:
		begin
			seek(fptr, (toprec+cline)*lsd^.recsize);
			blockread(fptr, lsd^.tl^, lsd^.recsize, r);

			move(lsd^.tl^, a, sizeof(_areacfg));

			MakeLinkCM(a);

			ds := lsd^.dl;
			exec_menu(ds^);

			seek(fptr, (toprec+cline)*lsd^.recsize);
			ReadLinkCM;

			drawscreen;
		end;

		#32:
		begin
			if (tagged^[(toprec+cline) div 8] and (1 shl ((toprec+cline) mod 8)) > 0) then
				dec(ntagged)
			else
				inc(ntagged);

			tagged^[(toprec+cline) div 8] :=
				tagged^[(toprec+cline) div 8] xor (1 shl ((toprec+cline) mod 8));

			putline(cline);

			if (toprec+cline < maxrec) then
			begin
				if (cline < 18) then
					inc(cline)
				else
				begin
					regs.ah := 6;
					intr($10, regs);
					inc(toprec);
					putline(18);
				end;
			end;
		end;

		'T':
		begin
			fillchar(tagged^, maxrec div 8 + 2, 255);
			ntagged := maxrec;
			putscr;
		end;


		'U':
		begin
			fillchar(tagged^, maxrec div 8 + 2, 0);
			ntagged := 0;
			putscr;
		end;

		'I':
		begin
			for l := 0 to maxrec div 8 + 1 do
				tagged^[l] := not tagged^[l];
			ntagged := maxrec - ntagged;
			putscr;
		end;

		#27:	quit := true;

	  end;
	end;

	make_nodefix;

	close(fptr);
	close(linkf);
	freemem(buf, lsd^.recsize+1);
	freemem(tagged, maxrec div 8 + 2);
end;


















































procedure exec_grouplist(d : desctype);
type pbyte = array [0..0] of byte;
type plst = array [1..1] of listscrtype;
var
  regs		: registers;
  toprec  	: word;
  cline 	: byte;
  r, y		: integer;
  quit		: boolean;
  ch		: char;
  maxrec 	: word;
  s			: string;

  grpf, mbrf	: file;
  grp			: TGroupData;

  z			: znnp;
  l, nl		: longint;



  function AddGroup : string;
  var
	grp		: TGroupData;
	ret		: word;
	s, t	: string;

  begin
	AddGroup := '';

	clrscr;
	heading('Add Group Name');

	writeln(#10);
	textcolor(cf.colorchart[NORMAL]);
	write('Enter the new group name:'#13#10'  ');

	s := getlinep('', 9, true, false, false, 0, 0, ret, #0, true);
	writeln(#13#10);

	if s = '' then exit;

	t := ups(s);

	seek(grpf, 0);
	while (not eof(grpf)) do
	begin
		blockread(grpf, grp, sizeof(grp));
		if (ups(fromnts(@grp.group)) = t) then
		begin
			textcolor(cf.colorchart[ERRCOLOR]);
			write('Group ',s,' already exists!  ');
			pok;
			exit;
		end;
	end;

	AddGroup := s;
  end;

  function DeleteGroup : boolean;
  var
	grp			: TGroupData;
	l, links	: longint;

	ret			: word;
	s			: string;
	nptr		: file;

  begin
	DeleteGroup := false;
	clrscr;
	heading('Delete Group Name');

	seek(grpf, (toprec+cline)*sizeof(grp));
	blockread(grpf, grp, sizeof(grp));

	if (fromnts(@grp.group) = 'MANAGERS') then
	begin
		writeln(#10'The group MANAGERS is a system group which defines the CMFix nodes with');
		writeln('managerial rights.  This group therefore cannot be deleted.  If you want no');
		writeln('managers, take out all the entries under the group.'#10);
		pok;
		exit;
	end;

	write(#10'Are you sure you want to delete group ',fromnts(@grp.group),'? ');
	if (bar_noyes = 'N') then
		exit;

	seek(grpf, 0);
	assign(nptr, 'NEWG.$$$');
	rewrite(nptr, 1);
	for l := 0 to maxrec do
	begin
		blockread(grpf, grp, sizeof(grp));
		if (l <> toprec+cline) then
			blockwrite(nptr, grp, sizeof(grp))
		else
			links := grp.members;
	end;
	close(nptr);

	close(grpf);
	{$I-} erase(grpf); {$I+}
	rename(nptr, 'GRPLST.CM');

	DeleteGroup := true;
  end;


  function getns(var z : znnp; var s : string; allowwild : boolean) : boolean;
  var
	ret		: word;

  begin
	getns := false;

	write(#13#10'Enter node or system name: ');

	s := getlinep('', 26, true, false, false, 0, 0, ret, #0, true);
	if s = '' then
		exit;

	writeln(#13#10);

	if (strtoznnp(s, z) = false) then
	begin
		z.zone := 0;
		if ((not (s[1] in ['A'..'Z'])) or (length(s) > 8)) then
		begin
			textcolor(cf.colorchart[ERRCOLOR]);
			write('Invalid node number or system name.  Press any key. ');
			readkey;
			exit;
		end;
	end
	else
	begin
		if (allowwild = false) and ((z.zone = 65535) or (z.net = 65535) or (z.node = 65535) or (z.point = 65535)) then
		begin
			textcolor(Cf.colorchart[ERRCOLOR]);
			write('Wildcards are not permitted in node number entry. ');
			readkey;
			exit;
		end;
	end;

	getns := true;
  end;

  procedure addlink;
  var
	s 		: string;
	z		: znnp;
	lp		: longint;
	grp		: TGroupData;
	mbr		: _arealink;

	function addlinknow(rec : longint) : boolean;
	begin
		addlinknow := false;

		seek(grpf, rec*sizeof(grp));
		blockread(grpf, grp, sizeof(grp));
		l := grp.members;
		nl := 0;
		while (l > 0) do
		begin
			seek(mbrf, l);
			blockread(mbrf, mbr, sizeof(mbr));
			if ( (z.zone = 0) and (mbr.sz.t = DInternet) and (fromnts(@mbr.sz.s) = s)) or
				 (z.zone <> 0) and (mbr.sz.t = DFidonet) and (addrcmp(mbr.sz.z, z)) then
			begin
				textcolor(cf.colorchart[ERRCOLOR]);
				write('error - node already a member.  ');
				readkey;
				exit;
			end;

			nl := l;
			l := mbr.next;
		end;

		if (nl > 0) then
		begin
			seek(mbrf, nl);
			mbr.next := filesize(mbrf);
			blockwrite(mbrf, mbr, sizeof(mbr));
		end
		else
		begin
			grp.members := filesize(mbrf);
			seek(grpf, rec*sizeof(grp));
			blockwrite(grpf, grp, sizeof(grp));
		end;

		seek(mbrf, filesize(mbrf));
		fillchar(mbr, sizeof(mbr), 0);
		mbr.status := msactive;
		if (z.zone = 0) then
		begin
			mbr.sz.t := DInternet;
			tonts(s, mbr.sz.s);
		end
		else
		begin
			mbr.sz.t := DFidonet;
			mbr.sz.z := z;
		end;
		blockwrite(mbrf, mbr, sizeof(mbr));

		addlinknow := true;
	end;

  begin
	clrscr;
	heading('Add Group Member');

	if (getns(z, s, true) = false) then
		exit;

	textcolor(cf.colorchart[NORMAL]);
	write('Processing... ');

	if (addlinknow(toprec + cline) = false) then
		exit;

	write('done!  Press any key. ');
	readkey;
	exit;
  end;

  procedure dellink;
  var
	s 		: string;
	z		: znnp;
	lp		: longint;
	done	: boolean;
	grp		: TGroupData;
	mbr		: _arealink;

	function dellinknow(rec : longint) : boolean;
	begin
		dellinknow := false;

		seek(grpf, rec*sizeof(grp));
		blockread(grpf, grp, sizeof(grp));

		l := grp.members;
		nl := 0;
		done := false;

		while (l > 0) do
		begin
			seek(mbrf, l);
			blockread(mbrf, mbr, sizeof(mbr));
			if ( (z.zone = 0) and (mbr.sz.t = DInternet) and (fromnts(@mbr.sz.s) = s)) or
				 (z.zone <> 0) and (mbr.sz.t = DFidonet) and (addrcmp(mbr.sz.z, z)) then
			begin
				if nl = 0 then
				begin
					grp.members := mbr.next;
					seek(grpf, rec*sizeof(grp));
					blockwrite(grpf, grp, sizeof(grp));
				end
				else
				begin
					seek(mbrf, nl);
					l := mbr.next;
					blockread(mbrf, mbr, sizeof(mbr));
					mbr.next := l;
					seek(mbrf, nl);
					blockwrite(mbrf, mbr, sizeof(mbr));
				end;

				done := true;
				l := 0;
			end
			else
			begin
				nl := l;
				l := mbr.next;
			end;
		end;

		if (not done) then
		begin
			write('error - node not a member.  ');
			readkey;
		end;

		dellinknow := done;
	end;

  begin
	clrscr;
	heading('Delete Group Member');

	if (getns(z, s, true) = false) then
		exit;

	textcolor(cf.colorchart[NORMAL]);
	write('Processing... ');

	if (dellinknow(toprec + cline) = false) then
		exit;

	write('done!  Press any key. ');
	readkey;
	exit;
  end;

  procedure putrline(at : longint);
  var
	y : byte;
	s : string;
	l : longint;
	last : znnp;
	mbr  : _arealink;

  begin
	clreol;

	y := wherey;

	s := fromnts(@grp.group);

	if (length(s) > 26) then
	begin
		delete(s, 1, length(s)-26);
		s := '<' + s;
	end;

	write(' '+s);
	gotoxy(13, y);

	s := '';
	fillchar(last, sizeof(last), 0);
	l := grp.members;
	while (l <> 0) do
	begin
		if (l <= filesize(mbrf)-sizeof(mbr)) then
			seek(mbrf, l);

		blockread(mbrf, mbr, sizeof(mbr));
		if (mbr.sz.t = DFidoNet) then
		begin
			s := s + pn(mbr.sz.z, last);
			move(mbr.sz.z, last, sizeof(last));
		end
		else
			s := s + downstr(fromnts(@mbr.sz.s));

		case mbr.Status of
		  MSActive:	s := s + ' ';
		  MSPaused: s := s + '! ';
		  MSNone:   s := s + #219+' ';
		end;

		if (length(s) > 67) then
		begin
			delete(s, 67, 1000);
			s := s + '>';
			l := 0;
		end
		else
			l := mbr.next;
	end;
	write(s);
  end;


  procedure putscr;
  var
	lp : integer;
	r  : word;
  begin
	seek(grpf, toprec*sizeof(grp));
	for lp := 5 to 23 do
	begin
		blockread(grpf, grp, sizeof(grp), r);
		if (sizeof(grp) = r) then
		begin
			gotoxy(1, lp);
			clreol;
			putrline(toprec+lp-5);
		end
		else
		begin
			for r := lp to 23 do begin gotoxy(1, r);clreol; end;
			lp := 23
		end;
	end;
  end;

  procedure putline(line : byte);
   var r : word;
  begin
	seek(grpf, (toprec+line)*sizeof(grp));
	blockread(grpf, grp, sizeof(grp), r);
	if (sizeof(grp) = r) then
	begin
		gotoxy(1, line+5);
		clreol;
		putrline(toprec+line);
	end;
  end;

  procedure drawhelpbar;
  begin
	gotoxy(1,3);
	textcolor(cf.colorchart[SPECIAL]);
	clreol;

	write(' <F1>Add  <F2>Del  <F3>Join  <F4>Unjoin');
	low;
  end;

  procedure drawscreen;
  var lp : integer;
  begin
	clrscr;
	heading(d.d);

	drawhelpbar;
	gotoxy(1,4);
	high;
	clreol;
	write(' GroupName  Group Members');

	gotoxy(1,24);
	clreol;
	write('  Press [ESC] to Exit');
	low;

	putscr;
  end;

label reread;

begin					{ groups version }
	regs.al := 1;
	regs.bh := 3;
	regs.ch := 4;
	regs.cl := 0;
	regs.dh := 22;
	regs.dl := 79;

	toprec := 1;
	cline := 0;



reread:
	assign(grpf, 'GRPLST.CM');
	{$I-} reset(grpf, 1); {$I+}
	if ioresult <> 0 then
	begin
		rewrite(grpf, 1);
		fillchar(grp, sizeof(grp), 0);
		blockwrite(grpf, grp, sizeof(grp));

		tonts('MANAGERS', grp.group);
		blockwrite(grpf, grp, sizeof(grp));
	end;

	assign(mbrf, 'GRPMBR.CM');
	{$i-} reset(mbrf, 1); {$i+}
	if ioresult <> 0 then
	begin
		rewrite(mbrf, 1);
		fillchar(z, sizeof(z), 0);
		blockwrite(mbrf, z, sizeof(z));
	end;

	maxrec := filesize(grpf) div sizeof(grp);
	if (maxrec > 0) then dec(maxrec);

	drawscreen;

	quit := false;
	while not quit do
	begin
		gotoxy(1, cline+5);

		ch := upcase(readkey);
		case ch of
		#0:
		begin
			ch := readkey;
			case ch of
			  #59:
			  begin
				s := AddGroup;
				if (s <> '') then
				begin
					fillchar(grp, sizeof(grp), 0);
					tonts(s, grp.group);
					seek(grpf, filesize(grpf));
					blockwrite(grpf, grp, sizeof(grp));
					close(grpf);
					close(mbrf);

					goto reread;
				end;

				drawscreen;
			  end;

			  #60:
			  begin
				if (DeleteGroup = true) then
					goto reread;
				drawscreen;
			  end;

			  #61:
			  begin
				addlink;
				drawscreen;
			  end;

			  #62:
			  begin
				dellink;
				drawscreen;
			  end;

			  #72:
			  begin
				if cline > 0 then
					dec(cline)
				else
				begin
					if (toprec > 1) then
					begin
						regs.ah := 7; {down}
						intr($10, regs);
						dec(toprec);
						putline(0);
					end;
				end;
			  end;

			  #71:
			  begin
				toprec := 1; cline := 0;
				putscr;
			  end;

			  #73:
			  begin
				if (toprec > 1) then
				begin
					if toprec > 18 then dec(toprec, 18) else toprec := 1;
					putscr;
				end else cline := 0;
			  end;

			  #79:
			  begin
				if maxrec > 16 then
				begin
					toprec := maxrec - 17;
					cline := 17;
				end
				else
				begin
					toprec := 1;
					cline := maxrec;
				end;
				putscr;
			  end;

			  #80:
			  begin
				if (toprec+cline < maxrec) then
				begin
					if (cline < 18) then
						inc(cline)
					else
					begin
						regs.ah := 6;
						intr($10, regs);
						inc(toprec);
						putline(18);
					end;
				end;
			  end;

			  #81:
			  begin
				if (toprec+18 < maxrec) then
				begin
					inc(toprec, 18);
					if maxrec < toprec+cline then
						toprec := maxrec-18;
					putscr;
				end
				else
					cline := maxrec-toprec;
			  end;
			end;
		end;

		#27:	quit := true;

	  end;
	end;

	close(grpf);
	close(mbrf);
end;




procedure exec_menu(d : desctype);
begin
	low;
	case d.lt of
	  T_MENULIST: 	exec_menulist(d);
	  T_CFGSCR:     exec_cfgscr(d);
	  T_LISTSCR:	exec_listscr(d);
	  T_MSGAREA:	exec_msgarealist(d);
	  T_GROUPAREA:	exec_grouplist(d);
	  T_EXTERNAL:   exec_external(d.d);
	end;
end;




end.
