unit statlog;

interface

Const StatTypes = 64;
      StatRecs = 4;
      StatFileSpec = 'STATLOG.SL2';

Type Timetype = record   { time }
       hour: byte;
       minute: byte;
     end;

     Datetype = record   { date }
       year: byte;
       month: byte;
       day: byte;
     end;

     StatLogType = record
       Dates: array[1..StatRecs] of datetype;
       Times: array[1..StatRecs] of timetype;
       Data: Array[1..StatTypes,1..StatRecs] of longint;
     end;


{
The first three date/time stamps correspond to activity since midnight,
activity since last Sysop login, and activity since last global reset. The
fourth set of numbers is a continuous total which Searchlight stores, but
does not display or reset.

Only the first six of the 64 possible events is defined. The first six
values correspond to: total calls, new messages posted, new mail for sysop,
new users, files uploaded, and files downloaded, in that order.

Example:

    StatLogType.Data[4,2] equals the number of new users since the last
       sysop login (4=Number of new users, 2=Since last Sysop login)

    StatLogType.Data[2,1] equals number of new messages posted since
       midnight (2=New messages posted, 1=Since midnight)

    StatLogType.Dates[3] equals the date of the last global reset
    StatLogType.Times[3] equals the time of the last global reset

The event numbers beyond 6 are undefined, and should all be zero. The fourth
event level (ie. Data[x,4]) will return a total count for that event since
Searchlight 4.0 was installed.
}

implementation

end.
