unit data;

interface

uses filedef;

type znnp = record
	zone,net,node,point : word;
end;


const s_colour : array [0..15] of string[20]
	= ('Black','Blue','Green','Cyan','Red','Magenta','Brown','LightGray',
           'DarkGray','LightBlue','LightGreen','LightCyan','LightRed',
           'LightMagenta', 'Yellow', 'White' );

type o_mailer = ( NO_MAILER, FRONTDOOR, BINKLEY, DBRIDGE, PORTAL );
const s_mailer : array [No_Mailer..Portal] of string[20]
	= ('Undefined', 'FrontDoor', 'BinkleyTerm', 'DBridge', 'Portal');

type o_loglevel = ( None, Minimal, Terse, Average, Verbose, Debug );
const s_loglevel : array [None..Debug] of string[20]
	= ('None','Minimal','Terse','Average','Verbose','Debug' );

type o_fam = ( Ignore, UUEncode, FileAttach );
const s_fam : array [Ignore..FileAttach] of string[20]
	= ('Ignore', 'UUEncode', 'FileAttach' );

type o_uuda = ( uuda_ignore, Decode, DecodeDelete );
const s_uuda : array [uuda_ignore..DecodeDelete] of string[20]
	= ('Ignore', 'Decode', 'Decode Then Delete' );

type o_uudd = ( uudd_default, uudd_ignore, uudd_Decode, uudd_DecodeDelete );
const s_uudd : array [uudd_default..uudd_DecodeDelete] of string[20]
	= ('Default', 'Ignore', 'Decode', 'Decode Then Delete' );

type o_dupe = ( d_ignore, d_rename, d_kill );
const s_dupe : array [d_ignore..d_kill] of string[20]
	= ('Ignore', 'Rename', 'Kill' );

type o_fi = ( DFidoNet, DInternet );
const s_fi : array [DFidoNet..DInternet] of string[20]
	= ('FidoNet', 'Internet');

type o_pw = ( pw_password, pw_frontdoor, pw_db, pw_squish );
const s_pw : array [pw_password..pw_squish] of string[20]
	= ('Password', 'FroDoor PASSWORD.FD', 'DBridge SESSION.TXT', 'Squish SQUISH.CFG');

type o_dyn = ( default, yes, no );
const s_dyn : array [default..no] of string[20]
	= ('Default', 'Yes', 'No');

type o_sa = ( sa_leave, sa_trunc, sa_kill );
const s_sa : array [sa_leave..sa_kill] of string[20]
	= ('Leave', 'Truncate', 'Kill');

type o_msgstat = ( MSNone, MSActive, MSPaused );
const s_msgstat : array [MSNone..MSPaused] of string[20]
	= ('Disconnected', 'Active', 'Paused');

type NameType = (N_Real,N_Alias,N_Both,N_Reply,N_NotFound);
const s_nametype : array [N_Real..N_NotFound] of string[20]
	= ('Real Only', 'Alias Only', 'User Choice', 'Replies Only', 'Not Found' );

type Alias_t = (A_Inbound,A_InOut,A_MailList,A_Ignore,A_Forward,A_Redirect,A_Bounce);
const s_AliasType : array [A_Inbound..A_Bounce] of string[20]
	= ('Inbound Only', 'In/Outbound', 'Mailing List', 'Ignore', 'Forward', 'Redirect', 'Bounce' );
const s_AliasType2 : array [A_Inbound..A_Bounce] of string[20]
	= ('In Only', 'In/Out', 'MailList', 'Ignore', 'Forward', 'Redirect', 'Bounce' );


type THeaderPos = (H_None, H_Top, H_Bottom);
const s_HeaderPos : array [H_None..H_Bottom] of string[20]
	= ('Strip', 'At Top', 'At Bottom');

type TOriginType = ( O_Zone, O_Area );
const s_OriginType : array [O_Zone..O_Area] of string[20]
	= ('Zone', 'Area');


type sysznnp = record
	t		: o_fi;
	case integer of
		0: ( z		: znnp;
			 dummy 	: word; );
		1: ( s 	    : array [0..9] of char; );
end;


type _password = record
	z		: znnp;
	tipe	: o_pw;
	pw		: array [0..30] of char;
end;


type _origin = record
	zone	: word;
	area	: array [0..8] of char;
	line	: array [0..70] of char;
	t		: TOriginType;
end;

type _bink = record
	zone	: word;
	domain	: array [0..8] of char;
	path	: array [0..30] of char;
end;

type _areacfg = record
	tag		: array [0..39] of char;
	slarea	: array [0..9] of char;
	group	: array [0..9] of char;
	export	: o_dyn;
	import	: o_dyn;
	cstrip	: o_dyn;
	secure	: o_dyn;
	dupe	: o_dyn;
	uu		: o_uudd;

	isusenet: byte;
	changed : byte;

	links	: longint;

	freeze  : boolean;
	other	: array [1..3] of byte;

	deleted : byte;
end;

type _arealink = record
	Status	: o_msgstat;
	next	: longint;

	sz		: sysznnp;
end;

type _tmplink = record
	Status 	: o_msgstat;
	sz		: sysznnp;
end;



type _archive = record
	Name		: array [0..14] of char;
	IdLocation	: longint;
	IdString	: array [0..29] of char;
	CmdAdd		: array [0..79] of char;
	CmdExtract	: array [0..79] of char;
end;


type _areaidx = record
	TLeft, TRight, SLeft, SRight	: longint;
	TagCrc, SLAreaCRC				: longint;
	LastDate, LastUid				: longint;
end;

type _fix_alias = record
	alias			: array [0..34] of char;
end;

type _pack = record
	z		: znnp;
	name	: array [0..14] of char;
end;

type _netpath = record
	path	: array [0..44] of char;
	fixscan	: byte;
end;

type _mainstats = record
	mimport,
	kimport,
	mexport,
	kexport,
	firsttime 	: longint;
	extra       : array [1..10] of longint;
end;

type _nodestats = record
	sz			: sysznnp;
	msg_to,
	msg_from,
	k_to,
	k_from,
	dupes,
	first_time	: longint;
	extra		: array [1..10] of longint;
end;

type mysubtype = record
	name	: array [0..40] of char;
	path	: array [0..40] of char;
	subsysop: array [0..25] of char;
	orig	: znnp;
end;

type TGroupData = record
	group	: array [0..9] of char;
	members : longint;

	free	: array [1..2] of longint;
end;

type THosts = record
	name		: array [0..14] of char;
	postmaster  : array [0..59] of char;

	AllowEmailPassing : byte;

	other		: array [0..199] of char;
end;

type TNameAlias = record
	user		: array [0..24] of char;
	inetname	: array [0..69] of char;
	atype		: alias_t;
	forwardto	: array [0..69] of char;
end;

type TNewMsg = record
	from		: sysznnp;
	group		: array [0..9] of char;
	subfile		: array [0..44] of char;
	subdir		: array [0..44] of char;
	nothing		: array [0..59] of char;

	nameprefix	: array [0..8] of char;
	autoname	: boolean;
	makeslsub	: boolean;
	autocreate  : boolean;

	mn			: mysubtype;
	n			: subtype;
end;

type TVolCh = record
	addr		: array [0..49] of char;
	fi			: o_fi;
	credits		: longint;
end;


implementation
end.