{$O+}
{$F+}

unit putils;

interface

uses
	dos, crt,
	defs, strings, data,
	users, general, filedef, submaint, sublist;

const
	slcol	: array[0..16] of string[10] =
	  ( '\BK', '\BL', '\GR', '\CY', '\RD', '\MG', '\BR', '\GY', '\DG',
		'\LB', '\LG', '\LC', '\LR', '\LM', '\YE', '\WH', '' );


	nullz   : znnp = ( zone:0; net:0; node:0; point:0 );

type
	pchar = ^char;


function  get_origin_line(area : string; zone : word) : string;
function  ats(p : pchar) : string;
function  vals(s : string) : integer;
function  readstr(var fptr : file) : string;
function  strs(n : word) : string;
function  strsl(n : longint) : string;
function  strs2(n : word) : string;
function  strs4(n : word) : string;
procedure log(ch : char; msg : string);
procedure error(s : string);
function  ouraddr(a : znnp) : integer;
function  addsub(subboard, tag : string; origin : sysznnp; manual : boolean; path : string) : boolean;
function  addrcmp(a, b : sysznnp) : boolean;
function  saddrcmp(a, w : sysznnp) : boolean;

function  ihlt(subboard : string) : boolean;
function  ipos(subboard : string) : boolean;
function  gpos(subboard : string) : longint;
procedure upos(subboard : string; p : longint);
procedure uhlt(subboard : string);
procedure dpos(subboard : string);
procedure dhlt(subboard : string);

function  dectohex(l : longint) : string;
procedure uu_encode(f : string; p : pointer; eol : char; isbinary : boolean);
function  nnm : word;
function  ups(s : string) : string;

function  strlwr(s : string) : string;
function  GetInternetDate(date : datetype; time : timetype) : string;

procedure PrintStatus;

function  crc32(value: Byte; crc: LongInt): LongInt;

function  GetMoreHandles(NumHandles: Word): Boolean;

function  NameCaps(s : string) : string;

procedure yn(a : boolean);
procedure sb(var a : boolean);
procedure fillsp(n : byte);
function  sp(n : byte) : string;

function  WildCardMatch(s, w : string) : boolean;





function  read_cfg : boolean;
procedure write_cfg;
procedure quit;
function  access(s:string) : boolean;
procedure pok;

function  aword(s : string; n : integer) : string;
function  addslash(s : string) : string;

function  GetFileDate(fname : string) : longint;

implementation


function strlwr(s : string) : string;
var
  lp : integer;
begin
	for lp := 1 to length(s) do
		if s[lp] in ['A'..'Z'] then
			s[lp] := chr(ord(s[lp])+32);
	strlwr := s;
end;

function DayOfWeek(date : datetype) : string;
const
  dows : array [1..7] of string[5] =
	( 'Mon','Tue','Wed','Thu','Fri','Sat','Sun' );

var
	y1, y2, dow 	: word;


Begin
	if date.month < 3 then
	begin
		inc(date.month, 10);
		dec(date.year);
	end
	else
		dec(date.month, 2);

	y1 := date.year div 100;
	y2 := date.year mod 100;
	dow := ((date.day + trunc(2.6 * date.month - 0.1) + Y2 + Y2 div 4 + Y1 div 4 - 2 *
		   Y1 + 49) mod 7) + 1;
	DayOfWeek := dows[dow];
end;


function GetInternetDate(date : datetype; time : timetype) : string;
var
	dt : string;
begin
	dt := DayOfWeek(date) + ', ' +
		  strs2(date.day) + ' ' + mons[date.month] + ' ' +
		  strs2(date.year mod 100) + ' ' +
		  strs2(time.hour) + ':' + strs2(time.minute) + ':00 ';

	if getenv('TZ') = '' then
		dt := dt + 'GMT'
	else
		dt := dt + getenv('TZ');

	GetInternetDate := dt;
end;

function ats(p : pchar) : string;
var
	s : string;
begin
	s := '';
        while (p^ <> #0) do
        begin
        	s := s + p^;
                inc(p);
        end;
end;


function vals(s : string) : integer;
var
	n, p : integer;
begin
	n := -1;
	val(s, n, p);
	vals := n;
end;


function readstr(var fptr : file) : string;
var
	thing 	: string;
	ch	: char;
begin
        thing := '';
        repeat;
			blockread(fptr, ch, 1);
                if (ch > #0) then
			thing := thing + ch;
        until (ch = #0);	       

	readstr := thing;
end;


function strs(n : word) : string;
var	s : string;
begin
	str(n, s);
	strs := s;
end;

function strsl(n : longint) : string;
var	s : string;
begin
	str(n, s);
	strsl := s;
end;

function strs2(n : word) : string;
var	s : string;
begin
	str(n, s);
	if (s[0] = #1) then
		s := '0' + s;
	strs2 := s;
end;

function strs4(n : word) : string;
var	s : string;
begin
	str(n, s);
	while (length(s) < 4) do
		s := '0' + s;
	strs4 := s;
end;

procedure log(ch : char; msg : string);
var
	y, m, d, dow 	: word;
	h, n, s, ss		: word;
	logptr			: text;
begin
	y := ioresult;	{ clear result flag }

	getdate(y, m, d, dow);
	gettime(h, n, s, ss);

	assign(logptr, fromnts(@cfg.logfile));
    {$I-} append(logptr); {$I+}
	if ioresult <> 0 then
        	rewrite(logptr);

    writeln(logptr, ch+' '+strs2(d)+' '+mons[m]+' '+strs2(h)+':'+strs2(n)+
		':'+strs2(s)+' CMI  '+msg);

	close(logptr);
end;

procedure error(s : string);
begin
	writeln('   ! ', s);
	log('!', s);
end;

function ouraddr(a : znnp) : integer;
var lp	: integer;
begin
	for lp := 0 to 14 do
	begin
		if cfg.address[lp].zone = a.zone then
		begin
			ouraddr := lp;
			exit;
		end;
	end;
	ouraddr := 0;
end;


function addsub(subboard, tag : string; origin : sysznnp; manual : boolean; path : string) : boolean;
var
	ok	 	: boolean;
	sub	 	: subtype;
	tptr 	: text;
	iptr 	: file;
	lp   	: integer;
	na	 	: TNewMsg;
	s		: string;
	ma		: integer;

begin
	addsub := false;

	assign(iptr, fromnts(@cfg.cmpath)+'NEWAREA.CM');
	{$I-} reset(iptr, 1); {$I+}
	if ioresult <> 0 then
		exit;

	ok := false;
	while (not eof(iptr)) and (not ok) do
	begin
		blockread(iptr, na, sizeof(na));
		if addrcmp(na.from, origin) or manual then
			ok := true;
	end;

	close(iptr);

	if (not ok) or (not na.makeslsub and not manual) then exit;

	move(na.n, sub, sizeof(subtype));

	sub.name := fromnts(@na.mn.name);
	while pos('~', sub.name) > 0 do
		sub.name[pos('~', sub.name)] := ' ';

	sub.name := sub.name + tag;
	sub.subsysop := fromnts(@na.mn.subsysop);

	if origin.t = DFidonet then
	begin
		ma := ouraddr(origin.z);

		sub.origzone  := cfg.address[ma].zone;
		sub.orignet   := cfg.address[ma].net;
		sub.orignode  := cfg.address[ma].node;
		sub.origpoint := cfg.address[ma].point;
	end;

	if path = '' then
	begin
		path := fromnts(@na.subdir);
		delete(path, length(path), 1);
	end;

	ok := addsubboard(subboard, sub, path);
	if ok = false then exit;

	if not manual and (fromnts(@na.subfile) <> '') then
	begin
		assign(tptr, fromnts(@na.subfile));
		{$I-} append(tptr); {$I+}
		if (ioresult = 0) then
		begin
			writeln(tptr, subboard);
			close(tptr);
		end;
	end;

	addsub := true;
end;


function get_origin_line(area : string; zone : word) : string;
var
	fptr 	: file;
	origin 	: _origin;
	origin0	: string;

begin
	get_origin_line := '';
	origin0 := '';

	assign(fptr, fromnts(@cfg.cmpath)+'ORIGIN.CM');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
		exit;

	while not eof(fptr) do
	begin
		blockread(fptr, origin, sizeof(origin));
		if (origin.t = O_Area) and (fromnts(@origin.area) = area) then
		begin
			get_origin_line := fromnts(@origin.line);
			close(fptr);
			exit;
		end;

		if (origin.t = O_Zone) and (origin.zone = zone) then
			origin0 := fromnts(@origin.line);

		if (origin0 = '') and
		   ( ((origin.t = O_Zone) and (origin.zone = 0)) or
			 ((origin.t = O_Area) and (fromnts(@origin.line) = '')) ) then
			origin0 := fromnts(@origin.line);
	end;

	close(fptr);

	get_origin_line := origin0;
end;


procedure upos(subboard : string; p : longint);
var
	fptr : file;
begin
	assign(fptr, fromnts(@cfg.workpath)+subboard+'.POS');
	rewrite(fptr, 1);
	blockwrite(fptr, p, 4);
	close(fptr);
end;

procedure uhlt(subboard : string);
var
	fptr : file;
begin
	assign(fptr, fromnts(@cfg.workpath)+subboard+'.HLT');
	rewrite(fptr, 1);
	close(fptr);
end;


procedure dpos(subboard : string);
var
	fptr : file;
	a : integer;
begin
	assign(fptr, fromnts(@cfg.workpath)+subboard+'.POS');
	{$I-} erase(fptr); {$I+}

	a := ioresult;
end;

procedure dhlt(subboard : string);
var
	fptr : file;
	a : integer;
begin
	assign(fptr, fromnts(@cfg.workpath)+subboard+'.HLT');
	{$I-} erase(fptr); {$I+}

	a := ioresult;
end;


function ipos(subboard : string) : boolean;
var
	fptr : file;
begin
	assign(fptr, fromnts(@cfg.workpath)+subboard+'.POS');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult = 0 then
	begin
		close(fptr);
		ipos := true;
	end
	else
		ipos := false;
end;

function ihlt(subboard : string) : boolean;
var
	fptr : file;
begin
	assign(fptr, fromnts(@cfg.workpath)+subboard+'.HLT');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult = 0 then
	begin
		close(fptr);
		ihlt := true;
	end
	else
		ihlt := false;
end;


function gpos(subboard : string) : longint;
var
	fptr : file;
        p : longint;
begin
	gpos := 0;

	assign(fptr, fromnts(@cfg.workpath)+subboard+'.POS');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
		exit;

	{$I-} blockread(fptr, p, 4); {$I+}
	if ioresult <> 0 then
			exit;

	close(fptr);
	gpos := p;
end;


function dectohex(l : longint) : string;
var
	thing 	: string;
	o		: longint;
	poss	: array[1..8] of integer;
	lp		: integer;

const p16 : array[1..8] of longint = ( 268435456, 16777216, 1048576, 65535,
					4096, 256, 16, 1);
begin
	thing := '';
	for lp := 1 to 8 do
	begin
		poss[lp] := 0;

		while (l-p16[lp] >= 0) do
		begin
			l := l - p16[lp];
			inc(poss[lp]);
		end;

		if (poss[lp] < 10) then
			thing := thing + chr(poss[lp]+48)
		else
			thing := thing + chr(poss[lp]+87); { 55 for upcase }
	end;

	dectohex := thing;
end;

procedure uu_encode(f : string; p : pointer; eol : char; isbinary : boolean);
const
  offset = 32;
  charsperline = 60;
  bytesperhunk = 3;
  sixbitmask = $3f;
type
  str80 = string[80];
var
  x, y : byte;
  inf : file of byte;
  linelength, numbytes, bytesinline: integer;
  line: array [0..59] of char;
  hunk: array [0..2] of byte;
  chars: array [0..3] of byte;
  size : longint;
  bread : longint;

  bfl	: ^file;
  tfl	: ^text;

  s : string;
  c : char;

	procedure flushline;
	var
		i	: integer;
		s 	: string;
	begin
		if chr(bytesinline + offset) = ' ' then
			s := '`'
		else
			s := chr(bytesinline + offset);

		for i := 0 to pred(linelength) do
		begin
			if line[i] = ' ' then
				s := s + '`'
			else
				s := s + line[i];
		end;

		s := s + eol;
		if isbinary then
			blockwrite(bfl^, s[1], length(s))
		else
			write(tfl^, s);

		linelength := 0;
		bytesinline := 0
	end;

	procedure flushhunk;
	var i: integer;
	begin
		if linelength = charsperline then flushline;

		chars[0] := hunk[0] shr 2;
		chars[1] := (hunk[0] shl 4) + (hunk[1] shr 4);
		chars[2] := (hunk[1] shl 2) + (hunk[2] shr 6);
		chars[3] := hunk[2] and sixbitmask;

		for i := 0 to 3 do
		begin
			line[linelength] := chr((chars[i] and sixbitmask) + offset);
			inc(linelength);
		end;

		inc(bytesinline, numbytes);
		numbytes := 0
	end;

begin
	bytesinline := 0;
	linelength := 0;
	numbytes := 0;
	bread := 0;

	if isbinary then
		bfl := p
	else
		tfl := p;

	assign(inf, cf.attachpath+f);
	{$I-} reset(inf); {$I+}
	if ioresult <> 0 then
		exit;

	size := filesize(inf);

	writeln;
	write('         ==> Please wait, UUEncoding file... ');
	x := wherex;
	y := wherey;

	s := eol+'=> This is a CatMail attach UUEncoded file.  Cut out the lines between'+eol+
	  '=> and including the "begin" and "end" and use a UUDecoder to extract.'+eol+eol+
	  'begin 644 '+f+eol;

	if isbinary then
		blockwrite(bfl^, s[1], length(s))
	else
		write(tfl^, s);

	while not eof(inf) do
	begin
		if numbytes = bytesperhunk then
		begin
			flushhunk;
			gotoxy(x, y);
			write( ((bread * 100) div size) : 3, '%')
		end;

		read(inf, hunk[numbytes]);
		inc(numbytes);
		inc(bread);
	end;

	if numbytes > 0 then
		flushhunk;

	if linelength > 0 then
	begin
		flushline;
		flushline;
	end
	else
		flushline;

	s := 'end'+eol;
	if isbinary then
		blockwrite(bfl^, s[1], 4)
	else
		write(tfl^, s);

	gotoxy(x, y);
	writeln('done!');
	close(inf);
end;



function nnm : word;
var
	f	: searchrec;
	s	: string;
	n, nn, tn	: word;

begin
	tn := 1;
	findfirst(fromnts(@cfg.netpath)+'*.MSG', 0, f);
	while doserror = 0 do
	begin
		s := f.name;
		s[0] := chr(pos('.',s) - 1);
		val(s, n, nn);
		if (tn < n) then
			tn := n;

		findnext(f);
	end;

	inc(tn);
	nnm := tn;
end;

procedure PrintStatus;
var
	o : longint;
    s : string;
    x, y : word;
begin
    x := wherex;
    y := wherey;

    window(1, 1, 80, 25);

    gotoxy(3, 4);
	if (EscapeOn) then
    	write('[ESC]')
    else
    	write('     ');

    o := memavail div 1024;
    str(o, s);
    while length(s) < 4 do
    	s := ' ' + s;

    gotoxy(73, 4);
    write('['+s+'k]');

    window(1, 6, 80, 25);
	gotoxy(x, y);
end;


function crc32(value: Byte; crc: LongInt): LongInt;
Const
  crc32_table : Array[0..255] of LongInt = (
    $00000000, $77073096, $ee0e612c, $990951ba, $076dc419, $706af48f,
    $e963a535, $9e6495a3, $0edb8832, $79dcb8a4, $e0d5e91e, $97d2d988,
    $09b64c2b, $7eb17cbd, $e7b82d07, $90bf1d91, $1db71064, $6ab020f2,
    $f3b97148, $84be41de, $1adad47d, $6ddde4eb, $f4d4b551, $83d385c7,
    $136c9856, $646ba8c0, $fd62f97a, $8a65c9ec, $14015c4f, $63066cd9,
    $fa0f3d63, $8d080df5, $3b6e20c8, $4c69105e, $d56041e4, $a2677172,
    $3c03e4d1, $4b04d447, $d20d85fd, $a50ab56b, $35b5a8fa, $42b2986c,
    $dbbbc9d6, $acbcf940, $32d86ce3, $45df5c75, $dcd60dcf, $abd13d59,
    $26d930ac, $51de003a, $c8d75180, $bfd06116, $21b4f4b5, $56b3c423,
    $cfba9599, $b8bda50f, $2802b89e, $5f058808, $c60cd9b2, $b10be924,
    $2f6f7c87, $58684c11, $c1611dab, $b6662d3d, $76dc4190, $01db7106,
    $98d220bc, $efd5102a, $71b18589, $06b6b51f, $9fbfe4a5, $e8b8d433,
    $7807c9a2, $0f00f934, $9609a88e, $e10e9818, $7f6a0dbb, $086d3d2d,
    $91646c97, $e6635c01, $6b6b51f4, $1c6c6162, $856530d8, $f262004e,
    $6c0695ed, $1b01a57b, $8208f4c1, $f50fc457, $65b0d9c6, $12b7e950,
    $8bbeb8ea, $fcb9887c, $62dd1ddf, $15da2d49, $8cd37cf3, $fbd44c65,
    $4db26158, $3ab551ce, $a3bc0074, $d4bb30e2, $4adfa541, $3dd895d7,
    $a4d1c46d, $d3d6f4fb, $4369e96a, $346ed9fc, $ad678846, $da60b8d0,
    $44042d73, $33031de5, $aa0a4c5f, $dd0d7cc9, $5005713c, $270241aa,
    $be0b1010, $c90c2086, $5768b525, $206f85b3, $b966d409, $ce61e49f,
    $5edef90e, $29d9c998, $b0d09822, $c7d7a8b4, $59b33d17, $2eb40d81,
    $b7bd5c3b, $c0ba6cad, $edb88320, $9abfb3b6, $03b6e20c, $74b1d29a,
    $ead54739, $9dd277af, $04db2615, $73dc1683, $e3630b12, $94643b84,
    $0d6d6a3e, $7a6a5aa8, $e40ecf0b, $9309ff9d, $0a00ae27, $7d079eb1,
    $f00f9344, $8708a3d2, $1e01f268, $6906c2fe, $f762575d, $806567cb,
    $196c3671, $6e6b06e7, $fed41b76, $89d32be0, $10da7a5a, $67dd4acc,
    $f9b9df6f, $8ebeeff9, $17b7be43, $60b08ed5, $d6d6a3e8, $a1d1937e,
    $38d8c2c4, $4fdff252, $d1bb67f1, $a6bc5767, $3fb506dd, $48b2364b,
    $d80d2bda, $af0a1b4c, $36034af6, $41047a60, $df60efc3, $a867df55,
    $316e8eef, $4669be79, $cb61b38c, $bc66831a, $256fd2a0, $5268e236,
    $cc0c7795, $bb0b4703, $220216b9, $5505262f, $c5ba3bbe, $b2bd0b28,
    $2bb45a92, $5cb36a04, $c2d7ffa7, $b5d0cf31, $2cd99e8b, $5bdeae1d,
    $9b64c2b0, $ec63f226, $756aa39c, $026d930a, $9c0906a9, $eb0e363f,
    $72076785, $05005713, $95bf4a82, $e2b87a14, $7bb12bae, $0cb61b38,
    $92d28e9b, $e5d5be0d, $7cdcefb7, $0bdbdf21, $86d3d2d4, $f1d4e242,
    $68ddb3f8, $1fda836e, $81be16cd, $f6b9265b, $6fb077e1, $18b74777,
    $88085ae6, $ff0f6a70, $66063bca, $11010b5c, $8f659eff, $f862ae69,
    $616bffd3, $166ccf45, $a00ae278, $d70dd2ee, $4e048354, $3903b3c2,
    $a7672661, $d06016f7, $4969474d, $3e6e77db, $aed16a4a, $d9d65adc,
    $40df0b66, $37d83bf0, $a9bcae53, $debb9ec5, $47b2cf7f, $30b5ffe9,
	$bdbdf21c, $cabac28a, $53b39330, $24b4a3a6, $bad03605, $cdd70693,
    $54de5729, $23d967bf, $b3667a2e, $c4614ab8, $5d681b02, $2a6f2b94,
    $b40bbe37, $c30c8ea1, $5a05df1b, $2d02ef8d
  );

begin
  crc32 := crc32_table[Byte(crc xor LongInt(value))] xor
             ((crc shr 8) and $00ffffff);
end;


function GetMoreHandles(NumHandles: Word): Boolean;
{
  NumHandles is the number of file handles you want your application
  to have available.  If an error occurs, function will return False,
  and any DOS error will be reported in the DOSError global variable.
  NOTE: NumHandles must be less than or equal to the number specified
  in the FILES= statement in your CONFIG.SYS.
}
Var
  ReturnVal: Boolean;
begin
  ReturnVal := True;   { assume success }

  { Check to make sure DOS version is greater than 3.3 }
  if (((DOSVersion and $00FF) = 3) and ((DOSVersion and $FF00) < 3)) or
     ((DOSVersion and $00FF) < 3) then ReturnVal := False;
  { Can't allocate more than 255 or less than 20 handles }
  if (NumHandles > 255) or (NumHandles < 20) then ReturnVal := False;
  if ReturnVal then asm
    mov ax, 6700h           { function 67h }
    mov bx, NumHandles      { requested handles in bx }
    int 21h                 { DOS call }

    jae @@NotAnError        { CF set on error }
    mov ReturnVal, 00h      { return false on error }
    mov DOSError, ax        { ax contains the error code }
    @@NotAnError:
  end;
  GetMoreHandles := ReturnVal;
end;

function NameCaps(s : string) : string;
var
  down	: boolean;
  lp	: integer;
begin
	down := false;

	for lp := 1 to length(s) do
	begin
		if (s[lp] in ['A'..'Z']) then
		begin
			if down = true then
				s[lp] := chr(ord(s[lp]) or 32);
			down := true;
		end
		else
			down := false;
	end;

	NameCaps := s;
end;


function addrcmp(a, b : sysznnp) : boolean;
begin
	addrcmp := false;
	if (a.t <> b.t) then exit;

	if (a.t = DFidoNet) and
	  ( (a.z.zone <> b.z.zone) or (a.z.net <> b.z.net) or
		(a.z.node <> b.z.node) or (a.z.point <> b.z.point)) then exit;

	if (a.t = DInternet) and (ups(fromnts(@a.s)) <> ups(fromnts(@b.s))) then exit;

	addrcmp := true;
end;

function saddrcmp(a, w : sysznnp) : boolean;
begin
	saddrcmp := false;

	if (a.t <> w.t) then exit;

	if (a.t = DFidoNet) and
	  ( ((a.z.zone <> w.z.zone) and (w.z.zone <> 65535)) or
		((a.z.net <> w.z.net) and (w.z.net <> 65535)) or
		((a.z.node <> w.z.node) and (w.z.node <> 65535)) or
		((a.z.point <> w.z.point)) and (w.z.point <> 65535)) then exit;

	if (a.t = DInternet) and
		(not WildCardMatch(ups(fromnts(@a.s)), ups(fromnts(@w.s)))) then exit;

	saddrcmp := true;
end;



function ups(s : string) : string;
var
	lp : integer;
begin
	for lp := 1 to length(s) do
		s[lp] := upcase(s[lp]);
	ups := s;
end;



procedure yn(a : boolean);
begin
	if a = true then
		write(' Yes ')
	else
		write(' No  ');
end;

procedure sb(var a : boolean);
begin
	if a = false then
		 a := true
	else
		 a := false;
end;


procedure fillsp(n : byte);
begin
	write(sp(n));
end;

function sp(n : byte) : string;
var
	s : string;
begin
	fillchar(s[1], n, 32);
	s[0] := chr(n);

	sp := s;
end;

function WildCardMatch(s, w : string) : boolean;
var
	sn, wn : integer;
begin
	WildCardMatch := false;
	sn := 1;

	for wn := 1 to length(w) do
	begin
		if (w[wn] = '*') and (wn = length(w)) then
		begin
			WildCardMatch := true;
			exit;
		end;

		if sn > length(s) then
			exit;

		case w[wn] of

		  '?':	inc(sn);

		  '*':
		  begin
			dec(sn);
			repeat
				inc(sn);

				while (w[wn+1] <> s[sn]) and (sn <= length(s)) do
					inc(sn);

				if sn > length(s) then
					exit;
			until WildCardMatch(copy(s, sn, 255), copy(w, wn+1, 255));

			WildCardMatch := true;
			exit;
		  end;

		  else
		  begin
			if w[wn] <> s[sn] then
				exit
			else
				inc(sn);
		  end;
		end;
	end;

	WildCardMatch := true;
end;




function read_cfg : boolean;
var fptr : file;
begin
	read_cfg := false;
	assign(fptr, 'cfg.cm');
	{$I-} reset(fptr, 1); {$I+}
    if ioresult = 0 then
    begin
		if filesize(fptr) <> sizeof(cfg) then
		begin
			close(fptr);
			writeln('Your CFG.CM file is of an incorrect size, indicating it is either corrupt or');
			writeln('is for an old version of CatMail.  Please delete this file and re-install.');
			halt(6);
		end;

		blockread(fptr, cfg, sizeof(cfg));
		close(fptr);
		read_cfg := true;

		if (cfg.id <> cfg_cm_id) then
		begin
			writeln('Your CatMail configuration file, CFG.CM is now obsolete.');
			writeln('Please delete CFG.CM and rerun CMSETUP.');
			halt(6);
		end;
	end;

	assign(fptr, 'icfg.cm');
	{$I-}reset(fptr, 1);{$I+}
	if ioresult = 0 then
	begin
		if filesize(fptr) <> sizeof(icfg) then
		begin
			close(fptr);
			writeln('Your ICFG.CM file is of an incorrect size, indicating it is either corrupt or');
			writeln('is for an old version of CatMail.  Please delete this file and re-install.');
			halt(6);
		end;

		blockread(fptr, icfg, sizeof(icfg));
		close(fptr);

		if (icfg.id <> icfg_cm_id) then
		begin
			writeln('Your CatMail configuration file, ICFG.CM is now obsolete.');
			writeln('Please delete ICFG.CM and rerun CMSETUP.');
			halt(6);
		end;
	end;
end;

procedure write_cfg;
var fptr : file;
begin
	assign(fptr, 'cfg.cm');
	rewrite(fptr, 1);
	blockwrite(fptr, cfg, sizeof(cfg));
	close(fptr);

	move(icfg_cm_id, icfg.id, 10);

	assign(fptr, 'icfg.cm');
	rewrite(fptr, 1);
	blockwrite(fptr, icfg, sizeof(icfg));
	close(fptr);
end;

procedure quit;
begin
	clrscr;
	textcolor(cf.colorchart[NORMAL]);
    writeln('Thank you for using CatMail!');
	writeln('Copyright (C)1994-1998 LastByte Software.  All rights reserved.');
    halt(0);
end;

function access(s : string) : boolean;
var f : file;
begin
	assign(f, s);
	{$I-} reset(f, 1); {$I+}
	if ioresult = 0 then
	begin
		access := true;
		close(f);
	end
	else
		access := false;
end;

procedure pok;
begin
	write('Press any key... ');
    readkey;
    writeln
end;


function aword(s : string; n : integer) : string;
var
	n1, n2 : integer;
	inq : boolean;
	t   : string;
label mq;

begin
	inq := false;
	while ((s[1] = ' ') or (s[1] = #9)) and (length(s) > 0) do
		delete(s, 1, 1);

	while (n > 1) do
	begin
mq:
		while (s[1] <> ' ') and (s[1] <> #9) and (s[1] <> '"') and (length(s) > 0) do
			delete(s, 1, 1);

		if (s[1] = '"') and (length(s) > 0) then
		begin
			delete(s, 1, 1);
			while (s[1] <> '"') and (length(s) > 0) do
				delete(s, 1, 1);
			delete(s, 1, 1);
			goto mq;
		end;

		while ((s[1] = ' ') or (s[1] = #9)) and (length(s) > 0) do
			delete(s, 1, 1);

		if (s = '') then
		begin
			aword := '';
			exit;
		end;

		dec(n);
	end;

	t := '';

	while ((inq = true) or ((s[1] <> #9) and (s[1] <> ' '))) and (length(s) > 0) do
	begin
		if (s[1] = '"') then
		begin
			delete(s, 1, 1);
			if (inq = true) then
				inq := false
			else
				inq := true;
		end
		else
		begin
			t := t + s[1];
			delete(s, 1, 1);
		end;
	end;

	stripspaces(t);
	aword := t;
end;

function addslash(s : string) : string;
begin
	if s[length(s)] <> '\' then
		s := s + '\';
	addslash := s;
end;

function GetFileDate(fname : string) : longint;
var
	sr		: searchrec;
begin
	findfirst(fname, 0, sr);
	if DosError <> 0 then
	begin
		GetFileDate := 0;
		exit;
	end;

	GetFileDate := sr.time;
end;


end.
