unit strznnp;

interface

uses crt, dos, data, putils, strings;

function strtoznnp(thing : string; var z : znnp) : boolean;
function StrToZnnpO(s : string; var z : znnp; old : znnp) : boolean;
function znnptostr(z : znnp) : string;
function znnptostrnp(z : znnp) : string;
function addrcmp(a, b : znnp) : boolean;
function pn(z, oz : znnp) : string;

function sztostr(sz : sysznnp) : string;

const	nullz : znnp = ( zone:0; net:0; node:0; point:0 );

implementation


function vals(s : string) : word;
var w : word; n : integer;
begin
	val(s, w, n);
	vals := w;
end;

function strtoznnp(thing : string; var z : znnp) : boolean;
begin
	strtoznnp := strtoznnpo(thing, z, nullz);
end;

function znnptostr(z : znnp) : string;
var s : string;
begin
	if (z.zone = 65535) then s := '*:' else s := strs(z.zone)+':';
	if (z.net = 65535) then s := s + '*/' else s := s + strs(z.net)+'/';
	if (z.node = 65535) then s := s + '*' else s := s + strs(z.node);
	if (z.point > 0) then
		if (z.point = 65535) then s := s + '.*' else s := s + '.' + strs(z.point);
	znnptostr := s;
end;

function znnptostrnp(z : znnp) : string;
var s : string;
begin
	if (z.zone = 65535) then s := '*:' else s := strs(z.zone)+':';
	if (z.net = 65535) then s := s + '*/' else s := s + strs(z.net)+'/';
	if (z.node = 65535) then s := s + '*' else s := s + strs(z.node);
	znnptostrnp := s;
end;


function addrcmp(a, b : znnp) : boolean;
begin
	addrcmp := (a.zone = b.zone) and (a.net = b.net) and (a.node = b.node) and (a.point = b.point);
end;


function StrToZnnpO(s : string; var z : znnp; old : znnp) : boolean;
var
	t 	: string;
	pz	: boolean;
	n   : integer;
begin
	if s = '*' then
		s := '*:*/*.*';

	if (pos('/', s) = 0) and (pos(':', s) <> 0) then
		s := s + '/*.*';

	pz := false;
	if pos('.', s) = 0 then
	begin
		s := s + '.0';
		pz := true;
	end;

	z := old;

	n := pos(':', s);
	if n > 0 then
	begin
		t := copy(s, 1, n-1);
		delete(s, 1, n);

		if (ups(t) = 'ALL') or (t = '*') then
			z.zone := 65535
		else
			val(t, z.zone, n);
	end;

	n := pos('/', s);
	if n > 0 then
	begin
		t := copy(s, 1, n-1);
		delete(s, 1, n);

		if (ups(t) = 'ALL') or (t = '*') then
			z.net := 65535
		else
			val(t, z.net, n);
	end;

	n := pos('.', s);
	if n > 0 then
	begin
		t := copy(s, 1, n-1);
		delete(s, 1, n);

		if (ups(t) = 'ALL') or (t = '*') then
			z.node := 65535
		else
			val(t, z.node, n);
	end;

	if (z.node = 65535) and pz then
		z.point := 65535
	else
	begin
		t := s;

		if (ups(t) = 'ALL') or (t = '*') then
			z.point := 65535
		else
			val(t, z.point, n);
	end;

	strtoznnpo := (z.zone > 0) and (z.net > 0);
end;

function pn(z, oz : znnp) : string;
var
	s : string;
	zone, net, node, point : string[7];
begin
	if z.zone = 65535 then zone := '*' else str(z.zone, zone);
	if z.net  = 65535 then net  := '*' else str(z.net, net);
	if z.node = 65535 then node := '*' else str(z.node, node);
	if z.point= 65535 then point:= '*' else str(z.point, point);

	if (oz.zone <> z.zone) then
		s := zone+':'+net+'/'+node

	else if (oz.net <> z.net) then
		s := net+'/'+node

	else if (oz.node <> z.node) then
		s := node

	else
		s := '';

	if (z.point > 0) then
		s := s + '.' + point;

	pn := s;
end;

function sztostr(sz : sysznnp) : string;
begin
	if sz.t = DFidonet then
		sztostr := znnptostr(sz.z)
	else
		sztostr := fromnts(@sz.s);
end;


end.