
uses
	crt, dos, overlay,
	defs, cfgdef,
	slin, slout, netout, putils, areas, inetout, version;


var
	i, j    : integer;
	n	: word;
	s	: string;


	ec 	: integer;	{ exit code }

procedure read_cfg;
var
	fptr 	: file;
	s 		: string;
begin
	s := getenv('CM');
	if (s <> '') then
	begin
		if (s[length(s)] <> '\') then
			s := s + '\';
	end;

	assign(fptr, s+'CFG.CM');
    {$I-} reset(fptr, 1); {$I+}
    if (ioresult <> 0) then
    begin
    	writeln;
        writeln('This program must be executed as part of CatMail.');
        halt(30);
    end;

	blockread(fptr, cfg, sizeof(_cfg));
	close(fptr);

	assign(fptr, s+'ICFG.CM');
	{$I-} reset(fptr, 1); {$I+}
	if ioresult = 0 then
	begin
		blockread(fptr, icfg, sizeof(icfg));
		close(fptr);
	end;
end;

procedure WindowSetup;
var
  y : word;
begin
	y := wherey;
	if y < 6 then y := 6;
	window(1, 6, 80, 25);
	gotoxy(1, y-5);
end;

procedure Failed;
begin
	writeln('  ! Call to constructor failed, CME.CME [',paramstr(1),'].');
	writeln('     Check that your SLBBS environment variable is set correctly.');
end;


  function wordtohex(w : word) : string;
  const
	p : array [0..15] of char = '0123456789ABCDEF';
  begin
	  wordtohex :=  p[w shr 12] + p[(w shr 8) and $f] +
					p[(w shr 4) and $f] + p[w and $f];
  end;



var
	oldexitproc : pointer;

{$F+}
procedure cme_exit;
var
	fptr 			: text;
	h, m, s, dum 	: word;
	yr, mo, da		: word;

  function strs2(n : word) : string;
  var	s : string;
  begin
	  str(n, s);
	  if (s[0] = #1) then
		  s := '0' + s;
	  strs2 := s;
  end;


begin
	exitproc := oldexitproc;

	if (erroraddr <> Nil) then
	begin
		gettime(h, m, s, dum);
		getdate(yr, mo, da, dum);

		dum := ioresult;

		assign(fptr, '!RUNTIME.LOG');
		{$I-} append(fptr); {$I+}
		if ioresult <> 0 then
		begin
			rewrite(fptr);
			writeln(fptr, 'Runtime error log.  Please send this');
			writeln(fptr, 'log to Roger Nesbitt at roger@lastbyte.co.nz for attention.');
			writeln(fptr);
		end;

		writeln(fptr, strs2(da)+mons[mo]+strs2(yr)+' '+
					  strs2(h)+':'+strs2(m)+':'+strs2(s)+'  v'+_ver+'  '+
					  'Critical error ',exitcode,' at ',
					  wordtohex(seg(erroraddr)),':',wordtohex(ofs(erroraddr)));
		close(fptr);
	end;
end;




const
	maxFile = 40;

var
	OutMsg				: ^TOutMsg;

	ps32, ps34, ps36	: word;

	puffer				: array [1..maxFile] of byte;

	IncreaseFileHandles_exit : pointer;

procedure RestoreFileHandles;
begin
  memw[prefixseg:$32] := ps32;
  memw[prefixseg:$34] := ps34;
  memw[prefixseg:$36] := ps36;

  exitproc := IncreaseFileHandles_exit;
end;

procedure IncreaseFileHandles;
var
	index		: integer;
begin
{  IncreaseFileHandles_exit := exitproc;
  exitproc := @RestoreFileHandles;}

  for index := 1 to maxFile do
	puffer[index] := $FF;

  for index := 1 to 5 do
	puffer[index] := mem[prefixseg:$18 + pred(index)];

  ps32 := memw[prefixseg:$32];
  ps34 := memw[prefixseg:$34];
  ps36 := memw[prefixseg:$36];

  memw[prefixseg:$32] := maxFile;
  memw[prefixseg:$34] := ofs(puffer);
  memw[prefixseg:$36] := seg(puffer);
end;

var
	lp	: integer;

begin
	IncreaseFileHandles;

	ovrinit('CME.OVR');
	ovrinitems;

	checkbreak := false;

	oldexitproc := exitproc;
	exitproc := @cme_exit;

	mons[1] := 'Jan';  mons[2] := 'Feb';  mons[3] := 'Mar';
	mons[4] := 'Apr';  mons[5] := 'May';  mons[6] := 'Jun';
	mons[7] := 'Jul';  mons[8] := 'Aug';  mons[9] := 'Sep';
	mons[10] := 'Oct';  mons[11] := 'Nov';  mons[12] := 'Dec';

	EscapeOn := false;
	WindowSetup;
	PrintStatus;

	read_cfg;
	randomize;

	if Area.ReadIDX = false then
	begin
		writeln(' ! Unable to open the area files.  Run CMSETUP.EXE to set up areas.');
		halt(1);
	end;

	for lp := 1 to paramcount do
	begin
		s := paramstr(lp);
		ec := 31;

		if (s = 'Import') then
			ec := cmi(false);
		if (s = 'Export') then
		begin
			new(OutMsg, MsgOpen);
			if (OutMsg = Nil) then
			begin
				failed;
				ec := 1;
			end
			else
			begin
				ec := OutMsg^.Scan;
				dispose(OutMsg, MsgClose);
			end;
		end;

		if (s = 'ExportMail') then
			ec := ExportMail;

		if (s = 'ImportMail') then
			ec := cmi(true);

		if ec > 0 then
			lp := paramcount;
	end;

	Area.CloseIDX;

	halt(ec);
end.
