unit inetout;	{ internet mail exporting routines }

interface

uses crt, dos, filedef, users, putils, sublist, message, general, block,
		strings, defs, msgs, data;

type msgtype_t = ( TNone, TEmail, TUsenet );

var
	msgsize		: longint;

	MsgTo, FileName	: string;

	header		: headertype;


function  GetAlias(s : string) : string;

procedure WriteDAT;
procedure WriteCMD;
procedure WriteXQT;

procedure WriteLOG;

function ExportIMessage(recnum : longint) : boolean;


implementation

var
	msg			: msgptr;
	lastalias, lastaliasname : string;

function GetAlias(s : string) : string;
var
  lp : integer;
  fptr : file;
  na : TNameAlias;
begin
	if (s = lastaliasname) then
	begin
		GetAlias := lastalias;
		exit;
	end;

	lastaliasname := s;

	upstr(s);

	assign(fptr, fromnts(@cfg.cmpath)+'ALIAS.CM');
	{$i-} reset(fptr, 1); {$I+}
	if ioresult = 0 then
	begin
		while not eof(fptr) do
		begin
			blockread(fptr, na, sizeof(na));

			if (s = fromnts(@na.user)) and (na.atype = A_InOut) then
			begin
				lastalias := fromnts(@na.inetname);
				close(fptr);

				GetAlias := lastalias;
				exit;
			end;
		end;

		close(fptr);
	end;

	s := strlwr(s);
	for lp := 1 to length(s) do
		if s[lp] = ' ' then
			s[lp] := '.';
	lastalias := s;
	GetAlias := lastalias;
end;



procedure WriteDAT;
var
  outf		: text;
  outfb		: file;
  cd		: datetype;
  ct		: timetype;
  result	: longint;
  lp 		: integer;
  cdt		: string;
  hosts		: string;

begin
	hosts := fromnts(@icfg.emailhost);

	assign(outf, fromnts(@icfg.spool)+hosts+'\'+filename+'.DAT');
	rewrite(outf);

	dosdate(cd); dostime(ct);
	cdt := GetInternetDate(cd, ct);

	write(outf, 'From '+fromnts(@icfg.returnaddr)+'!'+GetAlias(header.from)+' '+cdt+' remote from '+fromnts(@icfg.uucpname)+#10);

{$IFDEF Registered}
	write(outf, 'Received: by '+fromnts(@icfg.uucpname)+' (CatMail '+strs4(RegistrationNumber)+')'+
					' with UUCP id '+filename+' for '+MsgTo+'; '+cdt+#10);
{$ELSE}
	write(outf, 'Received: by '+fromnts(@icfg.uucpname)+' (CatMail UNREGISTERED)'+
					' with UUCP id '+filename+' for '+MsgTo+'; '+cdt+#10);
{$ENDIF}

	write(outf, 'To: '+MsgTo+#10);
	write(outf, 'From: '+GetAlias(header.from)+'@'+fromnts(@icfg.address)+' ('+NameCaps(header.from)+')'+#10);
	write(outf, 'Subject: '+header.subj+#10);
	write(outf, 'Message-ID: <MAIL.'+dectohex(header.id[UID])+
				'@'+fromnts(@icfg.address)+'>'#10);
	write(outf, 'Date: '+GetInternetDate(header.date, header.time)+#10);
	write(outf, 'Organization: '+cf.systemname+#10#10);

	for lp := 2 to msg^.msglen do
		write(outf, MsgLine(msg, lp)+#10);

	if header.fattach <> '' then
		uu_encode(header.fattach, @outf, #10, false);

	close(outf);

	assign(outfb, fromnts(@icfg.spool)+hosts+'\'+filename+'.DAT');
	reset(outfb, 1);
	msgsize := filesize(outfb);
	close(outfb);

	disposemsg(msg);

end;

procedure WriteCMD;
var
	outf 	: text;
	s  		: string;
begin
	s := fromnts(@icfg.emailhost);

	assign(outf, fromnts(@icfg.spool)+s+'\'+filename+'.CMD');
	rewrite(outf);

	s := copy(GetAlias(header.from), 1, 4);

	write(outf, 'S '+filename+'.dat D.'+fromnts(@icfg.uucpname)+filename+' '+
				s+' - '+filename+'.dat 0666'#10);
	write(outf, 'S '+filename+'.xqt X.'+fromnts(@icfg.uucpname)+filename+' '+
				s+' - '+filename+'.xqt 0666'#10);

	close(outf);
end;

procedure WriteXQT;
var
	outf	: text;
	s1, s2	: string;
begin
	s1 := fromnts(@icfg.emailhost);

	assign(outf, fromnts(@icfg.spool)+s1+'\'+filename+'.XQT');
	rewrite(outf);

	s2 := fromnts(@icfg.uucpname)+filename;

	s1 := GetAlias(header.from);

	write(outf, 'U '+s1+' '+fromnts(@icfg.uucpname)+#10);
	write(outf, 'Z'#10'e'#10);
	write(outf, 'R '+s1+#10);
	write(outf, 'J '+s2+#10);

	write(outf, 'F D.'+s2+#10);
	write(outf, 'I D.'+s2+#10);

	write(outf, 'C rmail '+MsgTo+#10);

	close(outf);
end;

procedure WriteLOG;
var
 fptr : text;
begin
	assign(fptr, fromnts(@cfg.inetlogfile));
	{$I-} append(fptr); {$I-}
	if ioresult <> 0 then
		rewrite(fptr);

	writeln(fptr, 'OUT,,',MsgTo,',',header.from,',',GetAlias(header.from)+'.'+fromnts(@icfg.address),',',msgsize);

	close(fptr);
end;


function ExportIMessage(recnum : longint) : boolean;
var
  s			: string;
  size		: longint;
  lp		: integer;
begin
	ExportIMessage := true;

	unpackmsg(header.txt, msg, true);
	MsgTo := strlwr(MsgLine(msg, 1));

	if CheckAccess(header, header.from) = false then
	begin
		readblockfile(mainsub.headrf, recnum, @header);
		header.attribute := 2;
		writeblockfile(mainsub.headrf, recnum, @header);

		exit;
	end;

	s := copy(MsgTo, pos('@', MsgTo)+1, 255);
	size := 0;
	for lp := 1 to msg^.msglen do
		inc(size, LineLength(msg, lp));

	if CheckCredits(header, msg, header.from, s, size+512) = false then
	begin
		readblockfile(mainsub.headrf, recnum, @header);
		header.attribute := 2;
		writeblockfile(mainsub.headrf, recnum, @header);

		exit;
	end;

	filename := dectohex(random(65535));
	upstr(filename);
	delete(filename, 1, 4);

	WriteCMD;
	WriteXQT;
	WriteDAT;

	WriteLOG;

	readblockfile(mainsub.headrf, recnum, @header);
	header.attribute := 2;
	writeblockfile(mainsub.headrf, recnum, @header);
end;



end.
