{$O+ $F+}

unit netout;

interface

uses
	crt, dos,
	inetout,
	areas, defs, putils, msgs, data, strings, strznnp, version,
	filedef, sublist, users, message, post, block;


function ExportMail : byte;

implementation

var
	IMsgsExported		: word;
	NMsgsExported		: word;

procedure OpenReqFiles;
var
	fptr 	: file;
	p		: setupptr;
begin
	if not openfiles([CONFIGF,NODESF]) or not openuserfile then
		halt(32);

	if not sublistinit(subboards, '') then
		halt(32);

	p := templistindex('MAIL', subboards);
	if (p = nil) or (p^.name <> 'MAIL') then
	begin
		writeln;
		writeln('   ! Can''t locate the MAIL conference.');
		log('!', 'Cannot locate the Searchlight MAIL conference.');
		halt(32);
	end;

	if not opensub('MAIL', mainsub, allfiles) then
	begin
		writeln;
		writeln('Unknown error in CME/NetOut while executing opensub()');
		writeln('Please report this error to the author.');
		log('!', 'CME/NetOut opensub() error - report to author');
		halt(32);
	end;
end;

procedure CloseReqFiles;
var
	fptr : file;
begin
	assign(fptr, fromnts(@cfg.cmpath)+'AREAIDX.CM');
	{$i-} reset(fptr, 1); {$I+}
	if ioresult = 0 then
	begin
		seek(fptr, 0);
		blockwrite(fptr, Area.areaidx^[0], sizeof(_areaidx));
		close(fptr);
	end;

	closesub(mainsub);

	closeuserfile;
	closeallfiles;
end;

function ExportNMessage(recnum : longint) : boolean;
var
	dest		: znnp;
	size		: longint;
	lp			: integer;
	msg			: msgptr;
	net			: _netmail;

	dt			: string;
	fptr		: file;
	our			: integer;
	kfs			: boolean;
	s			: string;

begin
	ExportNMessage := true;

	with header do
	begin
		if strtoznnp(addr.data, dest) = false then
			exit;

		unpackmsg(txt, msg, true);

		size := 0;
		for lp := 1 to msg^.msglen do
			inc(size, LineLength(msg, lp));

		if CheckCredits(header, msg, header.from, addr.data, size+512) = false then
		begin
			readblockfile(mainsub.headrf, recnum, @header);
			header.attribute := 2;
			writeblockfile(mainsub.headrf, recnum, @header);

			exit;
		end;

		dt := strs2(date.day) + ' ' + mons[date.month] + ' ' +
			  strs(date.year) + '  ' +
			  strs2(time.hour) + ':' + strs2(time.minute) + ':00';
	end;

	our := ouraddr(dest);

	fillchar(net, sizeof(net), 0);

	if (cfg.rennet > 0) and (header.from = 'SYSOP') then
		header.from := fromnts(@cfg.sysop);

	tonts(NameCaps(header.touser), net.touser);
	tonts(NameCaps(header.from), net.fromuser);
	tonts(dt, net.datetime);

	if (header.fattach <> '') and (cfg.fa_net = FileAttach) then
	begin
		net.attrib := cfg.fl_netf and ($ffff-1024);
		kfs := cfg.fl_netf and 1024 <> 0;
		tonts(cf.attachpath+header.fattach, net.subject);
	end
	else
	begin
		net.attrib := cfg.fl_net and ($ffff-1024);
		kfs := cfg.fl_net and 1024 <> 0;
		tonts(header.subj, net.subject);
	end;

	if (header.crashmail) then
		net.attrib := net.attrib or 2;

	net.orignet  := cfg.address[our].net;
	net.orignode := cfg.address[our].node;
	net.destnet  := dest.net;
	net.destnode := dest.node;


	assign(fptr, fromnts(@cfg.netpath)+strs(nnm)+'.MSG');
	rewrite(fptr, 1);
	blockwrite(fptr, net, sizeof(net));

	s := '';

	if (kfs = true) then
		s := s + #1'FLAGS KFS'#13;

	if beta = true then
		s := s + #1'PID: CatMail '+_shortver+'/b'#13
	else
		s := s + #1'PID: CatMail '+_shortver+#13;

	s := s + #1'MSGID: '+znnptostr(cfg.address[our])+' '+
			 dectohex(header.id[uid])+#13;

	s := s + #1'INTL '+znnptostrnp(dest)+' '+znnptostrnp(cfg.address[our])+#13;

	if cfg.address[our].point > 0 then
		s := s + #1'FMPT '+strs(cfg.address[our].point)+#13;

	if dest.point > 0 then
		s := s + #1'TOPT '+strs(dest.point)+#13;

	if (header.fattach <> '') and (cfg.fa_net = FileAttach) then
		s := s + 'Subject: '+header.subj+#13#13;

	blockwrite(fptr, s[1], length(s));

	for lp := 1 to msg^.msglen do
	begin
		s := msgline(msg, lp) + #13;
		blockwrite(fptr, s[1], length(s));
	end;

	if (header.fattach <> '') and (cfg.fa_net = UUEncode) then
		uu_encode(header.fattach, @fptr, #13, true);

	close(fptr);

	disposemsg(msg);

	readblockfile(mainsub.headrf, recnum, @header);
	header.attribute := 2;
	writeblockfile(mainsub.headrf, recnum, @header);
end;



function ExportMessages : boolean;
var
	result		: longint;
begin
	ExportMessages := false;
	result := 0;

	if Area.areaidx^[0].lastuid > 0 then
		result := findheader(header, uid, Area.areaidx^[0].lastuid, 0);

	if (result = 0) then
		result := findheader(header, seq, mainsub.subinfo.firstmsg, 0);

	while result > 0 do
	begin
		Area.areaidx^[0].lastuid := header.id[uid];

		if (header.addr.atype = 2) and (header.attribute = 0) and cfg.fidoenabled then
		begin
			if not ExportNMessage(result) then
				exit;
			inc(NMsgsExported);
		end;

		if (header.addr.atype = 4) and (header.attribute = 0) and icfg.enabled then
		begin
			if not ExportIMessage(result) then
				exit;
			inc(IMsgsExported);
		end;

		result := findheader(header, seq, header.nextseq, 0);
	end;

	ExportMessages := true;
end;


function ExportMail : byte;
var
	fptr : file;
begin
	ExportMail := 0;
	NMsgsExported := 0;
	IMsgsExported := 0;

	write('Exporting private messages from Searchlight...');

	OpenReqFiles;

	ExportMessages;

	writeln;
	if cfg.fidoenabled then
		writeln('   Exported ',NMsgsExported,' netmail messages from Searchlight.');
	if icfg.enabled then
		writeln('   Exported ',IMsgsExported,' internet messages from Searchlight.');
	writeln;

	if NMsgsExported > 0 then
	begin
		log('+', strs(NMsgsExported)+' netmail messages exported from Searchlight');
		if fromnts(@cfg.rescanfile) <> '' then
		begin
			assign(fptr, fromnts(@cfg.rescanfile));
			{$i-} rewrite(fptr, 1); {$I+}
			if ioresult = 0 then
				close(fptr);
		end;
	end;

	if IMsgsExported > 0 then
		log('+', strs(IMsgsExported)+' internet messages exported from Searchlight');

	CloseReqFiles;
end;


end.
