{$O+}
{$F+}

unit rescan;

interface

uses crt, dos, filedef, sublist, users, message, post, defs, putils, block;

function cm_rescan : byte;

implementation

function cm_rescan : byte;
var
	first_out	: longint;
	rescan		: _rescan;

	ch			: char;
	down			: boolean;
	m			: _msg;
	cmhdr			: _cmhdr;
	tempc			: byte;
	header			: headertype;
	msg			: msgptr;
	dt			: string;
	before, after		: string;
	poss, result, li	: longint;
	p			: setupptr;
	areacfg			: _areacfg;
	ori, subboard		: string;
	written			: boolean;
	lp, ap, pp, zp		: integer;
	nma, nmi		: word;
	hptr, iptr, fptr		: file;
	ox, oy			: integer;
	n			: integer;
	thing, s		: string;
	msgout, origmsg         : ^char;

	outarea			: ^poutarea;
	numoutarea		: word;
	memalloced		: word;



label 	noecho, quitloop;
begin
        cm_rescan := 0;

        n := wherey;
	window(1, 6, 80, 25);
        gotoxy(1, n-5);


	if (not (openfiles([CONFIGF,NODESF])) and (openuserfile)) then 
        	halt(32);

        thing := '';
    	if (sublistinit(subboards, thing) = false) then
        begin
        	writeln('!  SubListInit Error On Startup');
                halt(32);
        end;

	getmem(origmsg, 32000);
        if (origmsg = nil) then
        begin
                writeln('CMRESCAN did not have sufficent memory to be executed.');
                log('!', 'CMRESCAN did not have sufficent memory to be executed.');
		halt(33);
        end;
        msgout := pointer(origmsg);


		write('Rescanning messages from Searchlight:  ');
        ox := wherex;


	assign(iptr, cfg.cmpath+'lastread.cnf');
        {$I-}
        reset(iptr, 1);
        {$I+}
        if (ioresult = 0) then
        begin
		blockread(iptr, numoutarea, 2);
		memalloced := sizeof(_outarea)*(numoutarea+2);
		getmem(outarea, memalloced);
		for lp := 1 to numoutarea do
			blockread(iptr, outarea^[lp], sizeof(_outarea));
        	close(iptr);
        end
        else
        begin
        	numoutarea := 0;
        end;


	assign(hptr, cfg.cmpath+'cmrescan.cnf');
	{$I-}
	reset(hptr, 1);
	{$I+}
	if (ioresult <> 0) then
	begin
		writeln;
		writeln('This program must be executed as part of CatMail.');
		halt(30);
	end;


        nmi := 0;

    	while (not eof(hptr)) do
	begin
                nma := 0;

                written := false;

		blockread(hptr, rescan, sizeof(rescan));

	        subboard := '';
	        for lp := 1 to 9 do
	        begin
		       	if (rescan.slarea[lp] <> #0) then
		               	subboard := subboard + rescan.slarea[lp]
		        else
		        	lp := 9;
		end;

                if (subboard[1] = '_') or (subboard = 'IGNORE') then
                	goto noecho;

                if (rescan.noexport = true) then
                	goto noecho;

		gotoxy(ox, wherey);
                write(subboard,'       ');
                gotoxy(ox, wherey);

	      	p := templistindex(subboard, subboards);

		assign(iptr, p^.path+subboard+'.hdr');
                {$I-}
                reset(iptr, 1);
                {$I+}
                if ioresult = 0 then
                begin
			getftime(iptr, li);
	                close(iptr);

	                result := 0;
	                for lp := 1 to numoutarea do
	                begin
				if (subboard = outarea^[lp].slarea) then
	                        begin
	                                result := 1;
					outarea^[lp].lastdate := li;
                                        lp := numoutarea;
	                        end;
	                end;

	                if (result = 0) then
	                begin
	                	inc(numoutarea);
				outarea^[numoutarea].slarea := subboard;
				outarea^[numoutarea].lastdate := li;
        	        end;
		end;

	      	if (p = nil) or (p^.name <> subboard) then
	      	begin
			write(#13); clreol;
                        writeln('       Can''t locate SL subboard ',subboard,'.');
                        log('!', 'Cannot locate Searchlight subboard '+subboard);
			write('Rescanning messages from SL base:  ');
			goto noecho;
		end;

	    	if (not opensub(subboard, mainsub, allfiles)) then
	    	begin
			write(#13); clreol;
			writeln('	     ! Can''t open subboard files for subboard '+subboard);
			writeln('                Make sure your .HDR, .MSG and .MBR files are present.');
			log('!', 'Can''t open subboard files for '+subboard);
			write('Rescanning messages from SL base:  ');
			goto noecho;
		end;

	        n := 0;

                first_out := 0;

                assign(fptr, cfg.workpath+subboard+'.cmr');
                {$I-}
                reset(fptr, 1);
                {$I+}
                if (ioresult <> 0) then
                begin
                	rewrite(fptr, 1);
                        fillchar(cmhdr, sizeof(cmhdr), 0);
                        cmhdr.tag[0] := ord('?');
                        cmhdr.inoutsl := true;
                        cmhdr.id[0] := cmiddef[0];
                        cmhdr.id[1] := cmiddef[1];
                        cmhdr.id[2] := cmiddef[2];
                        cmhdr.id[3] := cmiddef[3];
                        cmhdr.id[4] := cmiddef[4];
                        cmhdr.id[5] := cmiddef[5];

                        blockwrite(fptr, cmhdr, sizeof(cmhdr));
                end
                else
                	seek(fptr, filesize(fptr));

                for lp := mainsub.subinfo.lastmsg downto mainsub.subinfo.firstmsg do
                begin
                	result := findheader(header, seq, lp, 0);
                        if (result <> 0) then
                        	dec(rescan.rescan);

                        if (rescan.rescan = 0) then
                        begin
                        	first_out := lp;
                        	lp := mainsub.subinfo.firstmsg;
                        end;
		end;

                if first_out = 0 then
                	first_out := mainsub.subinfo.firstmsg;


		for lp := first_out to mainsub.subinfo.lastmsg do
		begin
	        	result := findheader(header, seq, lp, 0);

			if (result <> 0) then
			begin
	                        inc(n);

				poss := 0;
                                inc(nmi);
                               	inc(nma);

				str(header.date.day, dt);
			        if (length(dt) = 1) then
			        	dt := '0'+dt;
			        dt := dt + ' ' + mons[header.date.month] + ' ';
			        str(header.date.year, thing);
			        dt := dt + thing + '  ';
			        str(header.time.hour, thing);
			        if (length(thing) = 1) then
			        	thing := '0'+thing;
			        dt := dt + thing + ':';
			        str(header.time.minute, thing);
			        if (length(thing) = 1) then
			        	thing := '0'+thing;
			        dt := dt + thing + ':00';

				unpackmsg(header.txt, msg, true);

                                msgout := pointer(origmsg);

                                if header.attribute in [0,2] then
                                       	thing := #1'MSGID: '+
        					strs(mainsub.subinfo.origzone)+':'+
	                			strs(mainsub.subinfo.orignet)+'/'+
	                			strs(mainsub.subinfo.orignode)+'.'+
	                			strs(mainsub.subinfo.origpoint)+' '
				else
                                	thing := #1'MSGID: '+
                                        	header.addr.data+' ';

                                li := header.id[uid];
                                thing := thing + dectohex(li)+#13;

				for ap := 1 to length(thing) do
	                        begin
	                        	msgout^ := thing[ap];
                                        inc(msgout);
                                        inc(poss);
	                        end;

        			for ap := 1 to msg^.msglen do
				begin
                                        s := msgline(msg, ap);
					for pp := 1 to length(s) do
					begin
                                        	n := 0;
                                                tempc := cfg.stripcolour;
                                                if (rescan.colourstrip) then
                                                	tempc := 1;
                                                if (rescan.nocolourstrip) then
                                                       	tempc := 0;

                                                if (tempc = 1) and (s[pp] = '\') and (tempc <> 0) then
                                                begin
                                                       	thing := '\' + upcase(s[pp+1]) + upcase(s[pp+2]);
                                                	for zp := 0 to 15 do
                                                        	if slcol[zp] = thing then
                                                                	n := 1;
                                                        if thing = '\NO' then
                                                        	n := 1;
                                                end;
                                                if (n = 0) then
						begin
							msgout^ := s[pp];
                                                        inc(poss);
                                                        inc(msgout);
                                                end
                                                else
                                                       	pp := pp + 2;
					end;
					msgout^ := #13;
					inc(poss);
                                        inc(msgout);
				end;

                                fillchar(m, sizeof(m), 0);

                                down := false;
                                for ap := 1 to length(header.touser) do
                                begin
                                        ch := header.touser[ap];
                                        if (ch >= 'A') and (ch <= 'Z') then
					begin
                                                if (down = true) then
							ch := chr(ord(ch) or 32);
                                                down := true;
                                        end else
                                        	down := false;

                                	m.touser[ap-1] := ord(ch);
                                end;
                                m.touser[ap] := 0;

                                down := false;
				for ap := 1 to length(header.from) do
                                begin
                                        ch := header.from[ap];
                                        if (ch >= 'A') and (ch <= 'Z') then
					begin
                                                if (down = true) then
							ch := chr(ord(ch) or 32);
                                                down := true;
                                        end else
                                        	down := false;

                                	m.fromuser[ap-1] := ord(ch);
                                end;
                                m.fromuser[ap] := 0;

                                for ap := 1 to length(header.subj) do
                                	m.subject[ap-1] := ord(header.subj[ap]);
                                m.subject[ap] := 0;

                                for ap := 1 to length(dt) do
                                	m.datetime[ap-1] := ord(dt[ap]);
                                m.datetime[ap] := 0;

                                m.size := poss;

				thing := header.addr.data;

                                if (header.attribute = 2) then
                                begin
	                        	m.origzone := mainsub.subinfo.origzone;
	                                m.orignet := mainsub.subinfo.orignet;
	                                m.orignode := mainsub.subinfo.orignode;
	                                m.origpoint := mainsub.subinfo.origpoint;
	                                m.originzone := mainsub.subinfo.origzone;
        	                        m.originnet := mainsub.subinfo.orignet;
	                                m.originnode := mainsub.subinfo.orignode;
	                                m.originpoint := mainsub.subinfo.origpoint;
                                end;

                                blockwrite(fptr, m, sizeof(m));
				blockwrite(fptr, origmsg^, poss);
				disposemsg(msg);

                                if (written = false) then
				begin
					written := true;
					writeln;
                                end;
	          	end;
		end;

		close(fptr);

		closesub(mainsub);
                if (nma > 0) then
                	log('+', strs(nma)+' messages rescaned from '+subboard);

noecho:
        end;
quitloop:

        freemem(origmsg, 32000);
	freemem(outarea, memalloced);

        if nmi > 0 then
        	log('+', strs(nmi)+' messages rescaned in total');

        writeln('        ');
        close(hptr);


	closeuserfile;
	closeallfiles;
end;

end.
