{$O+ $F+ $X+}

unit slin;

interface

uses crt, defs, dos, general, filedef, sublist, message, users, post, kill,
		putils,	data, strings, areas, msgs;

function  cmi(mailonly : boolean) : byte;
function  odec(c : char) : byte;
procedure cmi_read_thread;


procedure ImportCMI;
function  ImportMessage : boolean;
function  MakeNewSLArea : boolean;
procedure ReadMessageLine;
procedure RouteMailMessage;
procedure AddColour;


implementation

const
	allocmem = 12000;

var
	thread				: array [0..200] of string[36];
	threadu				: array [0..200] of longint;
	threadn				: integer;

	header				: headertype;

	result				: longint;

	subboard, thingy, s, spath	: string;
	path				: string;
	nmi, n				: word;
	thing				: string;
	a, msgbuf			: ^char;
	iptr, gptr			: file;
	update, mta, x		: integer;
	fs, fd, li			: longint;
	bread, bjread		: longint;

	tmsg				: _msg;
	fromuser, atouser, subject 	: string;
	datetime			: string;
	size, sat			: longint;

	user				: usertype;
	alias				: aliastype;
	userrec, aliasrec	: longint;

	allread				: boolean;
	unfin, off, quote	: boolean;

	cmhdr				: _cmhdr;

	st				: boolean;
	ch				: char;
	msg				: msgptr;
	lp				: integer;
	sr				: searchrec;
	p				: setupptr;

	lastwastag 		: boolean;
	threaduid		: longint;
	posp			: longint;
	newsubf			: text;
	uucode			: boolean;
	uufile			: file;
	xa, xb, xc, xd	: byte;
	xp, xx			: byte;
	xn				: shortint;
	uudecode		: o_uuda;

	addhdrcolour	: word;

	routedtosysop	: boolean;


function cmi(mailonly : boolean) : byte;
begin
	nmi := 0;
	cmi := 0;


	if (not openfiles([configf,nodesf])) or (not openuserfile) then
		halt(32);

	thing := '';
	if (sublistinit(subboards, thing) = false) then
    begin
    	log('!', 'SubListInit Error On Startup');
        halt(32);
    end;

	getmem(msgbuf, allocmem+1024);
    if (msgbuf = nil) then
    begin
		writeln('CME module CMI not have sufficent memory to be executed.');
        log('!', 'CME module CMI did not have sufficent memory to be executed.');
		halt(33);
    end;

	if (mailonly = true) then
		findfirst(fromnts(@cfg.workpath)+'MAIL.CMI', 0, sr)
    else
    begin
		findfirst(fromnts(@cfg.workpath)+'*.CMI', 0, sr);
		write('Importing messages into Searchlight:  ');
    end;

	x := wherex;

	while (doserror = 0) do
	begin
		ImportCMI;

		gotoxy(x, wherey);
		write('[100%]');
		gotoxy(x, wherey);

		update := 0;

		findnext(sr);
	end;


	writeln;
	writeln('   Imported ',nmi,' messages into Searchlight.');
	writeln;

	if (nmi > 0) then
		log('+', strs(nmi)+' messages imported into Searchlight');

	freemem(msgbuf, allocmem+1024);
	closeuserfile;
	closeallfiles;
end;


procedure ImportCMI;
label nextarea;
var
	ImportOkay : boolean;
begin
	mta := 0;
	spath := '';
	update := 0;

	thing := sr.name;
	delete(thing, length(thing)-3, 4);
	upstr(thing);

	if (thing <> 'MAIL') then
	begin
		if (Area.GetSLArea(thing) = false) then
		begin
			if thing[1] = '!' then exit;

			write(#13);
			clreol;
			writeln('   ! Searchlight area '+thing+' is not defined in CMSetup.');
			log('!', 'Searchlight area '+thing+' is not defined in CMSetup.');
			write('Importing messages into Searchlight:  ');
			exit;
		end;

		if (areacfg.import = No) then
			exit;
	end;

	assign(gptr, fromnts(@cfg.workpath)+thing+'.CMI');
	{$I-} reset(gptr, 1); {$I+}
	if (ioresult <> 0) then
		exit;

	{$I-} blockread(gptr, cmhdr, sizeof(cmhdr)); {$I+}
	if ioresult <> 0 then
		cmhdr.id[0] := #0;

	if (cmhdr.id <> cmi_hdr_id) then
	begin
		write(#13);
		clreol;
		writeln('   ! File ',thing,'.CMI is either grunged or obsolete.  Skipping.');
		log('!', 'File '+thing+'.CMI is either grunged or obsolete');
		write('Importing messages into Searchlight:  ');
		close(gptr);
		exit;
	end;

	if (cmhdr.allimported = 1) or (cmhdr.importedsl >= filesize(gptr)) then
		goto nextarea;

	subboard := thing;
	upstr(subboard);
	stripspaces(subboard);

	if (ihlt(subboard) = true) then
	begin
		write(#13);
		clreol;
		writeln('   ! Crashed .CMI file (',subboard,'.CMI) found in work dir.');
		writeln('      Delete file ',fromnts(@cfg.workpath),subboard,'.HLT to import messages.');
		log('!', 'Crashed file '+subboard+'.CMI found - delete HLT file to import.');
		write('Importing messages into Searchlight:  ');
		close(gptr);
		exit;
	end;

	if (ipos(subboard) = true) then
	begin
		posp := gpos(subboard);
		seek(gptr, posp);
		dpos(subboard);
	end
	else
	begin
		if cmhdr.importedsl > 0 then
			seek(gptr, cmhdr.importedsl);
	end;

	p := templistindex(subboard, subboards);
	if ((p = nil) or (p^.name <> subboard)) then
	begin
		if (MakeNewSLArea = false) then
		begin
			close(gptr);
			exit;
		end;
	end;

	if cfg.usehlt then
		uhlt(subboard);

	gotoxy(x, wherey);
	write('[  0%] ',subboard,'         ');
	gotoxy(x, wherey);

	if not (opensub(subboard, mainsub, allfiles)) then
	begin
		write(#13); clreol;
		writeln('   ! Can''t open Searchlight subboard files for subboard '+subboard);
		writeln('      Make sure your .HDR, .MSG and .MBR files are present.');
		log('!', 'Can''t open subboard files for '+subboard);
		write('Importing messages into Searchlight:  ');

		close(gptr);
		exit;
	end;

	spath := p^.path;

	update := 0;

	li := GetFileDate(p^.path+subboard+'.HDR');
	if li > 0 then
	begin
		if (li = area.areaidx^[area.idx].lastdate) then
			update := area.idx;
	end;

	if (locksubboard(60, true) = false) then
		writeln('     Warning : Unable to lock subboard ',subboard);

	if (cfg.thread > 0) then
		cmi_read_thread;

	fs := filesize(gptr);

	ImportOkay := true;
	while (not eof(gptr)) and (ImportOkay = true) do
		ImportOkay := ImportMessage;

	if cfg.usehlt and ImportOkay then
	begin
		dpos(subboard);
		dhlt(subboard);
	end;

	log(' ', strs(mta)+' messages imported into '+subboard);

	autotrim;
	unlocksubboard;
	closesub(mainsub);

nextarea:
	if (update > 0) and (spath <> '') then
	begin
		li := GetFileDate(spath+subboard+'.HDR');
		if li > 0 then
			area.areaidx^[area.idx].lastdate := li;
	end;

	seek(gptr, 0);
	cmhdr.importedsl := filesize(gptr);
	blockwrite(gptr, cmhdr, sizeof(cmhdr));
	close(gptr);

	if (subboard = 'MAIL') then
		erase(gptr);
end;



function MakeNewSLArea : boolean;
begin
	MakeNewSLArea := false;

	if (1 = 0) or (subboard = 'MAIL') then
	begin
		write(#13);
		clreol;
		writeln('   ! Unable to find Searchlight message area '+subboard);
		log('!', 'Unable to find Searchlight message area '+subboard);
		write('Importing messages into Searchlight:  ');
		exit;
	end;

	thing := fromnts(@areacfg.tag);
	if (areacfg.isusenet = 1) then
	begin
		for lp := 1 to length(thing) do
		begin
			if (thing[lp] >= 'A') and (thing[lp] <= 'Z') then
				thing[lp] := chr(ord(thing[lp])+32);
		end;
	end;

	if addsub(subboard, thing, cmhdr.origin, false, '') = true then
	begin
		write(#13); clreol;
		writeln('     Successfully created new Searchlight subboard '+subboard);
		log('+', 'Successfully created new Searchlight message area '+subboard);

		assign(newsubf, fromnts(@cfg.cmpath)+'NEWSUB.CMD');
		{$I-} append(newsubf); {$I+}
		if ioresult <> 0 then
			{$i-} rewrite(newsubf); {$I+}

		writeln(newsubf, subboard);
		close(newsubf);

		write('Importing messages into Searchlight:  ');
		MakeNewSLArea := true;
		exit;
	end;

	write(#13); clreol;
	writeln('   ! Unable to find or create Searchlight message area '+subboard);
	log('!', 'Unable to find or create Searchlight message area '+subboard);
	write('Importing messages into Searchlight:  ');

	exit;
end;

procedure cmi_read_thread;
var
	n 		: integer;
	result	: longint;
	thing	: string;
	lp		: integer;

begin
	n := thrmsg;			{ number to thread }

	for lp := mainsub.subinfo.lastmsg downto mainsub.subinfo.firstmsg do
	begin
		result := findheader(header, seq, lp, 0);
		if (result <> 0) then
		begin
			thread[n] := header.subj;
			thing := thread[n];
			upstr(thing);
			thread[n] := thing;
			if (copy(thread[n], 1, 4)) = 'RE: ' then
				delete(thread[n], 1, 4);
			if (copy(thread[n], 1, 3)) = 'RE:' then
				delete(thread[n], 1, 3);
			threadu[n] := header.id[uid];
			dec(n);
		end;

		if (n = 0) then
			lp := mainsub.subinfo.firstmsg;
	end;

	threadn := n + 1;
end;



function odec(c : char) : byte;
var
	r : byte;
begin
	r := (byte(c) - 32) and 63;
	odec := r;
end;

function ImportMessage : boolean;
label readmore;
var
	ismail 			: boolean;
	hdrbuf, hdrptr 	: ^char;
	origstr			: string;

	allowfinish		: boolean;

begin
	ImportMessage := false;

	ismail := subboard = 'MAIL';

	fd := filepos(gptr);

	gotoxy(x, wherey);
	write('[',((fd*100) div fs):3,'%]');
	gotoxy(x, wherey);

	allread := false;
	uucode := false;
	bread := 0;

	{$I-} blockread(gptr, tmsg, sizeof(tmsg)); {$I+}
	if (ioresult <> 0) then
	begin
		write(#13); clreol;
		writeln('   ! Grunge error in '+subboard+'.CMI (cmmsghdr) at ',filepos(gptr),'.');
		writeln('      Run the CMSetup CMI repair function to salvage data.');
		log('!', 'Grunge error (cmmsghdr) in file '+subboard+'.CMI at '+strsl(filepos(gptr)));
		write('Importing messages into Searchlight:  ');

		exit;
	end;

	if (tmsg.headerattached = 1) then
		blockread(gptr, header, sizeof(header));

	if (tmsg.noimport = 1) then
	begin
		seek(gptr, fd+sizeof(tmsg)+tmsg.size);
		ImportMessage := true;
		exit;
	end;


	size := tmsg.size;
	new(msg);
	clearmsg(msg);
	path := '';
	off := false;

	atouser := fromnts(@tmsg.touser);
	fromuser := fromnts(@tmsg.fromuser);
	subject := fromnts(@tmsg.subject);
	datetime := fromnts(@tmsg.datetime);
	thing := subject;
	upstr(thing);
	if (copy(thing, 1, 4)) = 'RE: ' then
		delete(thing, 1, 4);
	if (copy(thing, 1, 3)) = 'RE:' then
		delete(thing, 1, 3);

	threaduid := 0;
	if (cfg.thread > 0) then
	begin
		for lp := thrmsg downto threadn do
		begin
			if (thing = thread[lp]) then
			begin
				threaduid := threadu[lp];
				lp := threadn;
			end;
		end;
	end;

	upstr(fromuser);
	upstr(atouser);

	q := 0;

	if (tmsg.usenet = 1) then
		origstr := ''
	else
	begin
		if (tmsg.origin.zone = 0) then
			origstr := 'Unknown Origin'
		else
		begin
			if (tmsg.origin.point > 0) then
				origstr := strs(tmsg.origin.zone)+':'+strs(tmsg.origin.net)+'/'+strs(tmsg.origin.node)+'.'+strs(tmsg.origin.point)
			else
				origstr := strs(tmsg.origin.zone)+':'+strs(tmsg.origin.net)+'/'+strs(tmsg.origin.node);
		end;

		if (fromuser = 'CATMAIL') and (tmsg.origin.zone = 0) then
			origstr := 'CatMail Mail Processor';
	end;


	uudecode := cfg.uudecode;
	case areacfg.uu of
	  uudd_ignore:	uudecode := uuda_ignore;
	  uudd_decode:	uudecode := decode;
	  uudd_decodedelete:  uudecode := decodedelete;
	end;


	if tmsg.headerattached = 0 then
	begin
		fillchar(header, sizeof(header), 0);

		if (tmsg.usenet = 1) then
		begin
			header.addr.atype := 3;
			addline(msg, fromnts(@tmsg.frominet));
		end
		else
			header.addr.atype := 1;

		if (subboard = 'MAIL') and (tmsg.noprocessing = 0) then
			RouteMailMessage;

		with header do begin
			from := fromuser;
			touser := atouser;
			subj := subject;
			addr.data := origstr;
			attribute := 1;
		end;

		if (user.netaddr.data <> '') and
		   (ismail) and (tmsg.noprocessing = 0) then
		begin
			addline(msg, '\lrCatMail:  \gr_');
			addline(msg, 'Netmail from user \ye'+header.from+'\gr at_');
			addline(msg, ' \ye'+origstr+'\gr forwarded.\no');
			addline(msg, '');
			addline(msg, '===');
			header.addr.data := user.netaddr.data;
			header.addr.atype := 2;
			header.attribute := 0;
		end;

		thing := copy(datetime, 1, 2);
		header.date.day := vals(thing);
		if (header.date.day < 1) or (header.date.day > 31) then
			header.date.day := 1;

		thing := copy(datetime, 4, 3);
		header.date.month := 1;
		for lp := 1 to 12 do
			if mons[lp] = thing then
				header.date.month := lp;

		thing := copy(datetime, 8, 2);
		header.date.year := vals(thing);
		if header.date.year < 70 then
			header.date.year := header.date.year + 100;

		thing := copy(datetime, 12, 2);
		header.time.hour := vals(thing);
		thing := copy(datetime, 15, 2);
		header.time.minute := vals(thing);
	end;


	if ismail and (tmsg.usenet = 1) then
		origstr := copy(tmsg.frominet, pos('@', tmsg.frominet)+1, 255);

	if (not routedtosysop) and ismail and (CheckAccess(header, header.touser) = false) then
	begin
		addline(msg, 'CatMail * This message was originally addressed to user:');
		addline(msg, '  '+header.touser);
		addline(msg, 'but was not sent as the user did not have access to receive it.');

		header.touser := fromnts(@icfg.postmaster);
	end;

	if ismail and (CheckCredits(header, Nil, header.touser, origstr, size) = false) then
	begin
		addline(msg, 'CatMail * This message was originally addressed to user:');
		addline(msg, '  '+header.touser);
		addline(msg, 'but was not sent as the user did not have enough credits to receive it.');

		header.touser := fromnts(@icfg.postmaster);
	end;

	addhdrcolour := 0;

	if tmsg.ihdrsize > 0 then
	begin
		if ((ismail) and (icfg.email_head <> H_Top)) or
		   ((not ismail) and (icfg.usenet_head <> H_Top)) then
		begin
			if ((ismail) and (icfg.email_head = H_Bottom)) or
			   ((not ismail) and (icfg.usenet_head = H_Bottom)) then
			begin
				hdrbuf := Nil;
				if tmsg.ihdrsize < memavail - 4096 then
				begin
					getmem(hdrbuf, tmsg.ihdrsize+1);
					blockread(gptr, hdrbuf^, tmsg.ihdrsize);
					size := size - tmsg.ihdrsize;
					bread := tmsg.ihdrsize;
				end;
			end
			else
			begin
				seek(gptr, filepos(gptr) + tmsg.ihdrsize);
				size := size - tmsg.ihdrsize;
				bread := tmsg.ihdrsize;
			end;
		end;

		if ((ismail) and (icfg.email_head = H_Top)) or
		   ((not ismail) and (icfg.usenet_head = H_Top)) then
			addhdrcolour := 1;
	end;


	quote := false;

readmore:
	{$I-}
	if (size > allocmem) then
	begin
		blockread(gptr, msgbuf^, allocmem);
		size := size - allocmem;
		bread := bread + allocmem;
		bjread := allocmem;
	end
	else
	begin
		blockread(gptr, msgbuf^, size);
		allread := true;
		bjread := size;
	end;
	{$I+}

	if (ioresult <> 0) then
	begin
		write(#13); clreol;
		writeln('   ! Grunge error in '+subboard+'.CMI (msgbody) at ',filepos(gptr),'.');
		writeln('      Run the CMSetup CMI repair function to salvage data.');
		log('!', 'Grunge error (msgbody) in file '+subboard+'.CMI at '+strsl(filepos(gptr)));
		write('Importing messages into Searchlight:  ');
		dhlt(subboard);
		disposemsg(msg);
		exit;
	end;

	sat := 0;
	st := false;
	unfin := false;
	lastwastag := false;

	repeat
		allowfinish := true;

		while (msg^.msglen <= mainsub.subinfo.maxmsglen - 3) and
			  (sat < bjread) and
			  (st = false) do
			ReadMessageLine;

		if (msg^.msglen > mainsub.subinfo.maxmsglen - 3) then
		begin
			addline(msg, '');
			addline(msg, '\LCCatMail:  This message continued in the next message ===>');

			if ismail then
			begin
				makemember(header.touser);
				result := msgpost(msg, header, 0, false, true, true);
			end
			else
				result := msgpost(msg, header, 0, false, true, true);

			if (tmsg.usenet = 1) then
				thing := MsgLine(msg, 1);

			disposemsg(msg);
			new(msg);
			clearmsg(msg);

			if (tmsg.usenet = 1) then
				addline(msg, thing);

			addline(msg, '\LCCatMail:  <=== This message is a continuation from the previous message\NO');
			addline(msg, '');

			allowfinish := false;
		end;

		if (allread = false) then
			goto readmore;

	until allread and allowfinish;


	if (tmsg.ihdrsize > 0) and
	   (((ismail) and (icfg.email_head = H_Bottom)) or
	   ((not ismail) and (icfg.usenet_head = H_Bottom))) then
	begin
		if hdrbuf <> Nil then
		begin
			hdrptr := hdrbuf;
			sat := tmsg.ihdrsize;

			addline(msg, slcol[cfg.ihdrcolour]);

			while sat > 0 do
			begin
				s := '';

				repeat
					ch := hdrptr^;

					case ch of
					  #13, #10:	{ nothing };
					  #9:		s := s + '        ';
					else
						s := s + ch;
					end;

					inc(hdrptr);
					dec(sat);
				until (ch in [#13]) or (length(s) >= cfg.wrapline) or (sat < 1);

				addline(msg, s);
			end;

			freemem(hdrbuf, tmsg.ihdrsize+1);
		end;
	end;

	if ismail then
	begin
		makemember(header.touser);
		result := msgpost(msg, header,         0, false, true, true);
	end
	else
		result := msgpost(msg, header, threaduid, false, true, true);

	if uucode = true then
	begin
		uucode := false;
		close(uufile);
	end;

	inc(nmi);
	inc(mta);

	if cfg.usehlt then
		upos(subboard, filepos(gptr));

	disposemsg(msg);

	ImportMessage := true;
end;


procedure ReadMessageLine;
begin
	if (unfin = true) then
		unfin := false
	else
		s := '';

	repeat
		a := pointer(longint(msgbuf)+sat);
		ch := a^;

		case ch of
		  #13, #10:	{ nothing };
		  #9:		s := s + '        ';
		else
			s := s + ch;
		end;

		inc(sat);
	until (ch = #13) or (sat >= bjread) or (length(s) = 250);

	if (addhdrcolour = 1) then
	begin
		s := slcol[cfg.ihdrcolour] + s;
		addhdrcolour := 2;
	end;

	if (addhdrcolour = 2) and (sat >= tmsg.ihdrsize) then
	begin
		s := s + '\NO';
		addhdrcolour := 0;
	end;

	if (s = 'end') or (s[1] = '-') then
	begin
		if (uucode = true) then
			close(uufile);
		uucode := false;
	end;

	if (uucode = true) and (uudecode <> uuda_Ignore) then
	begin
		xn := odec(s[1]);
		if (xn = 0) then
		begin
			close(uufile);
			uucode := false;
		end
		else
		begin
			xp := 2;
			while (xn > 0) do
			begin
				xa := odec(s[xp]);
				inc(xp);
				xb := odec(s[xp]);
				inc(xp);
				xc := odec(s[xp]);
				inc(xp);
				xd := odec(s[xp]);
				inc(xp);
				if (xn > 0) then
				begin
					xx := (xa shl 2) or (xb shr 4);
					blockwrite(uufile, xx, 1);
				end;
				dec(xn);
				if (xn > 0) then
				begin
					xx := (xb shl 4) or (xc shr 2);
					blockwrite(uufile, xx, 1);
				end;
				dec(xn);
				if (xn > 0) then
				begin
					xx := (xc shl 6) or xd;
					blockwrite(uufile, xx, 1);
				end;
				dec(xn);
			end;
		end;
	end;

	if (copy(s, 1, 6) = 'begin ') and ( (thing[7] >= '0') and (thing[7] <= '9') ) and (tmsg.noprocessing = 0) then
	begin
		uucode := true;
		delete(s, 1, 6);
		stripspaces(s);
		delete(s, 1, pos(' ', s));
		delete(s, pos(' ', s), 1000);

		thing := s;
		n := 0;

		while (n < 200) do
		begin
			assign(uufile, cf.attachpath+thing);
			{$I-} reset(uufile, 1); {$I+}
			if ioresult = 0 then
			begin
				close(uufile);
				for lp := 1 to 8 do
					thing[lp] := chr(random(26)+65);
				thing[0] := #8;
				thing := thing + copy(s, pos('.', s), 1000);

				inc(n);
			end
			else
			begin
				rewrite(uufile, 1);
				header.fattach := thing;
				n := 300;
			end;
		end;

		if (n = 200) then
		begin
			write(#13); clreol;
			error('Can''t create a unique filename for UUdecoded message.  File ignored.');
			uucode := false;
		end;
	end;

	if (length(s) = 250) then
		unfin := true;

	if (cfg.colour = 1) and (uucode = false) and (tmsg.noprocessing = 0) then
		AddColour;

	while (pos(chr($8d), s) > 0) do
		delete(s, pos(chr($8d), s), 1);

	while (length(s) > cfg.wrapline) do
	begin
		thing := copy(s, 1, cfg.wrapline);
		n := 0;
		for lp := length(thing) downto 1 do
		begin
			if thing[lp] in [' ',',','!','.'] then
			begin
				n := lp;
				lp := 1;
			end;
		end;

		if (n <> 0) then
		begin
			thing := copy(s, 1, n);
			addline(msg, thing);
			delete(s, 1, n);
		end
		else
		begin
			thing := copy(s, 1, cfg.wrapline);
			addline(msg, thing);
			delete(s, 1, cfg.wrapline);
		end;
	end;

		{ --> if uudecode is on and other is off }
	if (s[1] <> #1) and
	   (off = false) and
	   (unfin = false) and
	   ((uudecode <> decodedelete) or (uucode = false)) then
		addline(msg, s);

	if (length(path) > 0) then
		st := true;
end;


procedure AddColour;
begin
	if (cfg.quotecolour < 16) then
	begin
		if (s[1] = '>') or (s[2] = '>') or (s[3] = '>') or (s[4] = '>') then
		begin
			if (quote = false) then
			begin
				if (length(s) > cfg.wrapline - 3) then
					addline(msg, slcol[cfg.quotecolour]+'_')
				else
					s := slcol[cfg.quotecolour]+s;
				quote := true;
			end;
		end
		else
		begin
			if (quote = true) then
			begin
				s := '\NO'+s;
				quote := false;
			end;
		end;
	end;

	if (cfg.tagcolour < 16) then
		if (copy(s, 1, 4) = '... ') then
			s := slcol[cfg.tagcolour]+s+'\NO';

	if (cfg.origincolour < 16) then
	begin
		if (copy(s, 1, 10) = ' * Origin:') then
		begin
			path := s;
			if (lastwastag = false) then
				s := slcol[cfg.origincolour]+s;
		end;

		lastwastag := false;
	end;

	if (lastwastag = true) then
	begin
		lastwastag := false;
		s := '\NO'+s;
	end;

	if (cfg.tearcolour < 16) then
	begin
		if (copy(s, 1, 4) = '--- ') or (s = '---') then
		begin
			s := slcol[cfg.tearcolour]+s+slcol[cfg.origincolour];
			lastwastag := true;
		end;
	end;
end;


procedure RouteMailMessage;
begin
	routedtosysop := false;

	if (atouser = 'SYSOP') and (cfg.rennet = 0) then
	begin
		atouser := fromnts(@cfg.sysop);
		upstr(atouser);
		usearch(atouser, user, userrec);
	end
	else
	begin
		usearch(atouser, user, userrec);
		if userrec = 0 then
		begin
			asearch(atouser, alias, aliasrec);
			if (aliasrec <> 0) then
				usearch(alias.name, user, userrec);
		end
	end;

	if (userrec = 0) then
	begin
		routedtosysop := true;

		write(#13); clreol;
		writeln('     User ',atouser,' not found!  Routing to SysOp.');
		log('!', 'User '+atouser+' not found!  Routing to SysOp.');

		write('Importing messages into Searchlight:  ');

		addline(msg, '\yeCatMail Intercept:  \gr_');
		addline(msg, 'Mail to unknown user '+atouser+' routed.\no');

		addline(msg, '');
		addline(msg, '===');

		if (cfg.rennet > 0) then
			atouser := 'SYSOP'
		else
		begin
			atouser := fromnts(@cfg.sysop);
			upstr(atouser);
		end;

		usearch(atouser, user, userrec);
		if userrec = 0 then
		begin
			asearch(atouser, alias, aliasrec);
			if (aliasrec <> 0) then
				usearch(alias.name, user, userrec);
		end;
	end;
end;

end.

