{$O+ $F+ $R-}

unit slout;

interface

uses crt, dos, filedef, sublist, users, message, post, defs, putils, block,
		data, strings, msgs, version, inetout, general;



type TOutMsg = object(TMsg)
	before, after	: string;
	subboard		: string;
	written			: boolean;
	nma, nmi		: word;
	ox, oy			: integer;
	fposs, fpose 	: longint;

	next, nmsgscan	: longint;

	CMIIsOpen		: boolean;
	cmif			: file;

	procedure GetFidoMessageInfo;

	function  ScanMessage(recnum : longint) : boolean;
	function  ScanNextArea : boolean;
	function  Scan : byte;
end;



implementation

procedure bwrite(var f : file; s : string);
begin
	blockwrite(f, s[1], length(s));
end;


function TOutMsg.ScanMessage(recnum : longint) : boolean;
var
	lp, pp  	: integer;
	m			: _msg;
	cmhdr		: _cmhdr;
	TopOfMsg	: longint;
	tempc, n, nn: integer;

	dt			: string;
	s, thing	: string;

	li			: longint;

	cd		: datetype;
	ct		: timetype;
	cdt		: string;


begin
	ScanMessage := true;

	inc(nma);

	str(header.date.day, dt);
	if (length(dt) = 1) then
		dt := '0'+dt;
	dt := dt + ' ' + mons[header.date.month] + ' ';
	str(header.date.year mod 100, thing);
	dt := dt + thing + '  ';
	str(header.time.hour, thing);
	if (length(thing) = 1) then
		thing := '0'+thing;
	dt := dt + thing + ':';
	str(header.time.minute, thing);
	if (length(thing) = 1) then
		thing := '0'+thing;
	dt := dt + thing + ':00';

	unpackmsg(header.txt, msg, true);

	fillchar(m, sizeof(_msg), 0);

	TopOfMsg := filesize(cmif);
	seek(cmif, TopOfMsg);
	blockwrite(cmif, m, sizeof(_msg));

	if (areacfg.isusenet = 0) then
	begin
		blockwrite(cmif, before[1], length(before));

		thing := #1'MSGID: '+
			strs(mainsub.subinfo.origzone)+':'+
			strs(mainsub.subinfo.orignet)+'/'+
			strs(mainsub.subinfo.orignode)+'.'+
			strs(mainsub.subinfo.origpoint)+' ';

		li := header.id[uid];
		thing := thing + dectohex(li)+#13;

		blockwrite(cmif, thing[1], length(thing));
	end
	else
	begin
		dosdate(cd); dostime(ct);
		cdt := GetInternetDate(cd, ct);

		bwrite(cmif, 'Path: '+fromnts(@icfg.uucpname)+'!'+GetAlias(header.from)+#13);
		bwrite(cmif, 'Newsgroups: '+strlwr(fromnts(@areacfg.tag))+#13);
		bwrite(cmif, 'Subject: '+header.subj+#13);
		bwrite(cmif, 'From: '+GetAlias(header.from)+'@'+fromnts(@icfg.address)+' ('+NameCaps(header.from)+')'+#13);
		bwrite(cmif, 'Message-ID: <'+fromnts(@areacfg.slarea)+'.'+dectohex(header.id[UID])+
					'@'+fromnts(@icfg.address)+'>'#13);
		bwrite(cmif, 'Date: '+GetInternetDate(header.date, header.time)+#13);
		bwrite(cmif, 'Organization: '+cf.systemname+#13#13);
	end;

	case areacfg.cstrip of
	  Yes: 		tempc := 1;
	  No:  		tempc := 0;
	  Default:  tempc := cfg.stripcolour;
	end;

	for lp := 1 to msg^.msglen do
	begin
		s := msgline(msg, lp);

		if (s[length(s)] = '_') then
			delete(s, length(s), 1)
		else
			s := s + #13;

		if (tempc = 1) then
		begin
			n := pos('\', s);
			while n > 0 do
			begin
				thing := '\' + upcase(s[n+1]) + upcase(s[n+2]);
				for pp := 0 to 15 do
				begin
					if slcol[pp] = thing then
					begin
						delete(s, n, 3);
						pp := 15;
					end;
				end;
				if thing = '\NO' then
					delete(s, n, 3);

				nn := n;
				n := pos('\', copy(s, n+1, 255));

				if (n > 0) then
					inc(n, nn);
			end;
		end;

		blockwrite(cmif, s[1], length(s));
	end;

	if (header.from = 'SYSOP') and (cfg.rennet > 0) then
		header.from := fromnts(@cfg.sysop);

	tonts(NameCaps(header.touser), m.touser);
	tonts(NameCaps(header.from),   m.fromuser);

	tonts(header.subj, m.subject);
	tonts(dt,          m.datetime);

	tonts(GetAlias(header.from), m.frominet);

	if areacfg.isusenet = 0 then
	begin
		m.orig.zone := mainsub.subinfo.origzone;
		m.orig.net := mainsub.subinfo.orignet;
		m.orig.node := mainsub.subinfo.orignode;
		m.orig.point := mainsub.subinfo.origpoint;

		move(m.orig, m.origin, sizeof(znnp));
	end
	else
		m.usenet := 1;

	m.noimport := 1;

	move(cmi_msg_id, m.id, 4);

	if (header.fattach <> '') then
	begin
		if (cfg.fa_use = UUEncode) and (areacfg.isusenet = 1) then
			uu_encode(header.fattach, @cmif, #13, true);
		if (cfg.fa_echo = UUEncode) and (areacfg.isusenet = 0) then
			uu_encode(header.fattach, @cmif, #13, true);
	end;

	if areacfg.isusenet = 0 then
		blockwrite(cmif, after[1], length(after));

	m.size := filepos(cmif) - TopOfMsg - sizeof(m);
	seek(cmif, TopOfMsg);
	blockwrite(cmif, m, sizeof(m));

	disposemsg(msg);

	readblockfile(mainsub.headrf, recnum, @header);
	header.attribute := 2;
	writeblockfile(mainsub.headrf, recnum, @header);

	if (written = false) then
	begin
		written := true;
		writeln;
	end;
end;


procedure TOutMsg.GetFidoMessageInfo;
var
	ori, thing	: string;
begin
	if (mainsub.subinfo.origzone = 0) then
	begin
		mainsub.subinfo.origzone := cfg.address[0].zone;
		mainsub.subinfo.orignet := cfg.address[0].net;
		mainsub.subinfo.orignode := cfg.address[0].node;
		mainsub.subinfo.origpoint := cfg.address[0].point;
	end;

	ori := get_origin_line(subboard, mainsub.subinfo.origzone);
	if (ori = '') then
		ori := 'Default CatMail Origin Line';

	if (cfg.pidtype = 1) then
		after := #13'--- CatMail v'+_ver+#13
	else
		after := #13'---'#13;

	after := after + ' * Origin: '+ori+' ('+
	  strs(mainsub.subinfo.origzone)+':'+
	  strs(mainsub.subinfo.orignet)+'/'+
	  strs(mainsub.subinfo.orignode);

	if (mainsub.subinfo.origpoint > 0) then
		after := after + '.' + strs(mainsub.subinfo.origpoint)+')'#13
	else
		after := after + ')'#13;

	if (mainsub.subinfo.origpoint = 0) then
		after := after + 'SEEN-BY: '+strs(mainsub.subinfo.orignet)+'/'
		  +strs(mainsub.subinfo.orignode)+#13#0;

	if (cfg.pidtype = 0) then
	begin
		if beta = true then
			before := #1'PID: CatMail '+_shortver+'/b '#13
		else
			before := #1'PID: CatMail '+_shortver+#13;
	end
	else
		before := '';
end;

function TOutMsg.ScanNextArea : boolean;
var
	quit		: boolean;
	result		: longint;

begin
	nma := 0;
	written := false;

	blockread(idxf, areaidx, sizeof(_areaidx));
	blockread(areaf, areacfg, sizeof(_areacfg));

	if (areacfg.slarea[0] = #0) then
		exit;

	subboard := fromnts(@areacfg.slarea);

	if (areacfg.export = No) or (ihlt(subboard) = true) then
		exit;

	p := templistindex(subboard, subboards);

	if (p = nil) or (p^.name <> subboard) then
		exit;

	result := GetFileDate(p^.path+subboard+'.HDR');
	if (areaidx.LastDate = result) then
		exit;
	areaidx.LastDate := result;

	gotoxy(ox, wherey);
	clreol;
	write(subboard);
	gotoxy(ox, wherey);

	if (not opensub(subboard, mainsub, [HEADERF,MSGF])) then
	begin
		write(#13); clreol;
		writeln('   ! Can''t open subboard files for subboard '+subboard);
		writeln('      Make sure your .HDR, .MSG and .MBR files are present.');
		log('!', 'Can''t open subboard files for '+subboard);
		write(mainstr);
		exit;
	end;

	if (areacfg.isusenet = 0) then
		GetFidoMessageInfo;

	nmsgscan := 0;
	result := 0;

	if (areaidx.lastuid > 0) then
		result := findheader(header, uid, areaidx.lastuid, 0);

	if (result = 0) then
		result := findheader(header, seq, mainsub.subinfo.firstmsg, 0);

	quit := false;

	if (result <> 0) then
	begin
		repeat
			areaidx.lastuid := header.id[uid];
			next := header.nextseq;

			inc(nmsgscan);

			if (header.attribute = 0) then
			begin
				if CMIIsOpen = false then
				begin
					OpenCMI(subboard, fromnts(@areacfg.tag), cmif);
					CMIIsOpen := true;
				end;

				inc(nmi);

				if ScanMessage(result) = false then
					quit := true;
			end;

			result := findheader(header, seq, next, 0);
		until (result = 0) or (quit = true);
	end;

	if CMIIsOpen = true then
	begin
		CMIIsOpen := false;
		close(cmif);
	end;

	closesub(mainsub);
	if (nma > 0) then
	begin
		log('+', strs(nma)+' messages exported from '+subboard);
		areaidx.LastDate := GetFileDate(p^.path+subboard+'.HDR');
	end;

	seek(idxf, filepos(idxf) - sizeof(_areaidx));
	blockwrite(idxf, areaidx, sizeof(_areaidx));
end;



function TOutMsg.Scan : byte;
begin
	seek(idxf, 0);
	seek(areaf, sizeof(_areacfg));

	{$i-} blockread(idxf, areaidx, sizeof(_areaidx)); {$i+}
	if ioresult <> 0 then
	begin
		Scan := 0;
		exit;
	end;

	if (areaidx.lastdate = 0) then
	begin
		writeln('  Rebuilding CatMail quick message area index.');
		writeln('   This export message scan will take longer than normal.');
		writeln;

		areaidx.lastdate := GetFileDate(fromnts(@cfg.cmpath)+'AREA.CM');
		seek(idxf, 0);
		blockwrite(idxf, areaidx, sizeof(_areaidx));
	end;

	seek(idxf, sizeof(_areaidx));

	mainstr := 'Exporting messages from Searchlight:  ';
	write(mainstr);
	ox := wherex;

	nmi := 0;
	CMIIsOpen := false;

	while (not eof(areaf)) do
		ScanNextArea;

	if nmi > 0 then
		log('+', strs(nmi)+' messages exported from Searchlight.');

	writeln('        ');

	writeln('   Exported ',nmi,' messages from Searchlight.');
	writeln;

	Scan := 0;
end;


end.
