#ifndef __CFGDEF_H
#define __CFGDEF_H

#include <dos.h>
#include "defs.h"


enum o_loglevel { LNone, LMinimal, LTerse, LAverage, LVerbose, LDebug };

typedef enum
	{ M_Undefined, M_FrontDoor, M_Binkley, M_DBridge, M_Portal, M_CatFlap } o_mailer;

typedef enum
	{ U_Ignore, U_UUEncode, U_FileAttach } o_fam;

typedef enum
	{ UD_Ignore, UD_Decode, UD_DecodeDelete } o_uuda;

typedef enum
	{ UDD_Default, UDD_Ignore, UDD_Decode, UDD_DecodeDelete } o_uudd;

typedef enum
	{ D_Ignore, D_Rename, D_Kill } o_dupe;

typedef enum
	{ PW_Password, PW_FrontDoor, PW_DB, PW_Squish } o_pw;

typedef enum
	{ Default, Yes, No } o_dyn;

typedef enum
	{ SA_Leave, SA_Trunc, SA_Kill } o_sa;

typedef enum
	{ MSNone, MSActive, MSPaused } EMsgStatus;


struct _cfg			//  Configuration structure in CFG.CM
{
	char	id[10];
	char	cmpath[45];	//  CatMail's path taken from enviro var.
	znnp	address[15];	//  Addresses
	char	filespath[45];	//  Path of inbound files directory
	char	arcnetpath[45];
	char	packpath[45];	//  Outbound files directory
	char	workpath[45];	//  Temporary work area
	char	logfile[45];    //  Path to log file
	char	binkpath[45];   //  BinkleyTerm root dir
	char	netpath[45];    //  Netmail Directory
	char	inetlogfile[45];
	char	rescanfile[45];	//  Path to rescan semaphore file
	char	dupepath[45];   //  Duplicate data directory
	char	comfile[45];    //  4DOS comments file (DESCRIPT.ION)

	byte	usecomfile;	//  Use the 4dos comments file?

	byte	secure;		//  Secure mode on/off
	byte	killblank;	//  Kill blank messages

	byte	pidtype;	//  Use kludge or tearline ID
	byte	colour;		//  Use the colour system
	byte	quotecolour;    //  Colours: quotes      [>]
	byte	tearcolour;     //           tearline    [---]
	byte	origincolour;   //           origin line [ * Origin:]
	byte	tagcolour;      //           taglines    [___]
	byte	stripcolour;    //  Strip colour from outbound msgs

	char	sysop[25];	//  SysOp's name
	byte	rennet;		//  Rename netmail <-> SYSOP

	byte	quiet;		//  Do not show archivers working
	o_mailer mailertype;	//  Mailer type

	byte	cmfixsecure;	//  Is CMFix secure?

	o_loglevel loglevel;	//  Log Level

	o_sa	sentaction;	//  Action to sent echomail archives

	byte	wrapline;	//  Wrap at column number

	byte	filecomment;	//  Use 4DOS comments

	byte	killbadmsg;	//  Kill all ill-formed messages

	byte	secureimport;	//  Accept messages from downlinks only
	byte	msgstats;	//  Stats system enabled

	o_dupe	dupeaction;	//  What to do when CM finds a dupe
	word	dupecheck;	//  Dupe check # of messages

	byte	thread;		//  Threading on/off

	byte	rep[10];	//  Report error bytes

	o_fam	fa_net;
	o_fam	fa_echo;        //  FileAttach type
	o_fam	fa_use;

	word	fl_net;		//  Flags for outbound sl netmail
	word	fl_netf;	//  Flags for outbound sl netmail w fattach.

	byte	retries;        //  Retries
	byte	allowpktforward; // Allow .PKT routing

	word	msgbufsize;	//  Advanced msgbuf size bytes
	word	splitat;	//  Advanced split outbound msg at bytes
	word	msgcachesize;	//  Advanced message file cache size

	char	multiwindow;	//  Allow multiple windows (display)

	char	usevia;		//  Use VIA line to mark importing netmail

	o_uuda  uudecode;	//  UUDecoding Action

	byte	localnetimp;	//  Allow local netmail importing
	byte	swapto;		//  Swap to what? (see SPAWNO.H)

	char	system_comment[80];

	byte	enable_cmfix;	//  Enable CMFix

	byte    ihdrcolour;

	char	transxlogfile[45];

	word	defcredits;
	byte	usehlt;
	byte	fidoenabled;

	char	extra[142];	//  extra space for later
};


struct DAreaCfg
{
	char	Tag[40];
	char	SLArea[10];
	char	Group[10];
	o_dyn	export, import, cstrip, secure, dupe;
	o_uudd	uu;
	byte	isusenet, changed;

	long	Links;

	byte	freeze;
	byte	other[3];

	byte	Deleted;
};

struct DAreaIdx
{
	long	TLeft, TRight;
	long	SLeft, SRight;

	ulong	TagCrc, SLAreaCrc;
	ulong   LastDate, LastUid;
};



struct DLink
{
	EMsgStatus	Status;
	long		Next;

	sysznnp		sz;
};

struct DNetPath
{
	char		NetPath[45];
	byte		CMFixScan;
};


struct DGroup
{
	char		group[10];
	long		members;
	long		free[2];
};

struct _cmhdr			//  Header for .CMI files
{
	char	id[6];		//  CMHdr ID Code
	char	tag[40];        //  EchoMail tag area of messages
	char	slarea[10];	//  Searchlight area name
	long	ImportedSL;	//  Position of importing
	long	TossedOut;	//  Position of tossing
	char	AllImported;
	char	AllTossed;
	znnp	RescanAddr;	//  If non-0, is a rescan for this node
	sysznnp Origin;
};

struct _cmmsg			//  Msg hdr structure for .CMI files
{
	char	datetime[20];	//  FTSC-001 date/time
	char	touser[36];
	char	toinet[80];	//  To
	char	fromuser[36];
	char	frominet[80];	//  From
	char	subject[80];	//  Subject
	long    size;		//  Size of message
	char    id[4];  	//  ID of header type (used to be size)
	znnp	orig;		//  Originated from
	znnp	origin;		//  Initially originated from
	byte	usenet;		//  Is a usenet message
	byte	fileattach;	//  Is a file-attached message (netmail)
	byte	noimport;	//  Set if message is exported from SL
	byte	notossing;
	byte	noprocessing;
	byte	headerattached;
	char	orig_i[10];	//  internet last origin
	long	ihdrsize;
	char	spare[4];
};


struct _rescan			//  CMRESCAN.CNF file
{
	char	slarea[9];	//  SLArea name
	word	rescan;		//  Number of messages to rescan
	byte	noexport;	//  Whether area is noexport
	byte	colourstrip;	//  Whether area is colourstripped
	byte	nocolourstrip;  //  Whether area is not colourstripped
	znnp	node;		//  Node to rescan to
};

typedef struct _cmbcmd		//  CMB command definition
{
	char    cmd[20];	//  Command
	byte	nopts;		//  Number of parameters
	char	desc[60];	//  Description of command
	char	room[120];
} cmbcmd;

struct _mainstats		//  Header to STATS.CM file
{
	long	MImport, KImport;	//  #/k messages imported into system
	long	MExport, KExport;	//  #/k messages exported from system
	long	FirstTime;		//  UNIX-style first time used
	long	Extras[10];
};

struct _nodestats		//  Records after header in STATS.CM
{
	sysznnp	sz;			//  System
	long	msg_to;		//  Messages to node
	long	msg_from;	//  Messages from node
	long	k_to;		//  Kilobytes uncompressed to node
	long	k_from;		//  Kilobytes uncompressed from node
	long	dupes;		//  Dupes from node
	long	first_time;	//  UNIX-style first time used
	long	extras[10];
};

struct _dupehdr			//  Header to .DUP files
{
	char	id[6];		//  .DUP file header
	word	next;		//  Next record to use
	word	max;		//  Max dupe records in file
};

struct _dupepkt			//  Records in .DUP file after header
{
	long	msgidcrc;	//  MSGID or CRC of message
	long	crc;		//  CRC of header
	znnp	msgid;		//  Node message from
};


struct _newmsg
{
	sysznnp		from;

	char		group[10];
	char		subfile[45];
	char		subdir[45];
	char		nothing[60];

	char		nameprefix[9];
	byte		autoname;
	byte		makeslsub;
	byte		autocreate;

	byte		other[244];
};

struct _volch
{
	char		addr[50];
	o_fi		fi;
	long		credits;
};


struct TCatMailDB
{
	znnp	system;
	char	sysopname[25];
	word	majver, minver;
	word	regnum;
	long	accession;
	long	capability;
	byte	known;
	char	comment[80];
};

struct _cmb			//  Structure for .CMB files
{
	char	id[6];
	char	progid[10];	//  DOS accepted program name
	char	progname[30];	//  Text program name
	char	progdesc[80];	//  Small description with copyright
	char	author[30];	//  Author's name
	char	vermaj;		//  Version (maj)
	int	vermin;		//  Version (min), 3 digits
	byte	stage;		//  0 = Major Release
				//  1 = Alpha, 2 = Beta, 3 = Gamma

	byte	cmminvermaj;    //  Minimum ChainMail version that
	int	cmminvermin;	//     this CME will run on
	byte	cmmaxvermaj;    //  Maximum ChainMail version that
	int	cmmaxvermin;    //     this CME will run on

	long	expire;		//  Program will not run after this
				//  particular UNIX date/time.

	byte	cfgreq;		//  Set to 1 if a text configuration
				//  file is required to be read from.

	cmbcmd	cmd[50];	//  Command structure, see above.

	long	cmbcrc;	        //  CRC checking
	long	cmecrc;
	long	chksum;
};


#endif

