#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <dos.h>
#include <dir.h>
#include <mem.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#include "cdefs.h"
#include "pktdef.h"
#include "errors.h"
#include "icfg.h"
#include "defs.h"

#include "cmcpkt.h"
#include "cmdisp.h"

#include "id.h"
#include "ver.h"


const	int	WRAPAT	= 74;


int getline(char *write, char *buf)
{
	char 	*point = buf;

	while (*point != '\r' && *point != 0)
	{
		if (*point != '\n')
			*write++ = *point++;
		else
			point++;
	}
	*write++ = *point++;
	*write = 0;
	return (int)((long int)point-(long int)buf);
}

int backline(char *write, char *b, int max)
{
	int	f = 0, g = 0;
	char	*buf = b;
	
	while (*buf == '\r' || !*buf)
	{
		buf--;
		g++;
	}
		
	while (*buf != '\r' && *buf && f <= max)
	{
		if (*buf != '\n')
			write[f++] = *buf;
		buf--;
		g++;
	}

	if (f > 1024)
		Log->error("Abnormally big backline [%d]", f);

	write[f] = 0;
	strrev(write);
	return g;
}

int aline(char *write, char *point)
{
	int 	n = 0;
	char	*p = write;

	while (*p != '\r' && *p)
	{
		*point++ = *p++;
		n++;
	}

	*point++ = *p++;
	return ++n;
}


TToss::TToss(void)
{
	msgbuf      = (char *)farmalloc(cfg->msgbufsize+8);
	line        = new char[2048];
	seenpathbuf = new char[2048];

	memassert(seenpathbuf);
}

TToss::~TToss(void)
{
	farfree(msgbuf);
	delete line;
	delete seenpathbuf;
}


int TToss::TossCMI(void)
{
	ffblk		f;

	char		thing[75], *point;
	int			ff, nl;
	word		nmt = 0, nmta;
	TNodeLink	*al;


	cprintf("Tossing outbound messages to downlinks...\r\n");

	strcpy(thing, cfg->workpath);
	strcat(thing, "*.CMI");

	ff = 200;
	while (1)
	{
		if (ff == 200)
			ff = findfirst(thing, &f, 0);
		else
			ff = findnext(&f);

		if (ff)
			break;

		strupr(f.ff_name);

		if (!stricmp(f.ff_name, "MAIL.CMI"))
			continue;

		nmta = 0;

		sprintf(thing, "%s%s", cfg->workpath, f.ff_name);
		cmifile = fopen(thing, "r+b");

		strcpy(thing, f.ff_name);

		if (cmifile == NULL)
		{
			Log->error("TToss: Unable to open file %s for input", thing);
			continue;
		}

		filesize = filelength(fileno(cmifile));
		setvbuf(cmifile, NULL, _IOFBF, cfg->msgcachesize);

		fread(&cmhdr, sizeof(cmhdr), 1, cmifile);
		if (strcmp(cmhdr.id, CMI_HDR_ID))
		{
			Log->error("TossCMI: File %s is either grunged or obsolete", thing);
			fclose(cmifile);
			continue;
		}

		TScreen Screen;

		areacfg = Area->GetTagArea(cmhdr.tag);
		if (areacfg == NULL)
		{
			cmhdr.TossedOut = filelength(fileno(cmifile));
			goto deliffin;
		}

		if (areacfg->Links == NULL)
		{
			cmhdr.TossedOut = filelength(fileno(cmifile));
			goto deliffin;
		}

		if (cmhdr.TossedOut >= filelength(fileno(cmifile)) ||
			cmhdr.AllTossed)
			goto deliffin;

		if (cmhdr.TossedOut)     // if it's already been tossed a bit :)
			fseek(cmifile, cmhdr.TossedOut, SEEK_SET);

		nl = 0;
		al = areacfg->Links;
		while (al != NULL)
		{
			nl++;
			al = al->next;
		}

		char	ShortTag[80];
		strcpy(ShortTag, areacfg->Tag);
		ShortTag[20] = 0;

		cprintf("   From area %-20s to %02d downlinks : message #0000 [  0%]", ShortTag, nl);

		gotoxy(63, wherey());

		NumMsgsTossed = 0;

		while (!feof(cmifile))
		{
			if (TossMsg(thing) != OK)
				break;

			nmt++;
			nmta++;
			Screen.PrintStatus();
		}
		cputs("\r\n");

		Log->log(LDebug, ' ', "Tossed %d messages from %s", nmta, areacfg->Tag);

deliffin:
		if (feof(cmifile))
			cmhdr.TossedOut = filelength(fileno(cmifile));

		fseek(cmifile, 0L, SEEK_SET);
		fwrite(&cmhdr, sizeof(cmhdr), 1, cmifile);

		fclose(cmifile);

		sprintf(thing, "%s%s", cfg->workpath, f.ff_name);
		if ( (cmhdr.AllTossed || cmhdr.TossedOut >= filesize) &&
			 (cmhdr.AllImported || cmhdr.ImportedSL >= filesize) )
			unlink(thing);
	}

	cprintf("   Tossed %d messages.\r\n\n", nmt);
	return 0;
}



int TToss::TossMsg(char *path)
{
	znnp		old;
	char		*p, *point, s[20];
	TSeenPath	SeenBy, Path;


	cmhdr.TossedOut = msgstart = ftell(cmifile);

	if (fread(&cmmsg, sizeof(_cmmsg), 1, cmifile) == NULL)
		return FAILURE;

	if (strcmp(cmmsg.id, CMI_MSG_ID))
	{
		cputs("\r\n");
		Log->error("%s is either grunged or obsolete at position %ld", path, msgstart);
		fseek(cmifile, msgstart, SEEK_SET);
		return FAILURE;
	}

	if (cmmsg.size == 0)
		return OK;

	moretoread = cmmsg.size > cfg->msgbufsize;
	if (moretoread)
		fseek(cmifile, cmmsg.size-2048, SEEK_CUR);

	point = msgbuf + fread(msgbuf, 1, moretoread ? 2048 : cmmsg.size, cmifile);
	point--;

	while (1)
	{
		p = point;

		point-= backline(line, point, 2000);
		if (strncmp(line, "SEEN-BY:", 8) &&
		    strncmp(line, "\001PATH:", 6))
			break;
	}

	point = p;
	while (*point && *point != '\r')
		point++;

	if (*point == '\r')
		point++;

	loc = point - msgbuf;

	p = point;
	while (*point)
	{
		point+= getline(line, point);

		if (!strncmp(line, "SEEN-BY:", 8))
			SeenBy.ReadLine(line);
		else if (!strncmp(line, "\001PATH:", 6))
			Path.ReadLine(line);
		else
			break;
	}

	// add our seen-bys
	TNodeLink	*dal;
	dal = areacfg->Links;
	while (dal)
	{
		if (dal->sz.GetType() == DFidoNet &&
			dal->sz.z.point == 0 &&
			dal->Status == MSActive &&
			cmmsg.orig != dal->sz.z)

			SeenBy.AddNode(&dal->sz.z);

		dal = dal->next;
	}


	// if no seen-bys, we'll add our own :)
	if (SeenBy.data == NULL)
	{
		znnp dummy;

		dummy.net = Znnp.OurNet(areacfg->Links->sz.z.zone);
		dummy.node = Znnp.OurNode(areacfg->Links->sz.z.zone);
		SeenBy.AddNode(&dummy);
	}


	// write seen-by info
	point = seenpathbuf;
	*point = 0;

	word 		OldNet = 0;
	TZnnpLink	*dzl;

	strcpy(line, "SEEN-BY:");
	dzl = SeenBy.data;

	while (dzl)
	{
		if (OldNet != dzl->z.net)
		{
			OldNet = dzl->z.net;
			sprintf(s, " %d/%d", dzl->z.net, dzl->z.node);
		}
		else
			sprintf(s, " %d", dzl->z.node);

		if (strlen(line)+strlen(s) >= WRAPAT)
		{
			strcat(line, "\r");
			strcat(seenpathbuf, line);
			strcpy(line, "SEEN-BY:");
			sprintf(s, " %d/%d", dzl->z.net, dzl->z.node);
		}

		strcat(line, s);

		dzl = dzl->next;
	}

	strcat(line, "\r");
	strcat(seenpathbuf, line);

	delete SeenBy.data;
	SeenBy.data = NULL;



	// add our path info
	znnp dummy;
	dummy.net = Znnp.OurNet(areacfg->Links->sz.z.zone);
	dummy.node = Znnp.OurNode(areacfg->Links->sz.z.zone);
	Path.AddNode(&dummy);



	// write path info
	strcpy(line, "\x1PATH:");
	dzl = Path.data;
	OldNet = 0;

	while (dzl)
	{
		if (OldNet != dzl->z.net)
		{
			OldNet = dzl->z.net;
			sprintf(s, " %d/%d", dzl->z.net, dzl->z.node);
		}
		else
			sprintf(s, " %d", dzl->z.node);

		if (strlen(line)+strlen(s) >= WRAPAT)
		{
			strcat(line, "\r");
			strcat(seenpathbuf, line);
			strcpy(line, "\x1PATH:");
			sprintf(s, " %d/%d", dzl->z.net, dzl->z.node);
		}

		strcat(line, s);

		dzl = dzl->next;
	}

	strcat(line, "\r");
	strcat(seenpathbuf, line);

	delete Path.data;
	Path.data = NULL;


	long		ksize = ((int)((point-msgbuf) + sizeof(_msghdr) + strlen(cmmsg.touser) + strlen(cmmsg.fromuser) + strlen(cmmsg.subject) + 20) / 1024);
	_nodestats	ns;

	//  Make copies of the message
	dal = areacfg->Links;
	while (dal)
	{
		if (dal->sz.t == DFidoNet &&
			cmmsg.orig != dal->sz.z &&
			dal->Status == MSActive)
		{
			Stats->MainStats.KExport += ksize;
			Stats->MainStats.MExport++;

			Stats->ReadStats(&dal->sz, &ns);
			ns.msg_to++;
			ns.k_to+= ksize;
			Stats->WriteStats(&ns);

			WriteToPkt(&dal->sz.z);
		}

		if (dal->sz.t == DInternet &&
		    stricmp(dal->sz.s, cmmsg.orig_i) &&
		    dal->Status == MSActive)
		{
			Stats->MainStats.KExport += ksize;
			Stats->MainStats.MExport++;

			Stats->ReadStats(&dal->sz, &ns);
			ns.msg_to++;
			ns.k_to+= ksize;
			Stats->WriteStats(&ns);

			WriteToDAT(dal->sz.s);
		}

		dal = dal->next;
	}

	NumMsgsTossed++;

	gotoxy(63, wherey());
	cprintf("%04d [%3d", NumMsgsTossed, ((msgstart+cmmsg.size+sizeof(cmmsg))*100L)/filesize);

	return OK;
}


void TToss::WriteToPkt(znnp *z)
{
	FILE		*pktfile;
	_msghdr		m;
	int		red;
	char		s[50];

	ulong 		curpkt;

	curpkt = CPkt.GetPkt(z, EchoMail);

	sprintf(s, "%sOUTPKT\\%08lX.PKT", cfg->workpath, curpkt);

	if (!access(s, 0))
	{
		pktfile = fopen(s, "r+b");
		fseek(pktfile, 0L, SEEK_END);
	}
	else
	{
		pktfile = fopen(s, "w+b");
		WritePktHeader(z, pktfile);
	}

	memset(&m, 0, sizeof(m));
	m.ident = 2;
	m.orignode = Znnp.OurNode(z->zone);
	m.destnode = z->node;
	m.orignet = Znnp.OurNet(z->zone);
	m.destnet = z->net;

	fwrite(&m, sizeof(m), 1, 	    		    pktfile);
	fwrite(&cmmsg.datetime, strlen(cmmsg.datetime)+1, 1,pktfile);
	fwrite(&cmmsg.touser, strlen(cmmsg.touser)+1, 1,    pktfile);
	fwrite(&cmmsg.fromuser, strlen(cmmsg.fromuser)+1, 1,pktfile);
	fwrite(&cmmsg.subject, strlen(cmmsg.subject)+1, 1,  pktfile);

	if (*areacfg->Tag)
		fprintf(pktfile, "AREA:%s\r", areacfg->Tag);

	if (!moretoread)
	{
//		cprintf("mtr=0; loc=%ld\n", loc);
		fwrite(msgbuf, 1, loc, pktfile);
	}
	else
	{
		fseek(cmifile, msgstart + sizeof(_cmmsg), SEEK_SET);
		loc = cmmsg.size;

//		cprintf("mtr=1; msgstart=%ld, sizeof(_cmmsg)=%ld, loc=%ld.\r\n", msgstart, sizeof(_cmmsg), loc);
		while (loc > 0)
		{
			red = fread(msgbuf, 1, loc > cfg->msgbufsize?cfg->msgbufsize:loc, cmifile);
			fwrite(msgbuf, 1, red, pktfile);
			loc-= red;
		}
	}

	if (cmmsg.usenet == 1)
	{
		fprintf(pktfile, "--- CatMail v"_ver"\r");
		fprintf(pktfile, " * Origin: CatMail Usenet->Fidonet Gate (%s)\r",
				 Znnp.ZnnpToStr(NULL, Znnp.OurZnnp(z->zone)) );
	}

	fputs(seenpathbuf, pktfile);
	fputc('\0', pktfile);
	fclose(pktfile);
}



void TToss::WritePktHeader(znnp *dest, FILE *pktfile)
{
	int	hand;
	char	pkts[80];
	struct	_pkthdr	p;
	struct	time 	t;
	struct	date	d;
	int	lp;

	gettime(&t);
	getdate(&d);

	memset(&p, 0, sizeof(p));

	p.orignode = Znnp.OurNode(dest->zone);
	p.destnode = dest->node;
	p.year = d.da_year;
	p.month = d.da_mon;
	p.day = d.da_day;
	p.hour = t.ti_hour;
	p.minute = t.ti_min;
	p.second = t.ti_sec;
	p.baud = 0;
	p.ident = 2;
	p.orignet = Znnp.OurNet(dest->zone);
	p.destnet = dest->net;

	char *pp = Password->Get(dest);
	if (pp != NULL)
		strcpy(p.password, strupr(pp));

	p.origzone = p.origzone_old = Znnp.OurZone(dest->zone);
	p.destzone = p.destzone_old = dest->zone;
	p.origpoint = Znnp.OurPoint(dest->zone);
	p.destpoint = dest->point;
	p.cwval = 1 << 8;
	p.cw = 1;
	p.auxnet = (p.origpoint) ? p.orignet : 0;

	p.productcode_l = 0x4D;		// M
	p.productcode_h = 0x43;		// C
	p.majrevision = _vermaj;
	p.minrevision = _vermin;

	p.prodspec[0] = 174;

#ifdef RegisteredTo
	p.prodspec[1] = RegistrationNumber & 255;
	p.prodspec[2] = RegistrationNumber >> 8;
#endif
	p.prodspec[3] = 175;

	fwrite(&p, sizeof(p), 1, pktfile);
}

void dot(char *s)
{
	char *p = s;
	while (*p)
	{
		if (*p == ' ')
			*p = '.';
		*p = tolower(*p);
		p++;
	}
}

void fawrite(char *a, long n, FILE *f)
{
	char *p = a;

	while (n)
	{
		if (*p == 1)
			fputc('+', f);
		else if (*p == '\r')
			fputc('\n', f);
		else
			fputc(*p, f);
		p++;
		n--;
	}
}

void TToss::WriteToDAT(char *System)
{
	char	s[120], name[10];
	FILE	*pktfile;
	int	lp;

	for (lp=0; lp<8; lp++)
		name[lp] = random(26) + 65;
	name[8] = 0;

	sprintf(s, "%s%s", Internet.icfg->spoolpath, System);
	FUtil.MakePath(s);

	sprintf(s, "%s%s\\%s.DAT", Internet.icfg->spoolpath, System, name);

	pktfile = fopen(s, "wb");

	if (areacfg->isusenet == 0)
	{
		strcpy(cmmsg.frominet, cmmsg.fromuser);
		dot(cmmsg.frominet);

		strlwr(strcpy(s, areacfg->Tag));
		fprintf(pktfile, "Path: %s!%s\n", Internet.icfg->uucpname, cmmsg.frominet);
		fprintf(pktfile, "Newsgroups: %s\n", s);
		fprintf(pktfile, "Subject: %s\n", cmmsg.subject);
		fprintf(pktfile, "From: %s@f%d.n%d.z%d.fidonet.org (%s)\n", cmmsg.frominet,
			cmmsg.origin.node, cmmsg.origin.net, cmmsg.origin.zone, cmmsg.fromuser);
		fprintf(pktfile, "Message-ID: <%04x%04x@%s>\n", random(32767), random(32767), Internet.icfg->address);

		time_t t = time(0);
		struct tm *tn;
		tn = localtime(&t);

		strftime(s, 80, "Date: %a, %d %b %y %H:%M:%S %Z\n\n", tn);
		fputs(s, pktfile);
	}

	fawrite(msgbuf, loc, pktfile);

	if (moretoread)
	{
		fseek(cmifile, msgstart + sizeof(_cmmsg), SEEK_SET);
		loc = cmmsg.size;

		word red;

		while (loc > 0)
		{
			red = fread(msgbuf, 1, loc > cfg->msgbufsize?cfg->msgbufsize:loc, cmifile);
			fawrite(msgbuf, red, pktfile);
			loc-= red;
		}
	}

	fclose(pktfile);


	sprintf(s, "%s%s\\%s.CMD", Internet.icfg->spoolpath, System, name);
	pktfile = fopen(s, "wb");

	strcpy(s, cmmsg.frominet);
	s[4] = 0;

	fprintf(pktfile, "S %s.dat D.%s%s %s - %s.dat 0666\n",
		name, Internet.icfg->uucpname, name, s, name);
	fprintf(pktfile, "S %s.xqt X.%s%s %s - %s.xqt 0666\n",
		name, Internet.icfg->uucpname, name, s, name);

	fclose(pktfile);


	sprintf(s, "%s%s\\%s.XQT", Internet.icfg->spoolpath, System, name);
	pktfile = fopen(s, "wb");

	fprintf(pktfile, "U news %s\n", Internet.icfg->uucpname);
	fprintf(pktfile, "Z\n");
	fprintf(pktfile, "F D.%s%s\n", Internet.icfg->uucpname, name);
	fprintf(pktfile, "I D.%s%s\n", Internet.icfg->uucpname, name);
	fprintf(pktfile, "C rnews\n");
	fclose(pktfile);
}


void TSeenPath::ReadLine(char *line)
{
	char	*point = line, snode[20], *blob;
	znnp	z;
	TZnnpLink	*tdsp;


	while (!isspace(*point))
		point++;
	while (isspace(*point))
		point++;

	tdsp = data;
	while (tdsp)
	{
		if (tdsp->next == NULL)
			break;
		tdsp = tdsp->next;
	}

	while (*point && *point != '\r')
	{
		blob = snode;

		while (!isspace(*point) && *point)
			*blob++ = *point++;

		while (isspace(*point))
			point++;

		*blob = 0;

		Znnp.StrToZnnp(snode, &z, &old);

		if (data == NULL)
		{
			data = new TZnnpLink;
			tdsp = data;
		}
		else
		{
			tdsp->next = new TZnnpLink;
			tdsp = tdsp->next;
		}

		memcpy(&tdsp->z, &z, sosz);
		memcpy(&old, &z, sosz);
	}
}

void TSeenPath::AddNode(znnp *z)
{
	TZnnpLink	*tdsp;

	tdsp = data;
	while (tdsp)
	{
		if (tdsp->next == NULL)
			break;
		tdsp = tdsp->next;
	}

	if (data == NULL)
	{
		data = new TZnnpLink;
		tdsp = data;
	}
	else
	{
		tdsp->next = new TZnnpLink;
		tdsp = tdsp->next;
	}

	memcpy(&tdsp->z, z, sosz);
	memcpy(&old, &z, sosz);
}
