#include <alloc.h>
#include <string.h>
#include <dos.h>
#include <stdio.h>
#include <time.h>
#include <io.h>
#include <dir.h>

#include "cdefs.h"
#include "cmdb.h"

#include "ver.h"


int TDataBase::LookUp(znnp *a)
{
	FILE	*fptr;
	int	recnum = 0;

	fptr = fopen("catmail.db", "rb");
	if (fptr == NULL)
		return -1;

	while (fread(CatRec, sizeof(TCatMailDB), 1, fptr))
	{
		if (CatRec->system == *a)
		{
			fclose(fptr);
			return recnum;
		}
		recnum++;
	}

	memset(CatRec, 0, sizeof(TCatMailDB));
	fclose(fptr);

	return -1;
}


#pragma argsused
void TDataBase::Send(znnp *a, DBType type, char *data, word datalen)
{
	char		thing[120];
	FILE		*fptr;
	_catpkt		cp;

	return;
/*
	memset(&cp, 0, sizeof(cp));
	memcpy(&cp.from, &cfg->address[0], sosz);
	memcpy(&cp.to, a, sosz);
	strcpy(cp.sysopname, cfg->sysop);
	cp.majver = _vermaj;
	cp.minver = _vermin;
#ifdef RegisteredTo
	cp.regnum = RegistrationNumber;
#endif
	cp.accession[0] = RegInfo->accession[0];

	switch (type)
	{
	  case AreAccessionsSame:
		cp.accession[1] = RegInfo->accession[1];
		break;

	  case AreOverridesSame:
		cp.accession[1] = RegInfo->accession[1];
		cp.override[0] = RegInfo->override[0];
		cp.override[1] = RegInfo->override[1];
		break;
	}

	cp.capability = 1;
	cp.command = type;
	strcpy(cp.comment, cfg->system_comment);

	ulong Pkt = CPkt.GetPkt(&cp.to, CATFile);

	sprintf(thing, "%sOUTPKT\\%08lX.CAT", cfg->workpath, Pkt);
	fptr = fopen(thing, "wb");
	fwrite(&cp, sizeof(cp), 1, fptr);
	if (data != NULL)
		fwrite(data, 1, datalen, fptr);
	fclose(fptr);*/
}

void TDataBase::Add(znnp *z, TKnown known)
{
	_catpkt	cp;

	memset(&cp, 0, sizeof(cp));
	memcpy(&cp.from, z, sosz);

	Add(&cp, known);
}


void TDataBase::Add(_catpkt *cp, TKnown known)
{
	FILE		*fptr;
	int		n;


	n = LookUp(&cp->from);

	if (access("catmail.db", 0))
		fptr = fopen("catmail.db", "wb");
	else
	{
		fptr = fopen("catmail.db", "r+b");
		fseek(fptr, 0, SEEK_END);
	}

	if (n != -1)
		fseek(fptr, n*sizeof(TCatMailDB), SEEK_SET);

	memset(CatRec, 0, sizeof(TCatMailDB));
	memcpy(&CatRec->system, &cp->from, sosz);
	strcpy(CatRec->sysopname, cp->sysopname);
	CatRec->majver = cp->majver;
	CatRec->minver = cp->minver;
	CatRec->regnum = cp->regnum;
	CatRec->accession = cp->accession[0];
	CatRec->capability = cp->capability;
	CatRec->known = known;
	strcpy(CatRec->comment, cp->comment);

	fwrite(CatRec, sizeof(TCatMailDB), 1, fptr);

	fclose(fptr);
}


void TDataBase::InboundLook(void)
{
	FILE	*fptr;
	struct 	ffblk	f;
	int	n;
	char	thing[120], *point;
	struct	_catpkt		cp;


	sprintf(thing, "%s*.CAT", cfg->workpath);
	n = findfirst(thing, &f, 0);
	while (!n)
	{
		sprintf(thing, "%s%s", cfg->workpath, f.ff_name);
		fptr = fopen(thing, "rb");
		fread(&cp, sizeof(cp), 1, fptr);
		fclose(fptr);

		if (Znnp.IsOurAddr(&cp.from) || !Znnp.IsOurAddr(&cp.to))
		{
			n = findnext(&f);
			continue;
		}

		if (cp.accession[0] == RegInfo->accession[0])
			Send(&cp.from, AreAccessionsSame);

		switch (cp.command)
		{
		  case NothingMuch:
			Add(&cp, Definite);
			break;

		  case AreYouCatMail:
			Send(&cp.from, NothingMuch);
			Add(&cp, Definite);
			break;
		}

		n = findnext(&f);
	}
}


TRegInfo::TRegInfo(void)
{
	memset(this, 0, sizeof(TRegInfo));
	strcpy(regname, "Beta Testers");
	strcpy(regbbs, "Beta BBS");
	expiry = 1262405708L;
}

TRegInfo::~TRegInfo(void)
{
	memset(this, 0, sizeof(TRegInfo));
}

