//  Classes defined in CMDB.C  ==========================================

enum DBType { NothingMuch, AreYouCatMail, AreAccessionsSame,
		AreOverridesSame };

enum TKnown { NotKnown, Possible, Definite, Friend, BadSystem };


class TDataBase
{
  private:
	struct _catpkt		// format of outbound .CAT files
	{
		znnp	from, to;
		char	sysopname[25];
		word	majver, minver;
		word	regnum;
		long    accession[2], override[2];
		long	capability;
		DBType	command;
		char	comment[80];
	};

  public:
	TCatMailDB	*CatRec;

	TDataBase(void) { CatRec = new TCatMailDB; }
	~TDataBase(void) { delete CatRec; }

	void 		InboundLook(void);
	int 		LookUp(znnp *);
	void 		Send(znnp *, DBType, char * = 0, word = 0);

	void 		Add(_catpkt *, TKnown);
	void 		Add(znnp *, TKnown);
	void 		AddType1(znnp *);
};
