#include <conio.h>
#include <alloc.h>
#include <stdio.h>
#include <process.h>
#include <errno.h>
#include <io.h>
#include <string.h>

#include "cdefs.h"
#include "errors.h"

#include "cmext.h"
#include "cmpkt.h"

char	cme[10];

int TExternal::CallCMB(char *filename, char *cmdline = NULL)
{
	int 	n, nn, ret;
	char	*cmd[10];

	n = 1;
	nn = 1;
	cmd[0] = new char[75];
	sprintf(cmd[0], "%s%s", cfg->cmpath, filename);

	if (cmdline != NULL)
	{
		while (n < 20)
		{
			cmd[n] = new char[45];
			SUtil.aword(cmdline, nn, cmd[n]);
			if (!*cmd[n])
				break;
			n++;
			nn++;
		}
	}

	cmd[n] = NULL;

	fclose(Area->areafile);	// close AREA.CM
	fclose(Area->linkfile);

	delete Stats;

	ret = spawnv(P_WAIT, filename, cmd);

	Stats = new TStats;

	Area->areafile = fopen(FUtil.CMPath("AREA.CM"), "r+b"); // and open it again
	Area->linkfile = fopen(FUtil.CMPath("AREALINK.CM"), "r+b");

	for (;n>=0;n--)
		delete cmd[n];

	return ret;
}


void TExternal::Call(char *filename, int abort)
{
	int	n;
	int	tries = cfg->retries + 1;

retry:
	if (!tries--)
		return;
	strcpy(cme, "CME.CME");
	n = CallCMB(cme, filename);

	if (!access("newsub.cmd", 0))
	{
		TPkt	Pkt;
		Pkt.MailToSysOp(NEW_AREA);
	}

	switch (n)
	{
	  case OK:
	      break;

	  case -1:
	     switch (errno)
	     {
		case ENOENT:
		    Log->error("Unable to find and/or execute external program CME.CME (%s)", filename);
		    if (abort)
			Sys.bye(20);
		    break;
		case ENOMEM:
		    Log->error("Not enough memory to call external program CME.CME (%s)", filename);
		    if (abort)
			Sys.bye(NO_MEM);
		    break;
		default:
		    Log->baderror("External program execution error (CME.CME [%s], %d)", filename, errno);
		    Sys.bye(250);
	     }
	     break;

	  case 4:
	      Log->error("Out of file handles");
	      cprintf("       Increase the number of FILES in your CONFIG.SYS file.\r\n");
	      return;

	  case 30:
	      Log->error("Unable to open external configuration file");
	      cprintf("       Make sure you have enough HD space and RAM free.\r\n");
	      return;

	  case 31:
	      Log->error("Invalid command passing in external CME.CME");
	      cprintf("       You may have mismatched versions you are running.  Try reinstalling\r\n");
	      cprintf("       the executable files.\r\n");
	      return;

	  case 32:
	      Log->error("Unable to open Searchlight configuration files in %s", filename);
	      cprintf("       Most likely you do not have your SLBBS environment variable\r\n");
	      cprintf("       correctly set.  It is also possible that your data files are\r\n");
	      cprintf("       corrupt or you do not have enough FILES to open.  Increase\r\n");
	      cprintf("       the number of FILES in your CONFIG.SYS if SLBBS is correct.\r\n\n");
	      goto retry;

	  case 33:
	      Log->error("Insufficent memory to execute CME.CME");
	      cprintf("       Free some more memory and rerun CatMail.\r\n");
	      return;

	  case 2:
	      Log->error("Critical runtime error occurred in external program CME.EXE [%s]", filename);
	      cprintf("       Take note of the runtime error and address given to you above.\r\n");
	      cprintf("       Match the runtime error number in the CMERROR.LST file.\r\n\n");
	      cprintf("       Check for disk space, file handles, file sharing clashes, and\r\n");
	      cprintf("       repair the subboard that the above program crashed on in CONFIG.\r\n");
	      cprintf("       Run CHKDSK if you can't find anything wrong, and if still in doubt\r\n");
		  cprintf("       report to the author with error, address and version number.\r\n\n");
		  goto retry;


	  case 255:
	      Log->error("User break from external program.  Aborting.");
	      Sys.bye(255);

	  default:
	      Log->baderror("Unknown return code.  (CME.CME [%s], %d)", filename, n);
	}
}
