#include "cdefs.h"
#include "cmnet.h"


class TGroupRec
{
  public:
	TGroupRec	*next;

	char		group[10];
	TNodeLink	*l;

	TGroupRec(void) { next = NULL; l = NULL; }
	~TGroupRec(void) { delete next; }
};

class TGroup
{
	FILE		*grpf, *mbrf;
	TGroupRec	*data;

  public:
	TGroup(void);
	~TGroup(void);

	int	IsInList(char *, znnp *);
	int	IsInList(char *, char *);

	int 	IsInAGroup(znnp *);
	int 	IsInAGroup(char *);
};


class TFixAlias
{
  public:
	TFixAlias	*next;
	char		alias[36];

	TFixAlias(void) { next = NULL; }
	~TFixAlias(void) { delete next; }
};


class TCMFix
{
  public:
	TFixAlias	*Alias;

  private:
	TGroup		*Group;
	char		*CmdName, *CmdLine;

	znnp		MsgFor, aorig;
	FILE		*newmsg;

	int		IsCMFixAlias(char *);
	int		nmp;

	void	CmdHelp(void);
	void    CmdList(void);
	void	CmdQuery(void);
	void	CmdUnlinked(void);
	void	CmdPauseResume(void);
	void	CmdHubList(void);
	void	CmdRescan(void);
	void	CmdCreate(void);
	void	CmdDelete(void);

	void	AreaAdd(char *);
	void	AreaDelete(char *);

	void		InitArea(void);
	TAreaCfg *	GetNextArea(void);
	TAreaCfg *	GetMyNextArea(void);
	int 		WildCardMatch(char *str, char *wildstr);


  public:
	TCMFix(void);
	~TCMFix(void);

	int 		Scan(void);
	int		Process(char *, char *);
	int 		ProcessMsg(_netmail *, char *);

	int 		ScanNetmail(void);
};

