// We still must add file attach capabilities for PackMSG.


#include <alloc.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <share.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "cdefs.h"
#include "cmnet.h"
#include "pktdef.h"
#include "errors.h"
#include "cmfix.h"

#include "id.h"
#include "ver.h"


TNet::TNet(void)
{
	memset(this, 0, sizeof(TNet));
	msgbuf = new char[cfg->msgbufsize+4];

	memassert(msgbuf);
}

TNet::~TNet(void)
{
	delete msgbuf;
}


int TNetImport::Process(char *file, char *curnetpath)
{
	FILE		*msgfile, *cmifile, *newfile;
	_netmail        net;
	_cmmsg		cmmsg;
	znnp		ato, afrom;
	long		BytesRead, TotBytesRead;
	char		*point;
	int		lp;


	msgfile = _fsopen(file, "rb", SH_DENYNONE);
	if (msgfile == NULL)
	{
		Log->error("Can't open .MSG file for importing, try again later.");
		return 0;
	}

	fread(&net, sizeof(net), 1, msgfile);

	if (!cfg->localnetimp && (net.attrib & Local))
	{
		fclose(msgfile);
		return 0;			// if it's written from here
	}


	TotBytesRead = BytesRead = FUtil.fngets(msgbuf, cfg->msgbufsize, msgfile);


	Znnp.FindAddr(&net, msgbuf, &afrom, &ato, NULL);

	if (!memcmp(&afrom, &ato, sosz) || !Znnp.IsOurAddr(&ato))
	{
		fclose(msgfile);
		return 0;               // if it's to and from us,
	}				// or not to us at all...

	point = msgbuf;
	while (*point == 1)
	{
		if (!strncmp("\001Via CatMail", point, 12))
		{
			fclose(msgfile);
			return 0;			// If it's already in
		}

		while (*point != 0 && *point != '\r')
			point++;
		while (*point == '\r')
			point++;
	}

	if (!*point)
	{
		fclose(msgfile);
		return 0;	// If it's a blank message
	}


	if (!stricmp(net.touser, "cmfix") || !stricmp(net.touser, "areafix"))
	{
		fclose(msgfile);
		return 0;
	}

	FILE *ffptr = fopen(FUtil.CMPath("FIXALIAS.CM"), "rb");
	if (ffptr != NULL)
	{
		char	s[40];

		while (fread(s, 35, 1, ffptr) != NULL)
		{
			if (!stricmp(net.touser, s))
			{
				fclose(ffptr);
				fclose(msgfile);
				return 0; 		// if it's a CMFix alias
			}
		}
	}
	fclose(ffptr);


	MsgsImported++;

	memset(&cmmsg, 0, sizeof(cmmsg));
	strcpy(cmmsg.id, CMI_MSG_ID);
	strcpy(cmmsg.datetime, net.datetime);
	strcpy(cmmsg.touser, net.touser);
	strcpy(cmmsg.fromuser, net.fromuser);
	strcpy(cmmsg.subject, net.subject);
	cmmsg.orig.net = net.orignet;
	cmmsg.orig.node = net.orignode;
	memcpy(&cmmsg.origin, &afrom, sizeof(znnp));

	char thing[45];

	sprintf(thing, "%sMAIL.CMI", cfg->workpath);

	if (access(thing, 0))
	{
		_cmhdr	cmhdr;

		cmifile = fopen(thing, "wb");
		memset(&cmhdr, 0, sizeof(cmhdr));
		strcpy(cmhdr.id, CMI_HDR_ID);
		strcpy(cmhdr.tag, "*Netmail");
		cmhdr.TossedOut = 0xFFFFFFFFL;
		fwrite(&cmhdr, sizeof(cmhdr), 1, cmifile);
	}
	else
	{
		cmifile = fopen(thing, "r+b");
		fseek(cmifile, 0, SEEK_END);
	}

	long hdrstart = ftell(cmifile);


	char 	tmpfile[55];
	sprintf(tmpfile, "%s%s", curnetpath, tmpnam(NULL));
	newfile = fopen(tmpfile, "wb");

	fwrite(&cmmsg, sizeof(_cmmsg), 1, cmifile);
	fwrite(&net, sizeof(_netmail), 1, newfile);

	fputs("\001Via CatMail v"_ver"\r", newfile);

	fwrite(msgbuf, 1, BytesRead, cmifile);
	fwrite(msgbuf, 1, BytesRead, newfile);

	while (BytesRead == cfg->msgbufsize)
	{
		BytesRead = FUtil.fngets(msgbuf, cfg->msgbufsize, msgfile);
		TotBytesRead+= BytesRead;
		fwrite(msgbuf, 1, BytesRead, cmifile);
		fwrite(msgbuf, 1, BytesRead, newfile);
	}

	fseek(cmifile, hdrstart, SEEK_SET);
	cmmsg.size = TotBytesRead;
	fwrite(&cmmsg, sizeof(_cmmsg), 1, cmifile);

	fclose(cmifile);
	fclose(msgfile);
	fclose(newfile);


	unlink(file);
	rename(tmpfile, file);

	return 0;
}


#pragma argsused
int TNetExport::Process(char *file, char *curnetpath)
{
	FILE		*msgfile, *pktfile;
	_netmail        net;
	_msghdr		m;
	znnp		ato, afrom;
	long		BytesRead;
	char		*point;


	msgfile = _fsopen(file, "r+b", SH_DENYNONE);
	if (msgfile == NULL)
	{
		Log->error("Can't open .MSG file for importing, try again later.");
		return 0;
	}

	fread(&net, sizeof(net), 1, msgfile);

	if ((net.attrib & Recd) || (net.attrib & Sent))
	{
		fclose(msgfile);
		return 0;
	}

	BytesRead = FUtil.fngets(msgbuf, cfg->msgbufsize, msgfile);

	Znnp.FindAddr(&net, msgbuf, &afrom, &ato, NULL);

	if (memcmp(&afrom, &ato, sizeof(znnp)) ||
	    Znnp.IsOurAddr(&ato))
	{
		fclose(msgfile);
		return 0;               // if it's to and from us,
	}				// or to us at all...

	MsgsExported++;

	long PktName = CPkt.GetPkt(&ato, NetMail);

/*		****  Wee need to make file attaches work!
	if (typ)
	{
		char	thing[120], *point;

		net_fileattach(net.subject, p);
		strcpy(thing, net.subject);
		point = (char *)strrchr(thing, '\\');
		if (point != NULL)
			strcpy(net.subject, point+1);
		else
			strcpy(net.subject, thing);
		strupr(net.subject);
	}
*/
	point = new char[55];
	memassert(point);

	sprintf(point, "%s%08lX.PKT", cfg->workpath, PktName);
	pktfile = fopen(point, "r+b");
	fseek(pktfile, 0L, SEEK_END);

	delete point;

	memset(&m, 0, sizeof(m));

	m.ident = 2;
	m.orignode = net.orignode;
	m.destnode = net.destnode;
	m.orignet = net.orignet;
	m.destnet = net.destnet;
	m.attrib = net.attrib;

	fwrite(&m, sizeof(m), 1, pktfile);
	fwrite(net.datetime, 1, strlen(net.datetime)+1, pktfile);
	fwrite(net.touser, 1, strlen(net.touser)+1, pktfile);
	fwrite(net.fromuser, 1, strlen(net.fromuser)+1, pktfile);
	fwrite(net.subject, 1, strlen(net.subject)+1, pktfile);

	fwrite(msgbuf, 1, BytesRead, pktfile);
	while (BytesRead == cfg->msgbufsize)
	{
		BytesRead = FUtil.fngets(msgbuf, cfg->msgbufsize, msgfile);
		fwrite(msgbuf, 1, BytesRead, pktfile);
	}

	if (!Znnp.IsOurAddr(&ato) && !Znnp.IsOurAddr(&afrom))
	{
		time_t	t;
		struct	tm	*tn;

		Log->log(LAverage, '%', "Forwarding mail from %s (%s) to %s (%s)",
			net.fromuser, Znnp.ZnnpToStr(NULL, &afrom),
			net.touser, Znnp.ZnnpToStr(NULL, &ato));

		cprintf("    Forwarding mail from %s (%s) to %s (%s)",
			net.fromuser, Znnp.ZnnpToStr(NULL, &afrom),
			net.touser, Znnp.ZnnpToStr(NULL, &ato));

#ifdef RegisteredTo
		fprintf(pktfile, "\r\001Via CatMail "_ver"/%04d %d:%d/%d.%d, ",
			RegistrationNumber,
#else
		fprintf(pktfile, "\r\001Via CatMail "_ver" UNREGISTERED %d:%d/%d.%d, ",
#endif
			Znnp.OurZone(ato.zone), Znnp.OurNet(ato.zone),
			Znnp.OurNode(ato.zone), Znnp.OurPoint(ato.zone));

		point = new char[80];
		memassert(point);

		tzset();
		t = time(NULL);
		tn = localtime(&t);
		strftime(point, 80, "%a %d %b %y at %H:%M:%S UTC\r", tn);
		fprintf(pktfile, point);

		delete point;
	}
	else
	{
		Log->log(LVerbose, '%', "Packing netmail from %s (%s) to %s (%s)",
			net.fromuser, Znnp.ZnnpToStr(NULL, &afrom),
			net.touser, Znnp.ZnnpToStr(NULL, &ato));

		cprintf("    Packing netmail from %s (%s) to %s (%s)",
			net.fromuser, Znnp.ZnnpToStr(NULL, &afrom),
			net.touser, Znnp.ZnnpToStr(NULL, &ato));
	}

	if (net.attrib & KillSent)
	{
		fclose(msgfile);
		unlink(file);
	}
	else
	{
		fseek(msgfile, 0L, SEEK_SET);
		net.attrib|= Sent;
		fwrite(&net, sizeof(net), 1, msgfile);
		fclose(msgfile);
	}

	fclose(pktfile);

	return OK;
}


int TNet::ScanNetmail(void)
{
	ffblk		f;
	char		path[75], file[75];
	int		n;
	DNetPath	np;
	FILE		*fptr;

	fptr = fopen(FUtil.CMPath("NETPATH.CM"), "rb");

	sprintf(path, "%s*.MSG", cfg->netpath);

	do
	{
		n = findfirst(path, &f, 0);

		while (!n)
		{
			sprintf(file, "%s%s", cfg->netpath, f.ff_name);
			path[strlen(path)-5] = 0;

			if (Process(file, path))
				break;

			n = findnext(&f);
		}

		*path = 0;

		if (fptr != NULL && fread(&np, sizeof(np), 1, fptr))
			sprintf(path, "%s*.MSG", np.NetPath);
	}
	while (*path);

	if (fptr != NULL)
		fclose(fptr);

	return OK;
}


int TNet::Import(void)
{
	TNetImport	NetImport;

	cprintf("Scanning for new inbound netmail messages...");

	int n = NetImport.ScanNetmail();

	if (n == OK)
	{
		cprintf("\r\n   Imported %d netmail messages.\r\n\n", NetImport.MsgsImported);
		if (NetImport.MsgsImported)
			Log->log('+', "Imported %d netmail messages", NetImport.MsgsImported);
	}

	return n;
}


int TNet::Export(void)
{
	if (cfg->mailertype != M_Binkley && cfg->mailertype != M_Portal)
	{
		cprintf("Option PACK may only be run under a BinkleyTerm or Portal mailer.\r\n");
		Log->log('!', "Invalid option PACK for this mailer");
		return FAILURE;
	}

	cprintf("Packing new outbound netmail messages...");

	TNetExport	NetExport;

	int n = NetExport.ScanNetmail();

	if (n == OK)
	{
		cprintf("\r\n    Packed %d netmail messages.\r\n", NetExport.MsgsExported);
		if (NetExport.MsgsExported)
			Log->log('+', "Packed %d outbound netmail messages", NetExport.MsgsExported);
	}

	return n;
}


void TGenNet::NextFreeR(char *thing, char *path)
{
	int	l, n, lp = 1;
	struct	ffblk	f;

	SUtil.AddSlash(path);

	sprintf(thing, "%s*.msg", path);

	n = findfirst(thing, &f, 0);
	while (!n)
	{
		l = atoi(f.ff_name);
		if (l > lp)
			lp = l;
		n = findnext(&f);
	}

	sprintf(thing, "%s%d.msg", path, ++lp);
}

void TGenNet::NextFree(char *thing, int arcdir)
{
	if (arcdir)
		NextFreeR(thing, cfg->arcnetpath);
	else
		NextFreeR(thing, cfg->netpath);
}


int TGenNet::SendMsg(struct _netmail *net, char *msg, int len, char incvia)
{
	char	thing[120];

	NextFree(thing, 0);
	return SendMsg(thing, net, msg, len, incvia);
}

int TGenNet::SendMsg(char *path, struct _netmail *net, char *msg, int len, char incvia)
{
	FILE	*fptr;
	char	thing[120];
	znnp	tonode, fromnode;


	if (!stricmp(net->fromuser, "sysop") && cfg->rennet)
		strcpy(net->fromuser, cfg->sysop);


	Znnp.FindAddr(net, msg, &fromnode, &tonode, NULL);
	close(_creat(path, 0));

	fptr = fopen(path, "wb");
	if (fptr == NULL)
		return FAILURE;
	fwrite(net, sizeof(struct _netmail), 1, fptr);

	if (Znnp.IsOurAddr(&tonode) && incvia)
	{
#ifdef RegisteredTo
		sprintf(thing, "\001Via "_pid" %04d\r", RegistrationNumber);
#else
		sprintf(thing, "\001Via "_pid" UNREGISTERED COPY\r");
#endif
		fwrite(thing, 1, strlen(thing), fptr);
	}

	fwrite(msg, 1, len, fptr);
	fclose(fptr);

	if (*cfg->rescanfile)
		close(_creat(cfg->rescanfile, 0));
	return OK;
}

