#include <alloc.h>
#include <conio.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys\stat.h>

#include "cdefs.h"
#include "errors.h"
#include "crc32.h"

#include "cmutils.h"


char *TSUtil::AddSlash(char *thing)
{
	if (thing[strlen(thing)-1] != '\\')
		strcat(thing, "\\");

	return thing;
}

char *TSUtil::KillRet(char *thing)
{
	while (thing[strlen(thing)-1] == '\r' || thing[strlen(thing)-1] == '\n')
		thing[strlen(thing)-1] = 0;

	return thing;
}

char *TSUtil::aword(char *othing, int n, char *ext)
{
	int     lp, qm = 0;
	char    *point, thingy[260];
	char	*thing = othing;

	while (1)
	{
		while (*thing == 32 || *thing == '\t')
			thing++;
		if (!--n)
			break;

		while (1)
		{
			if (*thing == 34)
				qm = 1 - qm;

			if (*thing == '\n' || *thing == 0 || *thing == '\r')
				break;

			if (!qm)
				if (*thing != 32 && *thing != '\t')
				{
					thing++;
					continue;
				}
				else
					break;
			thing++;
			continue;
		}

		if (*thing == 0 || *thing == '\n' || *thing == '\r')
		{
			ext[0] = 0;
			return NULL;
		}
	}

	if (qm)
	{
		ext[0] = 0;
		return NULL;
	}
	strcpy(ext, thing);
	for (lp=0; lp<strlen(ext); lp++)
	{
		if (ext[lp] == 34)
			qm = 1 - qm;
		if ((ext[lp] == '\t' || ext[lp] == 32) && !qm)
		{
			ext[lp] = 0;
			break;
		}
	}
	KillRet(ext);
	if (ext[0] == '\"' || ext[0] == '\'')
	{
		point = ext;
		point++;
		strcpy(thingy, point);
		strcpy(ext, thingy);
		ext[strlen(ext)-1] = 0;
	}
	return ext;
}

void TSys::bye(byte error)
{
	if (cfg->loglevel > LTerse)
		Log->log('+', "Closing down CatMail");

	// unlink old files that they may still have

	unlink(FUtil.CMPath("CMINUSE.FLG"));
	cprintf("\r\n");

	exit(error);
}

ulong atolx(char *s)
{
	int	lp, c;
	ulong	r = 0;
	char	ms[10];

	if (strlen(s) > 8)
		return 0L;

	strcpy(ms, s);
	strrev(ms);
	strupr(ms);

	for (lp=0; lp<strlen(ms); lp++)
	{
		if (ms[lp] >= 'A')
			c = ms[lp] - 'A' + 10;
		else c = ms[lp] - '0';

		r|= ((ulong)c << (4L * lp));
	}

	return r;
}


int TZnnp::FindAddr(_netmail *n, char *msgbuf, znnp *from, znnp *to, _dupepkt *dp = NULL)
{
	char	*point;
	char	*thing = new char[255], *s = new char[40], *t = new char[40];
	int	lp;
	ulong	mi;
	word	a, b;

	memassert(thing);
	memassert(t);

	memset(from, 0, sizeof(znnp));
	memset(to, 0, sizeof(znnp));

	if (n != NULL)
	{
		from->net  = n->orignet;
		from->node = n->orignode;
		to->net    = n->destnet;
		to->node   = n->destnode;
	}

	point = msgbuf;

	while (*point == 1)
	{
		lp = 0;

		while (*point != '\r' && *point != 0)
			thing[lp++] = *point++;

		thing[lp] = 0;
		if (strstr(thing, "\001INTL"))
		{
			a = to->point;
			b = from->point;
			sscanf(thing, "%*s %s %s", s, t);
			StrToZnnp(s, to);
			StrToZnnp(t, from);
			to->point = a;
			from->point = b;
		}

		if (strstr(thing, "\001MSGID"))
		{
			sscanf(thing, "%*s %s %s", s, t);
			mi = atolx(t);
			StrToZnnp(s, from);
			if (dp != NULL)
				dp->msgidcrc = mi;
		}

		if (strstr(thing, "\001MSGTO"))
		{
			sscanf(thing, "%*s %s", s);
			StrToZnnp(s, from);
		}

		if (strstr(thing, "\001TOPT"))
			sscanf(thing, "%*s %d", &to->point);

		if (strstr(thing, "\001FMPT"))
			sscanf(thing, "%*s %d", &from->point);

		while (*point == '\r') point++;
	}

	if (from->net == 0)
	{
		delete thing; delete s; delete t;
		return FAILURE;
	}

	if (from->zone == 0 && to->zone)
		from->zone = to->zone;

	if (to->zone == 0 && from->zone)
		to->zone = from->zone;

	if (from->zone == 0 && to->zone == 0)
	{
		int	lp;
		for (lp=0; lp<15; lp++)
		{
			if (cfg->address[lp].net == to->net ||
			    cfg->address[lp].net == from->net)
			{
				from->zone = to->zone = cfg->address[lp].zone;
				break;
			}
		}

		if (from->zone == 0)
		{
			Log->log(LDebug, '~', "TZnnp::FindAddr taken zone from cfg->address[0]");
			from->zone = to->zone = cfg->address[0].zone;
		}
	}

	if (dp != NULL)
		memcpy(&dp->msgid, from, sosz);

	delete thing; delete s; delete t;
	return OK;
}

int TSys::IsAnotherCopyRunning(void)
{
	char		flg[55];
	struct	stat	s;

	sprintf(flg, "%sCMINUSE.FLG", cfg->cmpath);
	if (access(flg, 0))
		return 0;

	stat(flg, &s);

	if (s.st_atime > time(0)+(60*60*3))
		return 0;

	return 1;
}

void TSys::CopyIsRunning(void)
{
	close(_creat(FUtil.CMPath("CMINUSE.FLG"), 0));
}

int TFUtil::IsEnoughHDSpace(char *path, long bytes)
{
	struct 	dfree 	free;
	long 	avail;
	int 	drive;

	if (path[1] != ':')
		drive = getdisk() + 1;
	else
		drive = toupper(path[0])-64;

	getdfree(drive, &free);
	if (free.df_sclus == 0xFFFF)
	{
		Log->baderror("Error in getdfree() call in enough_space()");
		return 0;
	}

	avail = (long)free.df_avail * (long)free.df_bsec * (long)free.df_sclus;

	return (avail >= bytes);
}

char *TUtil::GetFTSCDate(char *s)
{
	struct	tm *tmn;
	time_t	tmnt;

	static char internal[30];

	if (s == NULL)
		s = internal;

	time(&tmnt);
	tmn = localtime(&tmnt);
	strftime(s, 80, "%d %b %y  %H:%M:%S", tmn);

	return s;
}	

unsigned long int find_crc32(char *str)
{
	register unsigned long oldcrc32;
	char *point = str;

	oldcrc32 = 0xFFFFFFFF;

	while (*point)
	{
		oldcrc32 = UPDC32(*point, oldcrc32);
		point++;
	}

	return oldcrc32;
}

int esc_pressed(void)
{
	if (kbhit())
	{
		char ch = getch();
		if (ch != 27)
			ungetch(ch);
		else
			return 1;
	}

	return 0;
}





//  TZnnp class

int TZnnp::StrToZnnp(char *thing, znnp *z)
{
	char *thingy = new char[50], *str = new char[50], *point;

	strcpy(thingy, thing);
	if (strchr(thingy, '.') == NULL)
		strcat(thingy, ".0");


	point = (char *)strchr(thingy, ':');
	if (!point)
	{
		delete thingy; delete str;
		return 1;
	}
	*point = 0;
	if (!stricmp(thingy, "all") || !stricmp(thingy, "*"))
		z->zone = -1;
	else
		z->zone = atoi(thingy);

	strcpy(str, point+1);
	point = (char *)strchr(str, '/');
	if (!point)
	{
		delete thingy; delete str;
		return 1;
	}
	*point = 0;
	if (!stricmp(str, "all") || !stricmp(str, "*"))
		z->net = -1;
	else
		z->net = atoi(str);

	strcpy(thingy, point+1);
	point = (char *)strchr(thingy, '.');
	if (!point)
	{
		delete thingy; delete str;
		return 1;
	}
	*point = 0;
	if (!stricmp(thingy, "all") || !stricmp(thingy, "*"))
		z->node = -1;
	else
		z->node = atoi(thingy);

	if (!stricmp(point+1, "all") || !stricmp(point+1, "*"))
		z->point = -1;
	else
		z->point = atoi(point+1);

	delete thingy;  delete str;

	return 0;
}

int TZnnp::StrToZnnp(char *thing, znnp *z, znnp *old)
{
	char *thingy = new char[50], *str = new char[50], *point;
	char pz = 0;

	strcpy(thingy, thing);

	if (!strcmp(thingy, "*"))
		strcpy(thingy, "*:*/""*.*");

	if (strchr(thingy, '/') == NULL && strchr(thingy, ':') != NULL)
		strcat(thingy, "/""*.*");
	if (strchr(thingy, '.') == NULL)
	{
		strcat(thingy, ".0");
		pz = 1;
	}

	memcpy(z, old, sizeof(znnp));
	
	point = (char *)strchr(thingy, ':');
	if (!point) 
		strcpy(str, thingy);
	else
	{
		*point = 0;
		if (!stricmp(thingy, "all") || !stricmp(thingy, "*"))
			z->zone = -1;
		else
			z->zone = atoi(thingy);
	
		strcpy(str, point+1);
	}
	
	point = (char *)strchr(str, '/');
	if (!point)
		strcpy(thingy, str);
	else
	{
		*point = 0;
		if (!stricmp(str, "all") || !stricmp(str, "*"))
			z->net = -1;
		else
			z->net = atoi(str);
	
		strcpy(thingy, point+1);
	}
	
	point = (char *)strchr(thingy, '.');
	*point = 0;
	if (*thingy)
	{
		if (!stricmp(thingy, "all") || !stricmp(thingy, "*"))
			z->node = -1;
		else
			z->node = atoi(thingy);
	}

	if (z->node == 65535 && pz == 1)
		z->point = -1;
	else
	{
		if (!stricmp(point+1, "all") || !stricmp(point+1, "*"))
			z->point = -1;
		else
			z->point = atoi(point+1);
	}

	delete thingy;
	delete str;

	return 0;
}

char *TZnnp::ZnnpToStr(char *thing, znnp *z)
{
	static	char	int_thing[20];
	char	*nthing;

	if (thing == NULL)
		nthing = int_thing;
	else
		nthing = thing;

	if (z->point)
		sprintf(nthing, "%d:%d/%d.%d", z->zone, z->net, z->node, z->point);
	else
		sprintf(nthing, "%d:%d/%d", z->zone, z->net, z->node);

	return nthing;
}

void TZnnp::NodeToStr(char *thing, znnp *z, znnp *lastz)
{
	if (lastz != NULL)
	{
		if (lastz->net == z->net && lastz->zone == z->zone)
			sprintf(thing, "%d", z->node);
		else
			sprintf(thing, "%d/%d", z->net, z->node);
	}
	else
		sprintf(thing, "%d/%d", z->net, z->node);
}

word TZnnp::OurNet(word z)
{
	int	n = 0;

	while (cfg->address[n].zone > 0 && n < 15)
	{
		if (cfg->address[n].zone == z)
			return cfg->address[n].net;
		n++;
	}

	return cfg->address[0].net;
}

word TZnnp::OurNode(word z)
{
	int	n = 0;

	while (cfg->address[n].zone > 0 && n < 15)
	{
		if (cfg->address[n].zone == z)
			return cfg->address[n].node;
		n++;
	}

	return cfg->address[0].node;
}

word TZnnp::OurPoint(word z)
{
	int	n = 0;

	while (cfg->address[n].zone > 0 && n < 15)
	{
		if (cfg->address[n].zone == z)
			return cfg->address[n].point;
		n++;
	}

	return cfg->address[0].point;
}

word TZnnp::OurZone(word z)
{
	int	n = 0;

	while (cfg->address[n].zone > 0 && n < 15)
	{
		if (cfg->address[n].zone == z)
			return z;
		n++;
	}


	return cfg->address[0].zone;
}

znnp *TZnnp::OurZnnp(word z)
{
	int 	n = 0;

	while (cfg->address[n].zone > 0 && n < 15)
	{
		if (cfg->address[n].zone == z)
			return &cfg->address[n];
		n++;
	}

	return &cfg->address[0];
}


void TZnnp::PrintAddr(znnp *a)
{
	cprintf("%d:%d/%d.%d\r\n",
		a->zone, a->net, a->node, a->point);
}

int TZnnp::IsOurAddr(znnp *z)
{
	int lp;

	for (lp=0; lp<15; lp++)
		if (cfg->address[lp] == *z)
			return 1;
	return 0;
}


int TZnnp::IsValidAddr(znnp *t)
{
	if (t->zone == 0 || t->net == 0)
		return 0;
	return 1;
}





// TLog

void TLog::log(o_loglevel min, char ch, char *msg, ...)
{
	char		*buf = new char[120];
	va_list 	ap;
	int		n;

	va_start(ap, msg);
	vsprintf(buf, msg, ap);

	if (cfg->loglevel >= min)
		log(ch, buf);

	va_end(ap);

	delete buf;
}

void TLog::log(char ch, char *msg, ...)
{
	struct 	tm 	*time_now;
	time_t 	secs_now;
	va_list	ap;
	FILE	*fptr;

	char	*bf = new char[40];
	char	*buf = new char[120];


	va_start(ap, msg);
	vsprintf(buf, msg, ap);
	va_end(ap);

	time(&secs_now);
	time_now = localtime(&secs_now);

	fptr = fopen(cfg->logfile, "a");
	if (fptr == NULL)
	{
		cprintf("    FATAL ERROR : Unable to open log file for output.\r\n");
		sleep(1);
		delete bf; delete buf;
		return;
	}

	if (ch == ' ' && !*buf)
		fprintf(fptr, "\n");
	else
	{
		strftime(bf, 40, "%d %b %H:%M:%S", time_now);
		fprintf(fptr, "%c %s CM   %s\n", ch, bf, buf);
	}
	fclose(fptr);

	delete bf;
	delete buf;
}

void TLog::elog(char *prg, char ch, char *msg, ...)
{
	struct 	tm 	*time_now;
	time_t 	secs_now;
	char	*bf = new char[40], *buf = new char[120];
	va_list	ap;
	FILE	*fptr;

	va_start(ap, msg);
	vsprintf(buf, msg, ap);
	va_end(ap);

	time(&secs_now);
	time_now = localtime(&secs_now);

	fptr = fopen(cfg->logfile, "a");
	strftime(bf, 40, "%d %b %H:%M:%S", time_now);
	fprintf(fptr, "%c %s %-4s %s\n", ch, bf, prg, buf);
	fclose(fptr);

	delete buf;
	delete bf;
}

void TLog::error(char *msg, ...)
{
	char		*buf = new char[120];
	va_list 	ap;
	int		n;

	va_start(ap, msg);
	vsprintf(buf, msg, ap);

	cprintf("  ! %s\r\n", buf);

	log('!', buf);
	va_end(ap);

	delete buf;
}

void TLog::baderror(char *msg, ...)
{
	char		*buf = new char[120];
	va_list 	ap;


	va_start(ap, msg);
	vsprintf(buf, msg, ap);

	cprintf("\r\n  ! %s", buf);
	cprintf("\r\n      REPORT THIS ERROR TO THE AUTHOR AS SOON AS POSSIBLE.\r\n");
	log('', buf);
	log('', "REPORT THIS ERROR TO AUTHOR AS SOON AS POSSIBLE!");
	va_end(ap);

	delete buf;
	Sys.bye(250);
}





// TStats

TStats::TStats(void)
{
	if (!access(FUtil.CMPath("STATS.CM"), 0))
	{
		statptr = fopen(FUtil.CMPath("STATS.CM"), "r+b");
		fread(&MainStats, sizeof(_mainstats), 1, statptr);
	}
	else
	{
		statptr = fopen(FUtil.CMPath("STATS.CM"), "w+b");
		memset(&MainStats, 0, sizeof(_mainstats));
		MainStats.FirstTime = time(0);
		fwrite(&MainStats, sizeof(_mainstats), 1, statptr);
	}
}

TStats::~TStats(void)
{
	fseek(statptr, 0L, SEEK_SET);
	fwrite(&MainStats, sizeof(_mainstats), 1, statptr);
	fclose(statptr);
}

void TStats::ReadStats(sysznnp *z, _nodestats *n)
{
	if (*z == n->sz)
		return;

	fseek(statptr, sizeof(_mainstats), SEEK_SET);

	while (*z != n->sz && !feof(statptr))
		fread(n, sizeof(_nodestats), 1, statptr);

	if (*z != n->sz)
	{
		memset(n, 0, sizeof(_nodestats));
		memcpy(&n->sz, z, sizeof(sysznnp));
		n->first_time = time(0);
		fseek(statptr, 0L, SEEK_END);
		fwrite(n, sizeof(_nodestats), 1, statptr);
	}
}

void TStats::WriteStats(_nodestats *n)
{
	long 	te;
	struct _nodestats t;

	if (n->sz == LastZoneWritten)
		fseek(statptr, LastZonePos, SEEK_SET);
	else
	{
		fseek(statptr, sizeof(_mainstats), SEEK_SET);
		te = sizeof(_mainstats);
		while (!feof(statptr))
		{
			fread(&t, sizeof(t), 1, statptr);
			if (n->sz == t.sz)
				break;

			te+= sizeof(_nodestats);
		}

		fseek(statptr, te, SEEK_SET);
	}

	fwrite(n, sizeof(_nodestats), 1, statptr);
}




// TFUtil class

char *TFUtil::FileOnly(char *s)
{
	static	char	blah[50], *point;

	strcpy(blah, s);

	point = strrchr(blah, '\\');
	if (point == NULL)
		return (char *)blah;
	point++;
	return (char *)point;
}

int TFUtil::CfgMakePath(char *s, char *name, int compulsory)
{
	if (!compulsory && !*s)
		return 0;

	if (!*s)
	{
		Log->error("[S101] Keyword %s must be specified in configuration file!", name);
		return 1;
	}

	SUtil.AddSlash(s);
	if (MakePath(s))
	{
		Log->error("[S102] Unable to create path specified by keyword %s", name);
		return 1;
	}

	return 0;
}

int TFUtil::CopyFile(char *source, char *dest)
{
	FILE	*s, *d;
	size_t	n;
	unsigned	char    *buf;

	if (coreleft() < 32768L)
	{
		Log->error("Unable to copy file %s to file %s", source, dest);
		return NO_MEM;
	}

	s = fopen(source, "rb");
	if (s == NULL)
		return FAILURE;

	d = fopen(dest, "wb");
	if (d == NULL)
	{
		fclose(s);
		return FAILURE;
	}

	buf = new char[20002];
	if (buf == NULL)
		return NO_MEM;

	do
	{
		n = fread(buf, 1, 20000, s);
		fwrite(buf, 1, n, d);
	}
	while (n == 20000);

	delete buf;

	fclose(s);
	fclose(d);

	return OK;
}

int TFUtil::MakePath(char *paths)
{
	char	path[180], *point, thing[180];

	strcpy(path, paths);
	if (path[strlen(path)-1] == '\\')
		path[strlen(path)-1] = 0;

	if (!*path || (strlen(path) == 2 && path[1] == ':'))
		return 0;

	if (access(path, 0))
	{
		if (mkdir(path))
		{
			strcpy(thing, path);
			point = strrchr(thing, '\\');
			if (point == NULL)
				return 1;
			*point = 0;
			if (mkdir(thing))
				return 1;
			if (mkdir(path))
				return 1;
		}
	}
	return 0;
}

int TFUtil::RenameToBA(char *file)
{
	char	thingy[60];
	int	n;

	strcpy(thingy, file);
	n = strlen(thingy);
	thingy[n-3] = 'B';
	thingy[n-2] = 'A';
	while (rename(file, thingy))
	{
		thingy[n-2]++;
		if (thingy[n-2] == 'Z')
		{
			Log->error("Unable to rename %s as .BAD!", file);
			return 255;
		}
	}
	return OK;
}


int TFUtil::RenameToXXX(char *file, char *ext)
{
	char	*thingy = new char[2+strlen(file)];
	int	n;

	strcpy(thingy, file);
	n = strlen(thingy);
	thingy[n-3] = ext[0];
	thingy[n-2] = ext[1];
	thingy[n-1] = ext[2];
	while (rename(file, thingy))
	{
		thingy[n-1]++;
		if (thingy[n-1] == 'Z')
		{
			delete thingy;
			return FAILURE;
		}
	}
	delete thingy;
	return OK;
}

char *TFUtil::CMPath(char *s)
{
	static char	ss[80];

	if (*cfg->cmpath)
	{
		char *t = new char[strlen(s)+2], *p;

		p = strrchr(s, '\\');
		if (p != NULL)
			strcpy(t, ++p);
		else
			strcpy(t, s);
		sprintf(ss, "%s%s", cfg->cmpath, t);
		delete t;
	}
	else
		strcpy(ss, s);

	return ss;
}

word TFUtil::fngets(char *s, word n, FILE *fp)
{
	register    int     c = 1;
	register    char    *P;
	static	int	brakon = 0;

	P = s;

	while (c && n && (c = getc(fp)) != EOF)
	{
		*P = c;
		if (c == ')')
			brakon = 0;
		if (brakon)
		{
			LastBracket[28-brakon] = c;
			brakon--;
		}
		if (c == '(')
		{
			memset(LastBracket, 0, 30);
			brakon = 28;
		}

		if (c != '\n' && c != '\x7f')
			P++, n--;
	}

	if (P == s || c == EOF)
		return 0;
	if (!n)
		return 65535;

	*P = 0;
	return (ferror(fp)) ? 0 : P-s;
}

char *TFUtil::frgets(char *s, word n, FILE *fp)
{
	register    int    c = 0;
	register    char    *P;

	P = s;

	while ('\r' != c && --n > 0  &&  (c = getc(fp)) != EOF)  *P++ = c;

        if (EOF == c && P == s)  return( NULL );
	*P = 0;
        return (ferror (fp)) ? NULL : s;
}





//  TUtil class

void TUtil::BaseTo36(unsigned b, char *b26)
{
	unsigned	k;
	char		tab[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	b26[3] = 0;
	
	k = b/(36*36);
	b26[0] = tab[k];
	b-= k * 36 * 36;

	k = b/36;
	b26[1] = tab[k];
	b-= k * 36;
	b26[2] = tab[b];
	
}

word TUtil::GetDate(void)
{
	return (word)(time(0) / 20864L);
}

ulong TUtil::Crc32(char *s)
{
	ulong 	a = 0xffffffffL;
	int	lp;

	for (lp=0; lp<strlen(s); lp++)
		a = UPDC32(s[lp], a);

	return a;
}

ulong TUtil::Crc32(void *s, word len)
{
	ulong 	a = 0xffffffffL;
	int	lp;

	for (lp=0; lp<len; lp++)
		a = UPDC32( ((char *)s)[lp], a );

	return a;
}

int WildCardMatch(const char *str, const char *wildstr)
{
	const	char	*point, *p;

	point = str;
	p = wildstr;

	while (*p)
	{
		if (*p == '*')
			return 1;
		if (*p == '?')
		{
			if (*point)
				point++;
			p++;
			continue;
		}
		if (toupper(*p) != toupper(*point))
			return 0;
		if (*point)
			point++;
		p++;
	}

	return (*point == 0);
}
