#ifndef _DEFS_H
#define _DEFS_H

#include <mem.h>
#include <string.h>

typedef unsigned int word;
typedef unsigned char byte;
typedef unsigned long ulong;
typedef unsigned char bool;


#define db cprintf("DEBUG:  at line %d in file "__FILE__"\r\n", __LINE__)

#define memassert(x) { if ((x) == NULL) { Log->error("Out of memory - unable to continue ("__FILE__", %d)", __LINE__); Sys.bye(4); } }

#define sosz sizeof(znnp)



class znnp
{
  public:
	word	zone, net, node, point;
/*
	znnp(void) { zone = net = node = point = 0; }
	znnp(word z, word ne, word no, word p) :
		zone(z), net(ne), node(no), point(p) {}
*/
	int 	operator==(const znnp &r) const;
	int		operator!=(const znnp &r) const { return !(*this==r); }
	int		equiv(const znnp &r) const;
};


enum o_fi { DFidoNet, DInternet };

class sysznnp
{
  public:

	o_fi	t;

	union
	{
		znnp	z;
		char	s[10];
	};

	sysznnp(void) { memset(this, 0, sizeof(sysznnp)); }
	sysznnp(const znnp &r) : t(DFidoNet), z(r) 	{};
	sysznnp(const char *r) : t(DInternet) 		{ strcpy(s, r); };


	int operator==(const sysznnp &r) const;
	int operator==(const znnp &r) const;
	int operator==(const char *r) const;

	int	operator!=(const sysznnp &r) const { return !(*this==r); }

	int	equiv(const sysznnp &r) const;
	int equiv(const znnp &r) const;
	int equiv(const char *r) const;

	o_fi 	GetType() 		{ return t; }
};



#endif
