#ifndef PKTDEF_H
#define PKTDEF_H

#include "defs.h"
#include "cfgdef.h"

static 	const  word
		Priv = 1,
		Crash = 2,
		Recd = 4,
		Sent = 8,
		FileAttached = 16,
		InTransit = 32,
		Orphan = 64,
		KillSent = 128,
		Local = 256,
		Hold = 512,
		Unused = 1024,		/* used for kfs in flags */
		FileRequest = 2048,
		ReturnReceiptRequest = 4096,
		IsReturnReceipt = 8192,
		AuditRequest = 16384,
		FileUpdateReq = 32768;



struct _pkthdr
{
	word	orignode;
	word	destnode;
	word	year;
	word	month;
	word	day;
	word	hour;
	word	minute;
	word	second;
	word	baud;
	word	ident;		// must equal 2
	word	orignet;
	word	destnet;
	byte	productcode_l;
	byte	majrevision;
	char	password[8];
	word	origzone_old;
	word	destzone_old;
	word	auxnet;
	word	cwval;
	byte	productcode_h;
	byte	minrevision;
	word	cw;
	word	origzone;
	word	destzone;
	word	origpoint;
	word	destpoint;
	byte	prodspec[4];
};


struct _msghdr
{
	word	ident;
	word	orignode;
	word	destnode;
	word	orignet;
	word	destnet;
	word	attrib;
	word	cost;
};

struct _netmail
{
	char 	fromuser[36];
	char	touser[36];
	char	subject[72];
	char	datetime[20];
	word	timesread;
	word	destnode;
	word	orignode;
	word	cost;
	word	orignet;
	word	destnet;
	byte	fill[8];
	word	replyto;
	word	attrib;
	word	nextreply;
};



#endif

