#include <stdio.h>
#include <io.h>
#include <alloc.h>

#include "p:\cm\cdefs.h"


FILE	*areafile, *linkfile;

DAreaIdx	*index;
long		nindex;

const int UseTag = 1;

void Scan(int pos)
{
	DAreaCfg 	da;

	fseek(areafile, pos*sizeof(DAreaCfg), SEEK_SET);
	fread(&da, sizeof(da), 1, areafile);

	if (UseTag && index[pos].TLeft)
		Scan(index[pos].TLeft);
	if (!UseTag && index[pos].SLeft)
		Scan(index[pos].SLeft);

	printf("tag = %-30s slarea = %-10s\n", da.Tag, da.SLArea);

	if (UseTag && index[pos].TRight)
		Scan(index[pos].TRight);
	if (!UseTag && index[pos].SRight)
		Scan(index[pos].SRight);
}


void main(void)
{
	areafile = fopen("area.cm", "rb");
	if (areafile == NULL)
	{
		puts(" * Error: Can't open AREA.CM.");
		return;
	}

	linkfile = fopen("arealink.cm", "rb");
	if (linkfile == NULL)
	{
		puts(" * Error: Can't open AREALINK.CM.");
		fclose(areafile);
		return;
	}

	nindex = filelength(fileno(areafile)) / sizeof(DAreaCfg);
	index = (DAreaIdx *)farcalloc(nindex, sizeof(DAreaIdx));

	fread(index, sizeof(DAreaIdx), nindex, linkfile);

	if (UseTag)
		Scan(index[0].TRight);
	else
		Scan(index[0].SRight);

	fclose(areafile);
	fclose(linkfile);

	farfree(index);
}
