
uses crt, filedef, sublist, general, defs, message, block, strings, members;

var ch : char;


procedure export(s : string);
var
	p 		: setupptr;
	fptr 	: file;
	tptr	: text;
	lenout	: longint;
	result	: longint;
	header	: headertype;
	head	: headertype;
	msg		: msgptr;
	lp		: integer;
	headpos : longint;
	ss		: string;

	cmhdr	: _cmhdr;
	cmmsg	: _msg;


  procedure wmr(n : longint);
  begin
	readmember(member, n);
	if (member.leaf.left <> 0) then
	begin
		wmr(member.leaf.left);
		readmember(member, n);
	end;

	writeln(tptr, member.name);

	if (member.leaf.right<> 0) then
		wmr(member.leaf.right);
  end;


begin
	if (sublistinit(subboards, '') = false) then
	begin
		writeln('Can''t open the subboard list.  Aborting.');
		exit;
	end;

	upstr(s);
	stripspaces(s);

	p := templistindex(s, subboards);
	if (p = Nil) or (p^.name <> s) then
	begin
		writeln('Unable to open subboard ',s,'.  Aborting.');
		exit;
	end;

	if opensub(s, mainsub, allfiles) = false then
	begin
		writeln('Unable to open subboard ',s,'.  Aborting.');
		exit;
	end;

	assign(tptr, s+'.MEM');
	rewrite(tptr);

	wmr(memberfileroot);

	close(tptr);

	assign(fptr, s+'.CMI');
	{$I-} reset(fptr, 1); {$I+}
	if (ioresult <> 0) then
	begin
		rewrite(fptr, 1);
		fillchar(cmhdr, sizeof(cmhdr), 0);
		tonts(s, cmhdr.slarea);
		cmhdr.id[0] := cmiddef[0];
		cmhdr.id[1] := cmiddef[1];
		cmhdr.id[2] := cmiddef[2];
		cmhdr.id[3] := cmiddef[3];
		cmhdr.id[4] := cmiddef[4];
		cmhdr.id[5] := cmiddef[5];

		blockwrite(fptr, cmhdr, sizeof(cmhdr));
		close(fptr);
		{$I-} reset(fptr, 1); {$I+}
		if ioresult <> 0 then
		begin
			writeln('   ! Fatal - cannot open ',s,'.CMI for reading/writing.');
			exit;
		end;
	end;

	seek(fptr, filesize(fptr));


	result := findheader(header, seq, mainsub.subinfo.firstmsg, 0);
	while (result > 0) do
	begin
		fillchar(cmmsg, sizeof(cmmsg), 0);

		tonts('CM1', cmmsg.id);
		cmmsg.noprocessing := 1;
		cmmsg.headerattached := 1;

		case ch of
			'A':	cmmsg.notossing := 1;
			'B':	cmmsg.noimport := 1;
		end;

		headpos := filepos(fptr);
		blockwrite(fptr, cmmsg, sizeof(cmmsg));

		unpackmsg(header.txt, msg, true);

		move(header, head, sizeof(header));
		{ sizeof(header) = 256 }

		with head do
		begin
			id[seq] := 0;
			id[uid] := 0;
			next[seq] := 0;
			next[uid] := 0;
			txt := 0;
			lastseq := 0;
			nextseq := 0;
			lastthread := 0;
			nextthread := 0;
			topthread := 0;
			lastreply := 0;
			replyto := 0;
			lastmail := 0;
			nextmail := 0;
			nextseqrec := 0;
			nextmailrec := 0;
		end;

		blockwrite(fptr, head, sizeof(head));

		lenout := 0;

		for lp := 1 to msg^.msglen do
		begin
			ss := msgline(msg, lp);

			if (ss[length(ss)] = '_') then
				delete(ss, length(ss), 1)
			else
				ss := ss + #13;

			blockwrite(fptr, ss[1], length(ss));
			inc(lenout, length(ss));
		end;

		disposemsg(msg);

		seek(fptr, headpos);
		cmmsg.size := lenout;
		blockwrite(fptr, cmmsg, sizeof(cmmsg));
		seek(fptr, filesize(fptr));

		result := findheader(header, seq, header.nextseq, 0);
	end;

	close(fptr);
	closesub(mainsub);
end;


var s : string;

begin
	if not openfiles([CONFIGF, NODESF]) then
	begin
		writeln('Can''t open Searchlight configuration files!  Aborting.');
		halt;
	end;

	writeln(#10'Export for CatMail v1.0;  Copyright (C)1996 LastByte Software.');
	writeln;
	writeln('This program will export an ENTIRE message base to .CMI format.  This is');
	writeln('useful for two reasons:');
	writeln('  a) If your message base corrupts and you want to start again.');
	writeln('  b) If you want to export all messages to your downlinks.');
	writeln;
	write('Which one will you use it for?  Press [x] to quit: ');

	repeat
	 ch := upcase(readkey);
	until (ch in ['A','B','X']);

	writeln(ch,#10);

	if (ch = 'X') then
	begin
		writeln('Okay!');
		exit;
	end;

	write('Enter the subboard name to export: ');
	readln(s);
	if (s = '') then
		exit;

	write(#10'Exporting... ');

	export(s);

	closeallfiles;

	writeln('done!');
end.