#include <io.h>
#include <stdio.h>
#include <string.h>

#include "p:\cm\cfgdef.h"
#include "p:\cm\id.h"


int main(int argc, char *argv[])
{
	printf("\nFixCMI for CatMail v0.7x\nCopyright 1998 LastByte Software.\n\n");

	if (argc != 2)
	{
		printf("Usage:  FIXCMI.EXE [cmifile.cmi]\n");
		return 1;
	}

	if (access(argv[1], 0))
	{
		printf("Unable to open CMI file %s\n", argv[1]);
		return 2;
	}

	FILE *fptr = fopen(argv[1], "r+b");
	_cmhdr ch;
	_cmmsg cm;

	fread(&ch, sizeof(ch), 1, fptr);
	if (strcmp(ch.id, CMI_HDR_ID))
	{
		printf("File %s is an invalid or obsolete CMI file.\n", argv[1]);
		fclose(fptr);
		return 3;
	}

	long lastgood = 0;

	while (1)
	{
		if (fread(&cm, sizeof(cm), 1, fptr) == 0)
			break;

		if (strcmp(cm.id, CMI_MSG_ID))
		{
			printf("Grunged at position %ld\n", ftell(fptr)-sizeof(cm));
			printf("lastgood = %ld\n", lastgood);
			fclose(fptr);
			return 4;
		}

		lastgood = ftell(fptr)-sizeof(cm);

		fseek(fptr, cm.size, SEEK_CUR);
	}

	fclose(fptr);
	return 0;
}
