#include <io.h>
#include <ctype.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include "p:\cm\cfgdef.h"
#include "p:\cm\id.h"

FILE	*fptr;

int	noprint;
char	ch;

struct	_cmhdr	cmhdr;
struct	_cmmsg	cmmsg;
char	*buf, *point;

int 	lp, mn = 0;
int	hexmode = 0;

long	headstart, msgstart, scrstart;

void puthead(void);
void puthex(void);



void main(int argc, char *argv[])
{
	puts("\n=== ReadCMI for CatMail v0.7x  ================================================\n");

	if (argc != 2)
	{
		puts("  Usage: READCMI [cminame]");
		return;
	}

	buf = new char[32000];
	if (buf == NULL)
	{
		puts("  Error: No memory.");
		return;
	}

	strcpy(buf, argv[1]);
	if (!strchr(buf, '.'))
		strcat(buf, ".CMI");
	strupr(buf);

	fptr = fopen(buf, "rb");
	if (fptr == NULL)
	{
		printf("  Error: File %s not found.\n", buf);
		return;
	}

	fread(&cmhdr, sizeof(cmhdr), 1, fptr);
	printf("Reading file %s... ", buf);

	if (stricmp(cmhdr.id, CMI_HDR_ID))
	{
		printf("File is not a current CMI! (id=%s)\n", cmhdr.id);
		fclose(fptr);
		return;
	}

	printf("CMI file type %s\n", cmhdr.id);

	long fl = filelength(fileno(fptr));

	printf("\nTag name:           [%-40s]\n", cmhdr.tag);
	printf("Searchlight name:   [%-8s]\n", cmhdr.slarea);
	if (cmhdr.ImportedSL == -1)
		puts("Imported position:  [       ALL], [100%]");
	else
		printf("Imported position:  [%10ld], [%3d%%]\n", cmhdr.ImportedSL, cmhdr.ImportedSL*100/fl);

	if (cmhdr.TossedOut == -1)
		puts("Tossed position:    [       ALL], [100%]");
	else
		printf("Tossed position:    [%10ld], [%3d%%]\n", cmhdr.TossedOut, cmhdr.TossedOut*100/fl);

	printf("File size:          [%10ld]\n", fl);

	printf("\nPress [V] to view messages or [X] to quit... ");

	while (ch=toupper(getch()), ch!='V'&&ch!='X');
	printf("%c\n", ch);

	if (ch == 'X')
		return;

	while (!feof(fptr))
	{
		mn++;
		noprint = 0;
		headstart = ftell(fptr);
		if (fread(&cmmsg, sizeof(cmmsg), 1, fptr) == NULL)
			break;

		if (cmmsg.headerattached)
			fread(buf, 1, 256, fptr);

		msgstart = scrstart = ftell(fptr);

		puthead();

		if (hexmode)
			puthex();

		if (cmmsg.size > 30000)
		{
			printf("\nCan't read this in - too big.");
			fseek(fptr, cmmsg.size, SEEK_CUR);
			goto gi;
		}
		else
			fread(buf, 1, cmmsg.size, fptr);
		point = buf;

		if (!hexmode)
		{
			for (lp=0; lp<cmmsg.size; lp++)
			{
				if (*point == '\r')
					putchar('\n');
				else if (*point == 0)
					putchar('');
				else
					putchar(*point);

				if (wherey() == 25)
				{
					printf("\rPress space for continue, . for next, h for hex, esc to quit... ");
					ch = getch();
					if (ch == 27)
						return;
					if (ch == '.')
						goto reval;

					scrstart = ftell(fptr);
					puthead();
				}
				point++;
			}
		}
gi:
		ch = getch();
reval:
		switch (ch)
		{
		  case 0:
			getch();
			break;

		  case 27:
			return;

		  case 'h':
			hexmode = 1 - hexmode;
			break;

		  case 'j':
			gotoxy(1,25);
			printf("enter location to jump to: ");

			char s[100];
			long jl;
			gets(s);
			sscanf(s, "%ld", &jl);
			if (jl == 0)
				break;
			fseek(fptr, jl, SEEK_SET);
			break;
		}
	}

	fclose(fptr);

	delete buf;
}

void puthex(void)
{
	long	i, x;

	fseek(fptr, headstart, SEEK_SET);
	fread(buf, 1, sizeof(_cmmsg), fptr);

	for (x=0; x<sizeof(cmmsg); x++)
	{
		if (!(x % 16))
		{
			if (x)
			{
				for (i=x-16; i<x; i++)
					printf("%c", *(buf+i));
			}
			printf("\n%08lX  ", headstart+x);
		}
		printf("%02X ", *((unsigned char *)(&buf+x)));
	}
}




void puthead(void)
{
	clrscr();
	printf("datetime: %-34sMsg #: %d\nto: %-40sSize : %ld\nfrom: %-38sHdrSz: %ld\nsubject: %s\n",
		cmmsg.datetime, mn, cmmsg.touser, cmmsg.size, cmmsg.fromuser, cmmsg.ihdrsize, cmmsg.subject);
	printf("Last Origin: %d:%d/%d.%d  Initial Origin: %d:%d/%d.%d  Inet Origin: %s\n",
		cmmsg.orig.zone, cmmsg.orig.net, cmmsg.orig.node,
		cmmsg.orig.point, cmmsg.origin.zone, cmmsg.origin.net,
		cmmsg.origin.node, cmmsg.origin.point, cmmsg.orig_i);
	printf("[%c] UseNet         [%c] FileAttached   [%c] Header Attached\n",
		cmmsg.usenet?251:250, cmmsg.fileattach?251:250, cmmsg.headerattached?251:250);
	printf("[%c] No Importing   [%c] No Tossing     [%c] No processing\n",
		cmmsg.noimport?251:250, cmmsg.notossing?251:250, cmmsg.noprocessing?251:250);
	printf("msg hdr starts at: %ld [0x%lX], this screen starts at %ld [0x%lX]\n", msgstart, msgstart, scrstart, scrstart);

	printf("==========================================================================\n");
}

