#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>
#include "h:\cm\cfgdef.h"


struct	_mainstats	ms;
struct	_nodestats	ns;

void main(void)
{
	FILE *fptr;
	time_t	tmnt, t;
	struct	tm	*tmn;
	char	thing[120];
	int	hand;
	long	days;


	hand = open("stats.cnf", O_RDONLY|O_BINARY);
	if (hand == -1)
	{
		perror("Error opening stats.cnf");
		return;
	}

	fptr = fopen("stats.txt", "w");

	read(hand, &ms, sizeof(ms));

	t = time(&tmnt);
	tmn = localtime(&tmnt);
	strftime(thing, 80, "%d %b %y at %H:%M:%S", tmn);

	fprintf(fptr, "Statistics file from CatMail generated on %s\n", thing);
	fprintf(fptr, "============================================================================\n\n\n");

	days = (t-ms.first_time)/60/60/24;
	if (days < 1) days = 1;

	fprintf(fptr, "This system's statistics:\n");
	fprintf(fptr, "    Messages imported:            %9ld\n", ms.msg_imp);
	fprintf(fptr, "    Messages exported:            %9ld\n\n", ms.msg_exp);

	fprintf(fptr, "    Average imported / day:       %9ld\n", ms.msg_imp/days);
	fprintf(fptr, "    Average exported / day:       %9ld\n", ms.msg_exp/days);


	while (!eof(hand))
	{
		read(hand, &ns, sizeof(ns));

		days = (t-ns.first_time)/60/60/24;
		if (days < 1) days = 1;

		fprintf(fptr, "\n\nStatistics for node %d:%d/%d.%d:\n", ns.node.zone, ns.node.net, ns.node.node, ns.node.point);

		fprintf(fptr, "    Messages to node:             %9ld\n", ns.msg_to);
		fprintf(fptr, "    Messages from node:           %9ld\n", ns.msg_from);
		fprintf(fptr, "    Uncompressed bytes to node:   %9ldK\n", ns.k_to);
		fprintf(fptr, "    Uncompressed bytes from node: %9ldK\n", ns.k_from);
		fprintf(fptr, "    Duplicate messages:           %9ld\n\n", ns.dupes);

		fprintf(fptr, "    Avg msgs to node / day:       %9ld\n", ns.msg_to/days);
		fprintf(fptr, "    Avg msgs from node / day:     %9ld\n", ns.msg_from/days);
		fprintf(fptr, "    Avg bytes to node / day:      %9ldK\n", ns.k_to/days);
		fprintf(fptr, "    Avg bytes from node / day:    %9ldK\n", ns.k_from/days);
		fprintf(fptr, "    Avg duplicate msgs / week:    %9ld\n", ns.dupes/(days/7==0?1:days/7));
	}

	fclose(fptr);
	close(hand);

	puts("Done!");
}







